class _JediError(Exception):0
class InternalError(_JediError):'\n    This error might happen a subprocess is crashing. The reason for this is\n    usually broken C code in third party libraries. This is not a very common\n    thing and it is safe to use Jedi again. However using the same calls might\n    result in the same error again.\n    '
class WrongVersion(_JediError):"\n    This error is reserved for the future, shouldn't really be happening at the\n    moment.\n    "
class RefactoringError(_JediError):'\n    Refactorings can fail for various reasons. So if you work with refactorings\n    like :meth:`.Script.rename`, :meth:`.Script.inline`,\n    :meth:`.Script.extract_variable` and :meth:`.Script.extract_function`, make\n    sure to catch these. The descriptions in the errors are usually valuable\n    for end users.\n\n    A typical ``RefactoringError`` would tell the user that inlining is not\n    possible if no name is under the cursor.\n    '