_C=True
_B=False
_A=None
import os
from jedi.api import classes
from jedi.api.strings import StringName,get_quote_ending
from jedi.api.helpers import match
from jedi.inference.helpers import get_str_or_none
class PathName(StringName):api_type='path'
def complete_file_name(inference_state,module_context,start_leaf,quote,string,like_name,signatures_callback,code_lines,position,fuzzy):
	I=fuzzy;H=position;G=start_leaf;F=module_context;C=inference_state;A=string;J=len(os.path.basename(A));K=_get_string_additions(F,G)
	if A.startswith('~'):A=os.path.expanduser(A)
	if K is _A:return
	A=K+A;L=os.path.basename(A);A=os.path.dirname(A);D=signatures_callback(*H);E=D and all(A.full_name=='os.path.join'for A in D)
	if E:
		M=_add_os_path_join(F,G,D[0].bracket_start)
		if M is _A:E=_B
		else:A=M+A
	O=os.path.join(C.project.path,A)
	try:P=sorted(os.scandir(O),key=lambda e:e.name)
	except(FileNotFoundError,OSError):return
	Q=get_quote_ending(quote,code_lines,H)
	for N in P:
		B=N.name
		if match(B,L,fuzzy=I):
			if E or not N.is_dir():B+=Q
			else:B+=os.path.sep
			yield classes.Completion(C,PathName(C,B[len(L)-J:]),stack=_A,like_name_length=J,is_fuzzy=I)
def _get_string_additions(module_context,start_leaf):
	B=start_leaf
	def C():
		C=A.parent;B=_C
		for D in reversed(C.children[:C.children.index(A)]):
			if B:B=_B;yield D;continue
			if D!='+':break
			B=_C
	A=B.get_previous_leaf()
	if A!='+':return''
	D=module_context.create_context(B);return _add_strings(D,reversed(list(C())))
def _add_strings(context,nodes,add_slash=_B):
	A='';B=_C
	for E in nodes:
		C=context.infer_node(E)
		if len(C)!=1:return
		F,=C;D=get_str_or_none(F)
		if D is _A:return
		if not B and add_slash:A+=os.path.sep
		A+=D;B=_B
	return A
def _add_os_path_join(module_context,start_leaf,bracket_start):
	L='trailer';K='arglist';I='error_node';F=start_leaf
	def G(maybe_bracket,nodes):
		A=nodes
		if maybe_bracket.start_pos!=bracket_start:return
		if not A:return''
		B=module_context.create_context(A[0]);return _add_strings(B,A,add_slash=_C)or''
	if F.type=='error_leaf':
		M=F.parent;B=M.children.index(F)
		if B>0:
			H=M.children[B-1]
			if H.type==I and len(H.children)>=2:
				B=-2
				if H.children[-1].type==K:D=H.children[-1].children;B-=1
				else:D=[]
				return G(H.children[B+1],D[::2])
		return
	C=F
	while C.parent is not _A and C.parent.type not in(K,L,I):C=C.parent
	if C.get_first_leaf()is not F:return
	A=C.parent
	if A is _A:return
	B=A.children.index(C);D=A.children[:B]
	if A.type==K:
		E=A.parent
		if E.type==I:J=E.children.index(A);assert J>=2;assert E.children[J-1]=='(';return G(E.children[J-1],D[::2])
		elif E.type==L:return G(E.children[0],D[::2])
	elif A.type==L:return G(A.children[0],[])
	elif A.type==I:return G(D[-1],[])