'\nTo use Jedi completion in Python interpreter, add the following in your shell\nsetup (e.g., ``.bashrc``). This works only on Linux/Mac, because readline is\nnot available on Windows. If you still want Jedi autocompletion in your REPL,\njust use IPython instead::\n\n    export PYTHONSTARTUP="$(python -m jedi repl)"\n\nThen you will be able to use Jedi completer in your Python interpreter::\n\n    $ python\n    Python 3.9.2+ (default, Jul 20 2020, 22:15:08)\n    [GCC 4.6.1] on linux2\n    Type "help", "copyright", "credits" or "license" for more information.\n    >>> import os\n    >>> os.path.join(\'a\', \'b\').split().in<TAB>            # doctest: +SKIP\n    ..dex   ..sert\n\n'
import jedi.utils
from jedi import __version__ as __jedi_version__
print('REPL completion using Jedi %s'%__jedi_version__)
jedi.utils.setup_readline(fuzzy=False)
del jedi