_A=False
import os,time
from contextlib import contextmanager
from typing import Callable,Optional
_inited=_A
def _lazy_colorama_init():'\n    Lazily init colorama if necessary, not to screw up stdout if debugging is\n    not enabled.\n\n    This version of the function does nothing.\n    '
try:
	if os.name=='nt':raise ImportError
	else:
		from colorama import Fore,init,initialise
		def _lazy_colorama_init():
			'\n            Lazily init colorama if necessary, not to screw up stdout is\n            debug not enabled.\n\n            This version of the function does init colorama.\n            ';global _inited
			if not _inited:
				initialise.atexit_done=True
				try:init(strip=_A)
				except Exception:pass
			_inited=True
except ImportError:
	class Fore:RED='';GREEN='';YELLOW='';MAGENTA='';RESET='';BLUE=''
NOTICE=object()
WARNING=object()
SPEED=object()
enable_speed=_A
enable_warning=_A
enable_notice=_A
debug_function=None
_debug_indent=0
_start_time=time.time()
def reset_time():global _start_time,_debug_indent;_start_time=time.time();_debug_indent=0
def increase_indent(func):
	'Decorator for makin '
	def A(*A,**B):
		with increase_indent_cm():return func(*A,**B)
	return A
@contextmanager
def increase_indent_cm(title=None,color='MAGENTA'):
	B=color;A=title;global _debug_indent
	if A:dbg('Start: '+A,color=B)
	_debug_indent+=1
	try:yield
	finally:
		_debug_indent-=1
		if A:dbg('End: '+A,color=B)
def dbg(message,*B,color='GREEN'):
	' Looks at the stack, to see if a debug message should be printed. ';A=color;assert A
	if debug_function and enable_notice:C=' '*_debug_indent;_lazy_colorama_init();debug_function(A,C+'dbg: '+message%tuple(repr(A)for A in B))
def warning(message,*B,format=True):
	A=message
	if debug_function and enable_warning:
		C=' '*_debug_indent
		if format:A=A%tuple(repr(A)for A in B)
		debug_function('RED',C+'warning: '+A)
def speed(name):
	if debug_function and enable_speed:A=time.time();B=' '*_debug_indent;debug_function('YELLOW',B+'speed: '+'%s %s'%(name,A-_start_time))
def print_to_stdout(color,str_out):'\n    The default debug function that prints to standard out.\n\n    :param str color: A string that is an attribute of ``colorama.Fore``.\n    ';A=getattr(Fore,color);_lazy_colorama_init();print(A+str_out+Fore.RESET)