import os
from parso import file_io
class AbstractFolderIO:
	def __init__(A,path):A.path=path
	def get_base_name(A):raise NotImplementedError
	def list(A):raise NotImplementedError
	def get_file_io(A,name):raise NotImplementedError
	def get_parent_folder(A):raise NotImplementedError
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A.path)
class FolderIO(AbstractFolderIO):
	def get_base_name(A):return os.path.basename(A.path)
	def list(A):return os.listdir(A.path)
	def get_file_io(A,name):return FileIO(os.path.join(A.path,name))
	def get_parent_folder(A):return FolderIO(os.path.dirname(A.path))
	def walk(H):
		for(A,C,I)in os.walk(H.path):
			J=FolderIO(A);B=[FolderIO(os.path.join(A,B))for B in C];D=list(B);yield(J,D,[FileIO(os.path.join(A,B))for B in I]);E=iter(reversed(D));F=next(E,None);G=len(B)
			for K in reversed(B):
				G-=1
				if F is K:F=next(E,None)
				else:del C[G]
class FileIOFolderMixin:
	def get_parent_folder(A):return FolderIO(os.path.dirname(A.path))
class ZipFileIO(file_io.KnownContentFileIO,FileIOFolderMixin):
	'For .zip and .egg archives'
	def __init__(A,path,code,zip_path):super().__init__(path,code);A._zip_path=zip_path
	def get_last_modified(A):
		try:return os.path.getmtime(A._zip_path)
		except(FileNotFoundError,PermissionError,NotADirectoryError):return
class FileIO(file_io.FileIO,FileIOFolderMixin):0
class KnownContentFileIO(file_io.KnownContentFileIO,FileIOFolderMixin):0