from jedi.inference.compiled.value import CompiledValue,CompiledName,CompiledValueFilter,CompiledValueName,create_from_access_path
from jedi.inference.base_value import LazyValueWrapper
def builtin_from_name(inference_state,string):
	A=string;B=inference_state.builtins_module
	if A in('None','True','False'):D,=B.non_stub_value_set;C=next(D.get_filters())
	else:C=next(B.get_filters())
	E,=C.get(A);F,=E.infer();return F
class ExactValue(LazyValueWrapper):
	'\n    This class represents exact values, that makes operations like additions\n    and exact boolean values possible, while still being a "normal" stub.\n    '
	def __init__(A,compiled_value):B=compiled_value;A.inference_state=B.inference_state;A._compiled_value=B
	def __getattribute__(B,name):
		A=name
		if A in('get_safe_value','execute_operation','access_handle','negate','py__bool__','is_compiled'):return getattr(B._compiled_value,A)
		return super().__getattribute__(A)
	def _get_wrapped_value(A):B,=builtin_from_name(A.inference_state,A._compiled_value.name.string_name).execute_with_values();return B
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A._compiled_value)
def create_simple_object(inference_state,obj):'\n    Only allows creations of objects that are easily picklable across Python\n    versions.\n    ';B=inference_state;A=obj;assert type(A)in(int,float,str,bytes,slice,complex,bool),repr(A);C=create_from_access_path(B,B.compiled_subprocess.create_simple_object(A));return ExactValue(C)
def get_string_value_set(inference_state):return builtin_from_name(inference_state,'str').execute_with_values()
def load_module(inference_state,dotted_name,**D):
	B=dotted_name;A=inference_state
	if B.startswith('tensorflow.'):return
	C=A.compiled_subprocess.load_module(dotted_name=B,**D)
	if C is None:return
	return create_from_access_path(A,C)