_E='always'
_D='__module__'
_C=False
_B=True
_A=None
import inspect,types,traceback,sys,operator as op
from collections import namedtuple
import warnings,re,builtins,typing
from pathlib import Path
from typing import Optional,Tuple
from jedi.inference.compiled.getattr_static import getattr_static
ALLOWED_GETITEM_TYPES=str,list,tuple,bytes,bytearray,dict
MethodDescriptorType=type(str.replace)
NOT_CLASS_TYPES=types.BuiltinFunctionType,types.CodeType,types.FrameType,types.FunctionType,types.GeneratorType,types.GetSetDescriptorType,types.LambdaType,types.MemberDescriptorType,types.MethodType,types.ModuleType,types.TracebackType,MethodDescriptorType,types.MappingProxyType,types.SimpleNamespace,types.DynamicClassAttribute
MethodDescriptorType=type(str.replace)
WrapperDescriptorType=type(set.__iter__)
object_class_dict=type.__dict__['__dict__'].__get__(object)
ClassMethodDescriptorType=type(object_class_dict['__subclasshook__'])
_sentinel=object()
COMPARISON_OPERATORS={'==':op.eq,'!=':op.ne,'is':op.is_,'is not':op.is_not,'<':op.lt,'<=':op.le,'>':op.gt,'>=':op.ge}
_OPERATORS={'+':op.add,'-':op.sub}
_OPERATORS.update(COMPARISON_OPERATORS)
ALLOWED_DESCRIPTOR_ACCESS=types.FunctionType,types.GetSetDescriptorType,types.MemberDescriptorType,MethodDescriptorType,WrapperDescriptorType,ClassMethodDescriptorType,staticmethod,classmethod
def safe_getattr(obj,name,default=_sentinel):
	A=default
	try:B,C=getattr_static(obj,name)
	except AttributeError:
		if A is _sentinel:raise
		return A
	else:
		if isinstance(B,ALLOWED_DESCRIPTOR_ACCESS):return getattr(obj,name)
	return B
SignatureParam=namedtuple('SignatureParam','name has_default default default_string has_annotation annotation annotation_string kind_name')
def shorten_repr(func):
	def A(self):
		A=func(self)
		if len(A)>50:A=A[:50]+'..'
		return A
	return A
def create_access(inference_state,obj):return inference_state.compiled_subprocess.get_or_create_access_handle(obj)
def load_module(inference_state,dotted_name,sys_path):
	B=sys_path;A=dotted_name;C,sys.path=sys.path,B
	try:__import__(A)
	except ImportError:warnings.warn('Module %s not importable in path %s.'%(A,B),UserWarning,stacklevel=2);return
	except Exception:warnings.warn('Cannot import:\n%s'%traceback.format_exc(),UserWarning,stacklevel=2);return
	finally:sys.path=C
	D=sys.modules[A];return create_access_path(inference_state,D)
class AccessPath:
	def __init__(A,accesses):A.accesses=accesses
def create_access_path(inference_state,obj):A=create_access(inference_state,obj);return AccessPath(A.get_access_path_tuples())
def get_api_type(obj):
	A=obj
	if inspect.isclass(A):return'class'
	elif inspect.ismodule(A):return'module'
	elif inspect.isbuiltin(A)or inspect.ismethod(A)or inspect.ismethoddescriptor(A)or inspect.isfunction(A):return'function'
	return'instance'
class DirectObjectAccess:
	def __init__(A,inference_state,obj):A._inference_state=inference_state;A._obj=obj
	def __repr__(A):return'%s(%s)'%(A.__class__.__name__,A.get_repr())
	def _create_access(A,obj):return create_access(A._inference_state,obj)
	def _create_access_path(A,obj):return create_access_path(A._inference_state,obj)
	def py__bool__(A):return bool(A._obj)
	def py__file__(A):
		try:return Path(A._obj.__file__)
		except AttributeError:return
	def py__doc__(A):return inspect.getdoc(A._obj)or''
	def py__name__(A):
		if not _is_class_instance(A._obj)or inspect.ismethoddescriptor(A._obj):B=A._obj
		else:
			try:B=A._obj.__class__
			except AttributeError:return
		try:return B.__name__
		except AttributeError:return
	def py__mro__accesses(A):return tuple(A._create_access_path(B)for B in A._obj.__mro__[1:])
	def py__getitem__all_values(A):
		if isinstance(A._obj,dict):return[A._create_access_path(B)for B in A._obj.values()]
		if isinstance(A._obj,(list,tuple)):return[A._create_access_path(B)for B in A._obj]
		if A.is_instance():C=DirectObjectAccess(A._inference_state,A._obj.__class__);return C.py__getitem__all_values()
		try:D=A._obj.__getitem__
		except AttributeError:pass
		else:
			B=DirectObjectAccess(A._inference_state,D).get_return_annotation()
			if B is not _A:return[B]
	def py__simple_getitem__(A,index,*,safe=_B):
		if safe and type(A._obj)not in ALLOWED_GETITEM_TYPES:return
		return A._create_access_path(A._obj[index])
	def py__iter__list(A):
		try:D=A._obj.__iter__
		except AttributeError:return
		else:
			B=DirectObjectAccess(A._inference_state,D).get_return_annotation()
			if B is not _A:return[B]
		if type(A._obj)not in ALLOWED_GETITEM_TYPES:return[]
		C=[]
		for(E,F)in enumerate(A._obj):
			if E>20:break
			C.append(A._create_access_path(F))
		return C
	def py__class__(A):return A._create_access_path(A._obj.__class__)
	def py__bases__(A):return[A._create_access_path(B)for B in A._obj.__bases__]
	def py__path__(B):
		A=getattr(B._obj,'__path__',_A)
		if not isinstance(A,list)or not all(isinstance(A,str)for A in A):return
		return A
	@shorten_repr
	def get_repr(self):
		C='builtins';A=self
		if inspect.ismodule(A._obj):return repr(A._obj)
		if safe_getattr(A._obj,_D,default='')==C:return repr(A._obj)
		B=type(A._obj)
		if B==type:return type.__repr__(A._obj)
		if safe_getattr(B,_D,default='')==C:return repr(A._obj)
		return object.__repr__(A._obj)
	def is_class(A):return inspect.isclass(A._obj)
	def is_function(A):return inspect.isfunction(A._obj)or inspect.ismethod(A._obj)
	def is_module(A):return inspect.ismodule(A._obj)
	def is_instance(A):return _is_class_instance(A._obj)
	def ismethoddescriptor(A):return inspect.ismethoddescriptor(A._obj)
	def get_qualified_names(B):
		def C(obj):return getattr(obj,'__qualname__',getattr(obj,'__name__',_A))
		if B.is_module():return()
		A=C(B._obj)
		if A is _A:
			A=C(type(B._obj))
			if A is _A:return()
		return tuple(A.split('.'))
	def dir(A):return dir(A._obj)
	def has_iter(A):
		try:iter(A._obj);return _B
		except TypeError:return _C
	def is_allowed_getattr(B,name,safe=_B):
		try:A,C=getattr_static(B._obj,name)
		except AttributeError:
			if not safe:
				with warnings.catch_warnings(record=_B):
					warnings.simplefilter(_E)
					try:return hasattr(B._obj,name),_C,_A
					except Exception:pass
			return _C,_C,_A
		else:
			if C and type(A)not in ALLOWED_DESCRIPTOR_ACCESS:
				if isinstance(A,property):
					if hasattr(A.fget,'__annotations__'):D=DirectObjectAccess(B._inference_state,A.fget);return _B,_B,D.get_return_annotation()
				return _B,_B,_A
		return _B,_C,_A
	def getattr_paths(C,name,default=_sentinel):
		D=default
		try:
			with warnings.catch_warnings(record=_B):warnings.simplefilter(_E);B=getattr(C._obj,name)
		except Exception as F:
			if D is _sentinel:
				if isinstance(F,AttributeError):raise
				raise AttributeError
			B=D
		E=C._create_access(B)
		if inspect.ismodule(B):return[E]
		try:A=B.__module__
		except AttributeError:pass
		else:
			if A is not _A and isinstance(A,str):
				try:__import__(A)
				except ImportError:pass
		A=inspect.getmodule(B)
		if A is _A:
			A=inspect.getmodule(type(B))
			if A is _A:A=builtins
		return[C._create_access(A),E]
	def get_safe_value(A):
		if type(A._obj)in(bool,bytes,float,int,str,slice)or A._obj is _A:return A._obj
		raise ValueError('Object is type %s and not simple'%type(A._obj))
	def get_api_type(A):return get_api_type(A._obj)
	def get_array_type(A):
		if isinstance(A._obj,dict):return'dict'
	def get_key_paths(A):
		def B():
			for(B,C)in enumerate(A._obj.keys()):
				if B>50:break
				yield C
		return[A._create_access_path(B)for B in B()]
	def get_access_path_tuples(A):B=[create_access(A._inference_state,B)for B in A._get_objects_path()];return[(A.py__name__(),A)for A in B]
	def _get_objects_path(C):
		def A():
			A=C._obj;yield A
			try:A=A.__objclass__
			except AttributeError:pass
			else:yield A
			try:B=A.__module__
			except AttributeError:
				if not inspect.ismodule(A):yield builtins
			else:
				if B is _A:yield builtins
				else:
					try:yield sys.modules[B]
					except KeyError:yield builtins
		return list(reversed(list(A())))
	def execute_operation(A,other_access_handle,operator):B=other_access_handle.access;C=_OPERATORS[operator];return A._create_access_path(C(A._obj,B._obj))
	def get_annotation_name_and_args(A):
		'\n        Returns Tuple[Optional[str], Tuple[AccessPath, ...]]\n        ';C=_A;B=()
		if safe_getattr(A._obj,_D,default='')=='typing':
			D=re.match('typing.(\\w+)\\[',repr(A._obj))
			if D is not _A:
				C=D.group(1);import typing as E
				if sys.version_info>=(3,8):B=E.get_args(A._obj)
				else:B=safe_getattr(A._obj,'__args__',default=_A)
		return C,tuple(A._create_access_path(B)for B in B)
	def needs_type_completions(A):return inspect.isclass(A._obj)and A._obj!=type
	def _annotation_to_str(A,annotation):return inspect.formatannotation(annotation)
	def get_signature_params(B):return[SignatureParam(name=A.name,has_default=A.default is not A.empty,default=B._create_access_path(A.default),default_string=repr(A.default),has_annotation=A.annotation is not A.empty,annotation=B._create_access_path(A.annotation),annotation_string=B._annotation_to_str(A.annotation),kind_name=str(A.kind))for A in B._get_signature().parameters.values()]
	def _get_signature(A):
		B=A._obj
		try:return inspect.signature(B)
		except(RuntimeError,TypeError):raise ValueError
	def get_return_annotation(A):
		C='return'
		try:B=A._obj.__annotations__.get(C)
		except AttributeError:return
		if B is _A:return
		try:B=typing.get_type_hints(A._obj).get(C)
		except Exception:pass
		return A._create_access_path(B)
	def negate(A):return A._create_access_path(-A._obj)
	def get_dir_infos(A):'\n        Used to return a couple of infos that are needed when accessing the sub\n        objects of an objects\n        ';B=dict((B,A.is_allowed_getattr(B))for B in A.dir());return A.needs_type_completions(),B
def _is_class_instance(obj):
	'Like inspect.* methods.'
	try:A=obj.__class__
	except AttributeError:return _C
	else:return A!=type and isinstance(A,type)and not issubclass(A,NOT_CLASS_TYPES)