_A=None
from jedi.inference.base_value import ValueWrapper
from jedi.inference.value.module import ModuleValue
from jedi.inference.filters import ParserTreeFilter
from jedi.inference.names import StubName,StubModuleName
from jedi.inference.gradual.typing import TypingModuleFilterWrapper
from jedi.inference.context import ModuleContext
class StubModuleValue(ModuleValue):
	_module_name_class=StubModuleName
	def __init__(A,non_stub_value_set,*B,**C):super().__init__(*B,**C);A.non_stub_value_set=non_stub_value_set
	def is_stub(A):return True
	def sub_modules_dict(B):
		"\n        We have to overwrite this, because it's possible to have stubs that\n        don't have code for all the child modules. At the time of writing this\n        there are for example no stubs for `json.tool`.\n        ";A={}
		for C in B.non_stub_value_set:
			try:D=C.sub_modules_dict
			except AttributeError:pass
			else:A.update(D())
		A.update(super().sub_modules_dict());return A
	def _get_stub_filters(A,origin_scope):return[StubFilter(parent_context=A.as_context(),origin_scope=origin_scope)]+list(A.iter_star_filters())
	def get_filters(C,origin_scope=_A):A=origin_scope;B=super().get_filters(A);next(B,_A);D=C._get_stub_filters(origin_scope=A);yield from D;yield from B
	def _as_context(A):return StubModuleContext(A)
class StubModuleContext(ModuleContext):
	def get_filters(A,until_position=_A,origin_scope=_A):return super().get_filters(origin_scope=origin_scope)
class TypingModuleWrapper(StubModuleValue):
	def get_filters(E,*C,**D):A=super().get_filters(*C,**D);B=next(A,_A);assert B is not _A;yield TypingModuleFilterWrapper(B);yield from A
	def _as_context(A):return TypingModuleContext(A)
class TypingModuleContext(ModuleContext):
	def get_filters(D,*B,**C):A=super().get_filters(*B,**C);yield TypingModuleFilterWrapper(next(A,_A));yield from A
class StubFilter(ParserTreeFilter):
	name_class=StubName
	def _is_name_reachable(E,name):
		B=False;A=name
		if not super()._is_name_reachable(A):return B
		D=A.get_definition()
		if D is _A:return B
		if D.type in('import_from','import_name'):
			if A.parent.type not in('import_as_name','dotted_as_name'):return B
		C=A.value
		if C.startswith('_')and not(C.startswith('__')and C.endswith('__')):return B
		return True
class VersionInfo(ValueWrapper):0