from __future__ import annotations
_I='UNIX_TIMESTAMP'
_H='VARCHAR'
_G='TO_CHAR'
_F='TO_TIMESTAMP'
_E='TIMESTAMP'
_D='INTEGER'
_C='%Y'
_B='this'
_A=False
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,datestrtodate_sql,build_formatted_time,no_trycast_sql,rename_func,str_position_sql,timestrtotime_sql
from sqlglot.dialects.mysql import date_add_sql
from sqlglot.transforms import preprocess,move_schema_columns_to_partitioned_by
def _str_to_date(self,expression):
	B=expression;A=self;C=A.sql(B,_B);D=A.format_time(B)
	if D==Drill.DATE_FORMAT:return A.sql(exp.cast(C,exp.DataType.Type.DATE))
	return A.func('TO_DATE',C,D)
class Drill(Dialect):
	NORMALIZE_FUNCTIONS:bool|str=_A;NULL_ORDERING='nulls_are_last';DATE_FORMAT="'yyyy-MM-dd'";DATEINT_FORMAT="'yyyyMMdd'";TIME_FORMAT="'yyyy-MM-dd HH:mm:ss'";SUPPORTS_USER_DEFINED_TYPES=_A;SUPPORTS_SEMI_ANTI_JOIN=_A;TYPED_DIVISION=True;CONCAT_COALESCE=True;TIME_MAPPING={'y':_C,'Y':_C,'YYYY':_C,'yyyy':_C,'YY':'%y','yy':'%y','MMMM':'%B','MMM':'%b','MM':'%m','M':'%-m','dd':'%d','d':'%-d','HH':'%H','H':'%-H','hh':'%I','h':'%-I','mm':'%M','m':'%-M','ss':'%S','s':'%-S','SSSSSS':'%f','a':'%p','DD':'%j','D':'%-j','E':'%a','EE':'%a','EEE':'%a','EEEE':'%A',"''T''":'T'}
	class Tokenizer(tokens.Tokenizer):IDENTIFIERS=['`'];STRING_ESCAPES=['\\'];KEYWORDS=tokens.Tokenizer.KEYWORDS.copy();KEYWORDS.pop('/*+')
	class Parser(parser.Parser):STRICT_CAST=_A;FUNCTIONS={**parser.Parser.FUNCTIONS,_F:exp.TimeStrToTime.from_arg_list,_G:build_formatted_time(exp.TimeToStr,'drill')};LOG_DEFAULTS_TO_LN=True
	class Generator(generator.Generator):JOIN_HINTS=_A;TABLE_HINTS=_A;QUERY_HINTS=_A;NVL2_SUPPORTED=_A;LAST_DAY_SUPPORTS_DATE_PART=_A;SUPPORTS_CREATE_TABLE_LIKE=_A;TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.INT:_D,exp.DataType.Type.SMALLINT:_D,exp.DataType.Type.TINYINT:_D,exp.DataType.Type.BINARY:'VARBINARY',exp.DataType.Type.TEXT:_H,exp.DataType.Type.NCHAR:_H,exp.DataType.Type.TIMESTAMPLTZ:_E,exp.DataType.Type.TIMESTAMPTZ:_E,exp.DataType.Type.DATETIME:_E};PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.PartitionedByProperty:exp.Properties.Location.POST_SCHEMA,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED};TRANSFORMS={**generator.Generator.TRANSFORMS,exp.CurrentTimestamp:lambda*A:'CURRENT_TIMESTAMP',exp.ArrayContains:rename_func('REPEATED_CONTAINS'),exp.ArraySize:rename_func('REPEATED_COUNT'),exp.Create:preprocess([move_schema_columns_to_partitioned_by]),exp.DateAdd:date_add_sql('ADD'),exp.DateStrToDate:datestrtodate_sql,exp.DateSub:date_add_sql('SUB'),exp.DateToDi:lambda self,e:f"CAST(TO_DATE({self.sql(e,_B)}, {Drill.DATEINT_FORMAT}) AS INT)",exp.DiToDate:lambda self,e:f"TO_DATE(CAST({self.sql(e,_B)} AS VARCHAR), {Drill.DATEINT_FORMAT})",exp.If:lambda self,e:f"`IF`({self.format_args(e.this,e.args.get("true"),e.args.get("false"))})",exp.ILike:lambda self,e:self.binary(e,'`ILIKE`'),exp.Levenshtein:rename_func('LEVENSHTEIN_DISTANCE'),exp.PartitionedByProperty:lambda self,e:f"PARTITION BY {self.sql(e,_B)}",exp.RegexpLike:rename_func('REGEXP_MATCHES'),exp.StrPosition:str_position_sql,exp.StrToDate:_str_to_date,exp.Pow:rename_func('POW'),exp.Select:transforms.preprocess([transforms.eliminate_distinct_on,transforms.eliminate_semi_and_anti_joins]),exp.StrToTime:lambda self,e:self.func(_F,e.this,self.format_time(e)),exp.TimeStrToDate:lambda self,e:self.sql(exp.cast(e.this,exp.DataType.Type.DATE)),exp.TimeStrToTime:timestrtotime_sql,exp.TimeStrToUnix:rename_func(_I),exp.TimeToStr:lambda self,e:self.func(_G,e.this,self.format_time(e)),exp.TimeToUnix:rename_func(_I),exp.ToChar:lambda self,e:self.function_fallback_sql(e),exp.TryCast:no_trycast_sql,exp.TsOrDsAdd:lambda self,e:f"DATE_ADD(CAST({self.sql(e,_B)} AS DATE), {self.sql(exp.Interval(this=e.expression,unit=exp.var("DAY")))})",exp.TsOrDiToDi:lambda self,e:f"CAST(SUBSTR(REPLACE(CAST({self.sql(e,_B)} AS VARCHAR), '-', ''), 1, 8) AS INT)"}