from __future__ import annotations
_D='UNCONDITIONAL'
_C='CONDITIONAL'
_B='JSON_QUERY'
_A='WRAPPER'
from sqlglot import exp,parser
from sqlglot.dialects.dialect import merge_without_target_sql,trim_sql,timestrtotime_sql
from sqlglot.dialects.presto import Presto
from sqlglot.tokens import TokenType
class Trino(Presto):
	SUPPORTS_USER_DEFINED_TYPES=False;LOG_BASE_FIRST=True
	class Parser(Presto.Parser):
		FUNCTION_PARSERS={**Presto.Parser.FUNCTION_PARSERS,'TRIM':lambda self:self._parse_trim(),_B:lambda self:self._parse_json_query()};JSON_QUERY_OPTIONS:parser.OPTIONS_TYPE={**dict.fromkeys(('WITH','WITHOUT'),((_C,_A),(_C,'ARRAY','WRAPPED'),(_D,_A),(_D,'ARRAY',_A)))}
		def _parse_json_query(A):return A.expression(exp.JSONExtract,this=A._parse_bitwise(),expression=A._match(TokenType.COMMA)and A._parse_bitwise(),option=A._parse_var_from_options(A.JSON_QUERY_OPTIONS,raise_unmatched=False),json_query=True)
	class Generator(Presto.Generator):
		TRANSFORMS={**Presto.Generator.TRANSFORMS,exp.ArraySum:lambda self,e:f"REDUCE({self.sql(e,"this")}, 0, (acc, x) -> acc + x, acc -> acc)",exp.Merge:merge_without_target_sql,exp.TimeStrToTime:lambda self,e:timestrtotime_sql(self,e,include_precision=True),exp.Trim:trim_sql,exp.JSONExtract:lambda self,e:self.jsonextract_sql(e)};SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript}
		def jsonextract_sql(C,expression):
			A=expression
			if not A.args.get('json_query'):return super().jsonextract_sql(A)
			D=C.sql(A,'expression');B=C.sql(A,'option');B=f" {B}"if B else'';return C.func(_B,A.this,D+B)
	class Tokenizer(Presto.Tokenizer):HEX_STRINGS=[("X'","'")]