from __future__ import annotations
_AU='on_condition'
_AT='condition'
_AS='cross_apply'
_AR='WITH CUBE'
_AQ='WITH ROLLUP'
_AP=' UNLOGGED'
_AO=' OVERWRITE'
_AN='overwrite'
_AM='retention_period'
_AL='input_format'
_AK='partition_by'
_AJ=' DISTINCT'
_AI=' MATERIALIZED'
_AH=' CONCURRENTLY'
_AG='concurrently'
_AF='index_type'
_AE='allow_null'
_AD='increment'
_AC='constraints'
_AB='distribute'
_AA='TRANSFORM'
_A9='strict'
_A8='return_type'
_A7='null_handling'
_A6='group'
_A5='source'
_A4='DEFAULT'
_A3='value'
_A2=' TEMPORARY'
_A1='temporary'
_A0=' IF EXISTS '
_z='local'
_y='materialized'
_x='unique'
_w='end'
_v=' DESC'
_u='position'
_t='table'
_s='BLOB'
_r='TEXT'
_q='values'
_p='null'
_o='delete'
_n='credentials'
_m='safe'
_l='from'
_k='sample'
_j='percent'
_i='columns'
_h='with'
_g='windows'
_f='offset'
_e='limit'
_d='returning'
_c='partition'
_b='start'
_a=' IF EXISTS'
_Z='NO '
_Y='path'
_X='expressions'
_W='format'
_V='where'
_U='cluster'
_T='no'
_S='actions'
_R='on'
_Q='using'
_P='options'
_O=')'
_N='ON'
_M='order'
_L='default'
_K='\n'
_J=', '
_I='exists'
_H='alias'
_G='kind'
_F='expression'
_E=' '
_D=None
_C=False
_B=True
_A='this'
import logging,re,typing as t
from collections import defaultdict
from functools import reduce,wraps
from sqlglot import exp
from sqlglot.errors import ErrorLevel,UnsupportedError,concat_messages
from sqlglot.helper import apply_index_offset,csv,name_sequence,seq_get
from sqlglot.jsonpath import ALL_JSON_PATH_PARTS,JSON_PATH_PART_TRANSFORMS
from sqlglot.time import format_time
from sqlglot.tokens import TokenType
if t.TYPE_CHECKING:from sqlglot._typing import E;from sqlglot.dialects.dialect import DialectType;G=t.TypeVar('G',bound='Generator');GeneratorMethod=t.Callable[[G,E],str]
logger=logging.getLogger('sqlglot')
ESCAPED_UNICODE_RE=re.compile('\\\\(\\d+)')
UNSUPPORTED_TEMPLATE="Argument '{}' is not supported for expression '{}' when targeting {}."
def unsupported_args(*C):
	'\n    Decorator that can be used to mark certain args of an `Expression` subclass as unsupported.\n    It expects a sequence of argument names or pairs of the form (argument_name, diagnostic_msg).\n    ';B={}
	for A in C:
		if isinstance(A,str):B[A]=_D
		else:B[A[0]]=A[1]
	def D(func):
		@wraps(func)
		def A(generator,expression):
			C=expression;A=generator;F=C.__class__.__name__;G=A.dialect.__class__.__name__
			for(E,D)in B.items():
				if C.args.get(E):D=D or UNSUPPORTED_TEMPLATE.format(E,F,G);A.unsupported(D)
			return func(A,C)
		return A
	return D
class _Generator(type):
	def __new__(B,clsname,bases,attrs):
		A=super().__new__(B,clsname,bases,attrs)
		for C in ALL_JSON_PATH_PARTS-A.SUPPORTED_JSON_PATH_PARTS:A.TRANSFORMS.pop(C,_D)
		return A
class Generator(metaclass=_Generator):
	'\n    Generator converts a given syntax tree to the corresponding SQL string.\n\n    Args:\n        pretty: Whether to format the produced SQL string.\n            Default: False.\n        identify: Determines when an identifier should be quoted. Possible values are:\n            False (default): Never quote, except in cases where it\'s mandatory by the dialect.\n            True or \'always\': Always quote.\n            \'safe\': Only quote identifiers that are case insensitive.\n        normalize: Whether to normalize identifiers to lowercase.\n            Default: False.\n        pad: The pad size in a formatted string. For example, this affects the indentation of\n            a projection in a query, relative to its nesting level.\n            Default: 2.\n        indent: The indentation size in a formatted string. For example, this affects the\n            indentation of subqueries and filters under a `WHERE` clause.\n            Default: 2.\n        normalize_functions: How to normalize function names. Possible values are:\n            "upper" or True (default): Convert names to uppercase.\n            "lower": Convert names to lowercase.\n            False: Disables function name normalization.\n        unsupported_level: Determines the generator\'s behavior when it encounters unsupported expressions.\n            Default ErrorLevel.WARN.\n        max_unsupported: Maximum number of unsupported messages to include in a raised UnsupportedError.\n            This is only relevant if unsupported_level is ErrorLevel.RAISE.\n            Default: 3\n        leading_comma: Whether the comma is leading or trailing in select expressions.\n            This is only relevant when generating in pretty mode.\n            Default: False\n        max_text_width: The max number of characters in a segment before creating new lines in pretty mode.\n            The default is on the smaller end because the length only represents a segment and not the true\n            line length.\n            Default: 80\n        comments: Whether to preserve comments in the output SQL code.\n            Default: True\n    ';TRANSFORMS:t.Dict[t.Type[exp.Expression],t.Callable[...,str]]={**JSON_PATH_PART_TRANSFORMS,exp.AllowedValuesProperty:lambda self,e:f"ALLOWED_VALUES {self.expressions(e,flat=_B)}",exp.ArrayContainsAll:lambda self,e:self.binary(e,'@>'),exp.ArrayOverlaps:lambda self,e:self.binary(e,'&&'),exp.AutoRefreshProperty:lambda self,e:f"AUTO REFRESH {self.sql(e,_A)}",exp.BackupProperty:lambda self,e:f"BACKUP {self.sql(e,_A)}",exp.CaseSpecificColumnConstraint:lambda _,e:f"{"NOT "if e.args.get("not_")else""}CASESPECIFIC",exp.CharacterSetColumnConstraint:lambda self,e:f"CHARACTER SET {self.sql(e,_A)}",exp.CharacterSetProperty:lambda self,e:f"{"DEFAULT "if e.args.get(_L)else""}CHARACTER SET={self.sql(e,_A)}",exp.ClusteredColumnConstraint:lambda self,e:f"CLUSTERED ({self.expressions(e,_A,indent=_C)})",exp.CollateColumnConstraint:lambda self,e:f"COLLATE {self.sql(e,_A)}",exp.CommentColumnConstraint:lambda self,e:f"COMMENT {self.sql(e,_A)}",exp.ConnectByRoot:lambda self,e:f"CONNECT_BY_ROOT {self.sql(e,_A)}",exp.CopyGrantsProperty:lambda*A:'COPY GRANTS',exp.DateFormatColumnConstraint:lambda self,e:f"FORMAT {self.sql(e,_A)}",exp.DefaultColumnConstraint:lambda self,e:f"DEFAULT {self.sql(e,_A)}",exp.DynamicProperty:lambda*A:'DYNAMIC',exp.EmptyProperty:lambda*A:'EMPTY',exp.EncodeColumnConstraint:lambda self,e:f"ENCODE {self.sql(e,_A)}",exp.EphemeralColumnConstraint:lambda self,e:f"EPHEMERAL{_E+self.sql(e,_A)if e.this else""}",exp.ExcludeColumnConstraint:lambda self,e:f"EXCLUDE {self.sql(e,_A).lstrip()}",exp.ExecuteAsProperty:lambda self,e:self.naked_property(e),exp.Except:lambda self,e:self.set_operations(e),exp.ExternalProperty:lambda*A:'EXTERNAL',exp.GlobalProperty:lambda*A:'GLOBAL',exp.HeapProperty:lambda*A:'HEAP',exp.IcebergProperty:lambda*A:'ICEBERG',exp.InheritsProperty:lambda self,e:f"INHERITS ({self.expressions(e,flat=_B)})",exp.InlineLengthColumnConstraint:lambda self,e:f"INLINE LENGTH {self.sql(e,_A)}",exp.InputModelProperty:lambda self,e:f"INPUT{self.sql(e,_A)}",exp.Intersect:lambda self,e:self.set_operations(e),exp.IntervalSpan:lambda self,e:f"{self.sql(e,_A)} TO {self.sql(e,_F)}",exp.LanguageProperty:lambda self,e:self.naked_property(e),exp.LocationProperty:lambda self,e:self.naked_property(e),exp.LogProperty:lambda _,e:f"{_Z if e.args.get(_T)else""}LOG",exp.MaterializedProperty:lambda*A:'MATERIALIZED',exp.NonClusteredColumnConstraint:lambda self,e:f"NONCLUSTERED ({self.expressions(e,_A,indent=_C)})",exp.NoPrimaryIndexProperty:lambda*A:'NO PRIMARY INDEX',exp.NotForReplicationColumnConstraint:lambda*A:'NOT FOR REPLICATION',exp.OnCommitProperty:lambda _,e:f"ON COMMIT {"DELETE"if e.args.get(_o)else"PRESERVE"} ROWS",exp.OnProperty:lambda self,e:f"ON {self.sql(e,_A)}",exp.OnUpdateColumnConstraint:lambda self,e:f"ON UPDATE {self.sql(e,_A)}",exp.Operator:lambda self,e:self.binary(e,''),exp.OutputModelProperty:lambda self,e:f"OUTPUT{self.sql(e,_A)}",exp.PathColumnConstraint:lambda self,e:f"PATH {self.sql(e,_A)}",exp.PivotAny:lambda self,e:f"ANY{self.sql(e,_A)}",exp.ProjectionPolicyColumnConstraint:lambda self,e:f"PROJECTION POLICY {self.sql(e,_A)}",exp.RemoteWithConnectionModelProperty:lambda self,e:f"REMOTE WITH CONNECTION {self.sql(e,_A)}",exp.ReturnsProperty:lambda self,e:'RETURNS NULL ON NULL INPUT'if e.args.get(_p)else self.naked_property(e),exp.SampleProperty:lambda self,e:f"SAMPLE BY {self.sql(e,_A)}",exp.SecureProperty:lambda*A:'SECURE',exp.SecurityProperty:lambda self,e:f"SECURITY {self.sql(e,_A)}",exp.SetConfigProperty:lambda self,e:self.sql(e,_A),exp.SetProperty:lambda _,e:f"{"MULTI"if e.args.get("multi")else""}SET",exp.SettingsProperty:lambda self,e:f"SETTINGS{self.seg("")}{self.expressions(e)}",exp.SharingProperty:lambda self,e:f"SHARING={self.sql(e,_A)}",exp.SqlReadWriteProperty:lambda _,e:e.name,exp.SqlSecurityProperty:lambda _,e:f"SQL SECURITY {"DEFINER"if e.args.get("definer")else"INVOKER"}",exp.StabilityProperty:lambda _,e:e.name,exp.Stream:lambda self,e:f"STREAM {self.sql(e,_A)}",exp.StreamingTableProperty:lambda*A:'STREAMING',exp.StrictProperty:lambda*A:'STRICT',exp.TemporaryProperty:lambda*A:'TEMPORARY',exp.TagColumnConstraint:lambda self,e:f"TAG ({self.expressions(e,flat=_B)})",exp.TitleColumnConstraint:lambda self,e:f"TITLE {self.sql(e,_A)}",exp.ToMap:lambda self,e:f"MAP {self.sql(e,_A)}",exp.ToTableProperty:lambda self,e:f"TO {self.sql(e.this)}",exp.TransformModelProperty:lambda self,e:self.func(_AA,*e.expressions),exp.TransientProperty:lambda*A:'TRANSIENT',exp.Union:lambda self,e:self.set_operations(e),exp.UnloggedProperty:lambda*A:'UNLOGGED',exp.Uuid:lambda*A:'UUID()',exp.UppercaseColumnConstraint:lambda*A:'UPPERCASE',exp.VarMap:lambda self,e:self.func('MAP',e.args['keys'],e.args[_q]),exp.ViewAttributeProperty:lambda self,e:f"WITH {self.sql(e,_A)}",exp.VolatileProperty:lambda*A:'VOLATILE',exp.WithJournalTableProperty:lambda self,e:f"WITH JOURNAL TABLE={self.sql(e,_A)}",exp.WithSchemaBindingProperty:lambda self,e:f"WITH SCHEMA {self.sql(e,_A)}",exp.WithOperator:lambda self,e:f"{self.sql(e,_A)} WITH {self.sql(e,"op")}"};NULL_ORDERING_SUPPORTED:t.Optional[bool]=_B;IGNORE_NULLS_IN_FUNC=_C;LOCKING_READS_SUPPORTED=_C;EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE=_B;WRAP_DERIVED_VALUES=_B;CREATE_FUNCTION_RETURN_AS=_B;MATCHED_BY_SOURCE=_B;SINGLE_STRING_INTERVAL=_C;INTERVAL_ALLOWS_PLURAL_FORM=_B;LIMIT_FETCH='ALL';LIMIT_ONLY_LITERALS=_C;RENAME_TABLE_WITH_DB=_B;GROUPINGS_SEP=',';INDEX_ON=_N;JOIN_HINTS=_B;TABLE_HINTS=_B;QUERY_HINTS=_B;QUERY_HINT_SEP=_J;IS_BOOL_ALLOWED=_B;DUPLICATE_KEY_UPDATE_WITH_SET=_B;LIMIT_IS_TOP=_C;RETURNING_END=_B;EXTRACT_ALLOWS_QUOTES=_B;TZ_TO_WITH_TIME_ZONE=_C;NVL2_SUPPORTED=_B;SELECT_KINDS:t.Tuple[str,...]=('STRUCT','VALUE');VALUES_AS_TABLE=_B;ALTER_TABLE_INCLUDE_COLUMN_KEYWORD=_B;UNNEST_WITH_ORDINALITY=_B;AGGREGATE_FILTER_SUPPORTED=_B;SEMI_ANTI_JOIN_WITH_SIDE=_B;COMPUTED_COLUMN_WITH_TYPE=_B;SUPPORTS_TABLE_COPY=_B;TABLESAMPLE_REQUIRES_PARENS=_B;TABLESAMPLE_SIZE_IS_ROWS=_B;TABLESAMPLE_KEYWORDS='TABLESAMPLE';TABLESAMPLE_WITH_METHOD=_B;TABLESAMPLE_SEED_KEYWORD='SEED';COLLATE_IS_FUNC=_C;DATA_TYPE_SPECIFIERS_ALLOWED=_C;ENSURE_BOOLS=_C;CTE_RECURSIVE_KEYWORD_REQUIRED=_B;SUPPORTS_SINGLE_ARG_CONCAT=_B;LAST_DAY_SUPPORTS_DATE_PART=_B;SUPPORTS_TABLE_ALIAS_COLUMNS=_B;UNPIVOT_ALIASES_ARE_IDENTIFIERS=_B;JSON_KEY_VALUE_PAIR_SEP=':';INSERT_OVERWRITE=' OVERWRITE TABLE';SUPPORTS_SELECT_INTO=_C;SUPPORTS_UNLOGGED_TABLES=_C;SUPPORTS_CREATE_TABLE_LIKE=_B;LIKE_PROPERTY_INSIDE_SCHEMA=_C;MULTI_ARG_DISTINCT=_B;JSON_TYPE_REQUIRED_FOR_EXTRACTION=_C;JSON_PATH_BRACKETED_KEY_SUPPORTED=_B;JSON_PATH_SINGLE_QUOTE_ESCAPE=_C;SUPPORTED_JSON_PATH_PARTS=ALL_JSON_PATH_PARTS.copy();CAN_IMPLEMENT_ARRAY_ANY=_C;SUPPORTS_TO_NUMBER=_B;SET_OP_MODIFIERS=_B;COPY_PARAMS_ARE_WRAPPED=_B;COPY_PARAMS_EQ_REQUIRED=_C;COPY_HAS_INTO_KEYWORD=_B;TRY_SUPPORTED=_B;SUPPORTS_UESCAPE=_B;STAR_EXCEPT='EXCEPT';HEX_FUNC='HEX';WITH_PROPERTIES_PREFIX='WITH';QUOTE_JSON_PATH=_B;PAD_FILL_PATTERN_IS_REQUIRED=_C;SUPPORTS_EXPLODING_PROJECTIONS=_B;ARRAY_CONCAT_IS_VAR_LEN=_B;SUPPORTS_CONVERT_TIMEZONE=_C;PARSE_JSON_NAME:t.Optional[str]='PARSE_JSON';TYPE_MAPPING={exp.DataType.Type.NCHAR:'CHAR',exp.DataType.Type.NVARCHAR:'VARCHAR',exp.DataType.Type.MEDIUMTEXT:_r,exp.DataType.Type.LONGTEXT:_r,exp.DataType.Type.TINYTEXT:_r,exp.DataType.Type.MEDIUMBLOB:_s,exp.DataType.Type.LONGBLOB:_s,exp.DataType.Type.TINYBLOB:_s,exp.DataType.Type.INET:'INET',exp.DataType.Type.ROWVERSION:'VARBINARY'};TIME_PART_SINGULARS={'MICROSECONDS':'MICROSECOND','SECONDS':'SECOND','MINUTES':'MINUTE','HOURS':'HOUR','DAYS':'DAY','WEEKS':'WEEK','MONTHS':'MONTH','QUARTERS':'QUARTER','YEARS':'YEAR'};AFTER_HAVING_MODIFIER_TRANSFORMS={_U:lambda self,e:self.sql(e,_U),_AB:lambda self,e:self.sql(e,_AB),'sort':lambda self,e:self.sql(e,'sort'),_g:lambda self,e:self.seg('WINDOW ')+self.expressions(e,key=_g,flat=_B)if e.args.get(_g)else'','qualify':lambda self,e:self.sql(e,'qualify')};TOKEN_MAPPING:t.Dict[TokenType,str]={};STRUCT_DELIMITER='<','>';PARAMETER_TOKEN='@';NAMED_PLACEHOLDER_TOKEN=':';PROPERTIES_LOCATION={exp.AllowedValuesProperty:exp.Properties.Location.POST_SCHEMA,exp.AlgorithmProperty:exp.Properties.Location.POST_CREATE,exp.AutoIncrementProperty:exp.Properties.Location.POST_SCHEMA,exp.AutoRefreshProperty:exp.Properties.Location.POST_SCHEMA,exp.BackupProperty:exp.Properties.Location.POST_SCHEMA,exp.BlockCompressionProperty:exp.Properties.Location.POST_NAME,exp.CharacterSetProperty:exp.Properties.Location.POST_SCHEMA,exp.ChecksumProperty:exp.Properties.Location.POST_NAME,exp.CollateProperty:exp.Properties.Location.POST_SCHEMA,exp.CopyGrantsProperty:exp.Properties.Location.POST_SCHEMA,exp.Cluster:exp.Properties.Location.POST_SCHEMA,exp.ClusteredByProperty:exp.Properties.Location.POST_SCHEMA,exp.DistributedByProperty:exp.Properties.Location.POST_SCHEMA,exp.DuplicateKeyProperty:exp.Properties.Location.POST_SCHEMA,exp.DataBlocksizeProperty:exp.Properties.Location.POST_NAME,exp.DataDeletionProperty:exp.Properties.Location.POST_SCHEMA,exp.DefinerProperty:exp.Properties.Location.POST_CREATE,exp.DictRange:exp.Properties.Location.POST_SCHEMA,exp.DictProperty:exp.Properties.Location.POST_SCHEMA,exp.DynamicProperty:exp.Properties.Location.POST_CREATE,exp.DistKeyProperty:exp.Properties.Location.POST_SCHEMA,exp.DistStyleProperty:exp.Properties.Location.POST_SCHEMA,exp.EmptyProperty:exp.Properties.Location.POST_SCHEMA,exp.EngineProperty:exp.Properties.Location.POST_SCHEMA,exp.ExecuteAsProperty:exp.Properties.Location.POST_SCHEMA,exp.ExternalProperty:exp.Properties.Location.POST_CREATE,exp.FallbackProperty:exp.Properties.Location.POST_NAME,exp.FileFormatProperty:exp.Properties.Location.POST_WITH,exp.FreespaceProperty:exp.Properties.Location.POST_NAME,exp.GlobalProperty:exp.Properties.Location.POST_CREATE,exp.HeapProperty:exp.Properties.Location.POST_WITH,exp.InheritsProperty:exp.Properties.Location.POST_SCHEMA,exp.IcebergProperty:exp.Properties.Location.POST_CREATE,exp.InputModelProperty:exp.Properties.Location.POST_SCHEMA,exp.IsolatedLoadingProperty:exp.Properties.Location.POST_NAME,exp.JournalProperty:exp.Properties.Location.POST_NAME,exp.LanguageProperty:exp.Properties.Location.POST_SCHEMA,exp.LikeProperty:exp.Properties.Location.POST_SCHEMA,exp.LocationProperty:exp.Properties.Location.POST_SCHEMA,exp.LockProperty:exp.Properties.Location.POST_SCHEMA,exp.LockingProperty:exp.Properties.Location.POST_ALIAS,exp.LogProperty:exp.Properties.Location.POST_NAME,exp.MaterializedProperty:exp.Properties.Location.POST_CREATE,exp.MergeBlockRatioProperty:exp.Properties.Location.POST_NAME,exp.NoPrimaryIndexProperty:exp.Properties.Location.POST_EXPRESSION,exp.OnProperty:exp.Properties.Location.POST_SCHEMA,exp.OnCommitProperty:exp.Properties.Location.POST_EXPRESSION,exp.Order:exp.Properties.Location.POST_SCHEMA,exp.OutputModelProperty:exp.Properties.Location.POST_SCHEMA,exp.PartitionedByProperty:exp.Properties.Location.POST_WITH,exp.PartitionedOfProperty:exp.Properties.Location.POST_SCHEMA,exp.PrimaryKey:exp.Properties.Location.POST_SCHEMA,exp.Property:exp.Properties.Location.POST_WITH,exp.RemoteWithConnectionModelProperty:exp.Properties.Location.POST_SCHEMA,exp.ReturnsProperty:exp.Properties.Location.POST_SCHEMA,exp.RowFormatProperty:exp.Properties.Location.POST_SCHEMA,exp.RowFormatDelimitedProperty:exp.Properties.Location.POST_SCHEMA,exp.RowFormatSerdeProperty:exp.Properties.Location.POST_SCHEMA,exp.SampleProperty:exp.Properties.Location.POST_SCHEMA,exp.SchemaCommentProperty:exp.Properties.Location.POST_SCHEMA,exp.SecureProperty:exp.Properties.Location.POST_CREATE,exp.SecurityProperty:exp.Properties.Location.POST_SCHEMA,exp.SerdeProperties:exp.Properties.Location.POST_SCHEMA,exp.Set:exp.Properties.Location.POST_SCHEMA,exp.SettingsProperty:exp.Properties.Location.POST_SCHEMA,exp.SetProperty:exp.Properties.Location.POST_CREATE,exp.SetConfigProperty:exp.Properties.Location.POST_SCHEMA,exp.SharingProperty:exp.Properties.Location.POST_EXPRESSION,exp.SequenceProperties:exp.Properties.Location.POST_EXPRESSION,exp.SortKeyProperty:exp.Properties.Location.POST_SCHEMA,exp.SqlReadWriteProperty:exp.Properties.Location.POST_SCHEMA,exp.SqlSecurityProperty:exp.Properties.Location.POST_CREATE,exp.StabilityProperty:exp.Properties.Location.POST_SCHEMA,exp.StreamingTableProperty:exp.Properties.Location.POST_CREATE,exp.StrictProperty:exp.Properties.Location.POST_SCHEMA,exp.TemporaryProperty:exp.Properties.Location.POST_CREATE,exp.ToTableProperty:exp.Properties.Location.POST_SCHEMA,exp.TransientProperty:exp.Properties.Location.POST_CREATE,exp.TransformModelProperty:exp.Properties.Location.POST_SCHEMA,exp.MergeTreeTTL:exp.Properties.Location.POST_SCHEMA,exp.UnloggedProperty:exp.Properties.Location.POST_CREATE,exp.ViewAttributeProperty:exp.Properties.Location.POST_SCHEMA,exp.VolatileProperty:exp.Properties.Location.POST_CREATE,exp.WithDataProperty:exp.Properties.Location.POST_EXPRESSION,exp.WithJournalTableProperty:exp.Properties.Location.POST_NAME,exp.WithSchemaBindingProperty:exp.Properties.Location.POST_SCHEMA,exp.WithSystemVersioningProperty:exp.Properties.Location.POST_SCHEMA};RESERVED_KEYWORDS:t.Set[str]=set();WITH_SEPARATED_COMMENTS:t.Tuple[t.Type[exp.Expression],...]=(exp.Command,exp.Create,exp.Delete,exp.Drop,exp.From,exp.Insert,exp.Join,exp.MultitableInserts,exp.Select,exp.SetOperation,exp.Update,exp.Where,exp.With);EXCLUDE_COMMENTS:t.Tuple[t.Type[exp.Expression],...]=(exp.Binary,exp.SetOperation);UNWRAPPED_INTERVAL_VALUES:t.Tuple[t.Type[exp.Expression],...]=(exp.Column,exp.Literal,exp.Neg,exp.Paren);PARAMETERIZABLE_TEXT_TYPES={exp.DataType.Type.NVARCHAR,exp.DataType.Type.VARCHAR,exp.DataType.Type.CHAR,exp.DataType.Type.NCHAR};EXPRESSIONS_WITHOUT_NESTED_CTES:t.Set[t.Type[exp.Expression]]=set();SENTINEL_LINE_BREAK='__SQLGLOT__LB__';__slots__='pretty','identify','normalize','pad','_indent','normalize_functions','unsupported_level','max_unsupported','leading_comma','max_text_width','comments','dialect','unsupported_messages','_escaped_quote_end','_escaped_identifier_end','_next_name','_identifier_start','_identifier_end'
	def __init__(A,pretty=_D,identify=_C,normalize=_C,pad=2,indent=2,normalize_functions=_D,unsupported_level=ErrorLevel.WARN,max_unsupported=3,leading_comma=_C,max_text_width=80,comments=_B,dialect=_D):C=normalize_functions;B=pretty;import sqlglot as D;from sqlglot.dialects import Dialect as E;A.pretty=B if B is not _D else D.pretty;A.identify=identify;A.normalize=normalize;A.pad=pad;A._indent=indent;A.unsupported_level=unsupported_level;A.max_unsupported=max_unsupported;A.leading_comma=leading_comma;A.max_text_width=max_text_width;A.comments=comments;A.dialect=E.get_or_raise(dialect);A.normalize_functions=A.dialect.NORMALIZE_FUNCTIONS if C is _D else C;A.unsupported_messages=[];A._escaped_quote_end=A.dialect.tokenizer_class.STRING_ESCAPES[0]+A.dialect.QUOTE_END;A._escaped_identifier_end=A.dialect.IDENTIFIER_END*2;A._next_name=name_sequence('_t');A._identifier_start=A.dialect.IDENTIFIER_START;A._identifier_end=A.dialect.IDENTIFIER_END
	def generate(A,expression,copy=_B):
		'\n        Generates the SQL string corresponding to the given syntax tree.\n\n        Args:\n            expression: The syntax tree.\n            copy: Whether to copy the expression. The generator performs mutations so\n                it is safer to copy.\n\n        Returns:\n            The SQL string corresponding to `expression`.\n        ';B=expression
		if copy:B=B.copy()
		B=A.preprocess(B);A.unsupported_messages=[];C=A.sql(B).strip()
		if A.pretty:C=C.replace(A.SENTINEL_LINE_BREAK,_K)
		if A.unsupported_level==ErrorLevel.IGNORE:return C
		if A.unsupported_level==ErrorLevel.WARN:
			for D in A.unsupported_messages:logger.warning(D)
		elif A.unsupported_level==ErrorLevel.RAISE and A.unsupported_messages:raise UnsupportedError(concat_messages(A.unsupported_messages,A.max_unsupported))
		return C
	def preprocess(B,expression):
		'Apply generic preprocessing transformations to a given expression.';A=expression;A=B._move_ctes_to_top_level(A)
		if B.ENSURE_BOOLS:from sqlglot.transforms import ensure_bools as C;A=C(A)
		return A
	def _move_ctes_to_top_level(B,expression):
		A=expression
		if not A.parent and type(A)in B.EXPRESSIONS_WITHOUT_NESTED_CTES and any(B.parent is not A for B in A.find_all(exp.With)):from sqlglot.transforms import move_ctes_to_top_level as C;A=C(A)
		return A
	def unsupported(A,message):
		B=message
		if A.unsupported_level==ErrorLevel.IMMEDIATE:raise UnsupportedError(B)
		A.unsupported_messages.append(B)
	def sep(A,sep=_E):return f"{sep.strip()}\n"if A.pretty else sep
	def seg(A,sql,sep=_E):return f"{A.sep(sep)}{sql}"
	def pad_comment(B,comment):A=comment;A=_E+A if A[0].strip()else A;A=A+_E if A[-1].strip()else A;return A
	def maybe_comment(A,sql,expression=_D,comments=_D,separated=_C):
		E=expression;D=comments;B=sql;D=(E and E.comments if D is _D else D)if A.comments else _D
		if not D or isinstance(E,A.EXCLUDE_COMMENTS):return B
		C=_E.join(f"/*{A.pad_comment(B)}*/"for B in D if B)
		if not C:return B
		C=A._replace_line_breaks(C)
		if separated or isinstance(E,A.WITH_SEPARATED_COMMENTS):return f"{A.sep()}{C}{B}"if not B or B[0].isspace()else f"{C}{A.sep()}{B}"
		return f"{B} {C}"
	def wrap(A,expression):
		C=expression;B=A.sql(C)if isinstance(C,exp.UNWRAPPED_QUERIES)else A.sql(C,_A)
		if not B:return'()'
		B=A.indent(B,level=1,pad=0);return f"({A.sep("")}{B}{A.seg(_O,sep="")}"
	def no_identify(A,func,*B,**C):D=A.identify;A.identify=_C;E=func(*B,**C);A.identify=D;return E
	def normalize_func(A,name):
		B=name
		if A.normalize_functions=='upper'or A.normalize_functions is _B:return B.upper()
		if A.normalize_functions=='lower':return B.lower()
		return B
	def indent(B,sql,level=0,pad=_D,skip_first=_C,skip_last=_C):
		C=sql;A=pad
		if not B.pretty or not C:return C
		A=B.pad if A is _D else A;D=C.split(_K);return _K.join(E if skip_first and C==0 or skip_last and C==len(D)-1 else f"{_E*(level*B._indent+A)}{E}"for(C,E)in enumerate(D))
	def sql(B,expression,key=_D,comment=_B):
		A=expression
		if not A:return''
		if isinstance(A,str):return A
		if key:
			D=A.args.get(key)
			if D:return B.sql(D)
			return''
		E=B.TRANSFORMS.get(A.__class__)
		if callable(E):C=E(B,A)
		elif isinstance(A,exp.Expression):
			F=f"{A.key}_sql"
			if hasattr(B,F):C=getattr(B,F)(A)
			elif isinstance(A,exp.Func):C=B.function_fallback_sql(A)
			elif isinstance(A,exp.Property):C=B.property_sql(A)
			else:raise ValueError(f"Unsupported expression type {A.__class__.__name__}")
		else:raise ValueError(f"Expected an Expression. Received {type(A)}: {A}")
		return B.maybe_comment(C,A)if B.comments and comment else C
	def uncache_sql(B,expression):A=expression;C=B.sql(A,_A);D=_a if A.args.get(_I)else'';return f"UNCACHE TABLE{D} {C}"
	def cache_sql(A,expression):C=expression;E=' LAZY'if C.args.get('lazy')else'';F=A.sql(C,_A);D=C.args.get(_P);D=f" OPTIONS({A.sql(D[0])} = {A.sql(D[1])})"if D else'';B=A.sql(C,_F);B=f" AS{A.sep()}{B}"if B else'';B=f"CACHE{E} TABLE {F}{D}{B}";return A.prepend_ctes(C,B)
	def characterset_sql(B,expression):
		A=expression
		if isinstance(A.parent,exp.Cast):return f"CHAR CHARACTER SET {B.sql(A,_A)}"
		C='DEFAULT 'if A.args.get(_L)else'';return f"{C}CHARACTER SET={B.sql(A,_A)}"
	def column_parts(B,expression):A=expression;return'.'.join(B.sql(A)for A in(A.args.get('catalog'),A.args.get('db'),A.args.get(_t),A.args.get(_A))if A)
	def column_sql(A,expression):
		C=expression;B=' (+)'if C.args.get('join_mark')else''
		if B and not A.dialect.SUPPORTS_COLUMN_JOIN_MARKS:B='';A.unsupported('Outer join syntax using the (+) operator is not supported.')
		return f"{A.column_parts(C)}{B}"
	def columnposition_sql(B,expression):C=expression;A=B.sql(C,_A);A=f" {A}"if A else'';D=B.sql(C,_u);return f"{D}{A}"
	def columndef_sql(B,expression,sep=_E):
		A=expression;F=B.sql(A,_A);C=B.sql(A,_G);D=B.expressions(A,key=_AC,sep=_E,flat=_B);G='IF NOT EXISTS 'if A.args.get(_I)else'';C=f"{sep}{C}"if C else'';D=f" {D}"if D else'';E=B.sql(A,_u);E=f" {E}"if E else''
		if A.find(exp.ComputedColumnConstraint)and not B.COMPUTED_COLUMN_WITH_TYPE:C=''
		return f"{G}{F}{C}{D}{E}"
	def columnconstraint_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,_G).strip();return f"CONSTRAINT {C} {D}"if C else D
	def computedcolumnconstraint_sql(C,expression):
		A=expression;D=C.sql(A,_A)
		if A.args.get('not_null'):B=' PERSISTED NOT NULL'
		elif A.args.get('persisted'):B=' PERSISTED'
		else:B=''
		return f"AS {D}{B}"
	def autoincrementcolumnconstraint_sql(A,_):return A.token_sql(TokenType.AUTO_INCREMENT)
	def compresscolumnconstraint_sql(A,expression):
		B=expression
		if isinstance(B.this,list):C=A.wrap(A.expressions(B,key=_A,flat=_B))
		else:C=A.sql(B,_A)
		return f"COMPRESS {C}"
	def generatedasidentitycolumnconstraint_sql(K,expression):
		A=expression;I=''
		if A.this is not _D:L=' ON NULL'if A.args.get('on_null')else'';I=' ALWAYS'if A.this else f" BY DEFAULT{L}"
		B=A.args.get(_b);B=f"START WITH {B}"if B else'';C=A.args.get(_AD);C=f" INCREMENT BY {C}"if C else'';E=A.args.get('minvalue');E=f" MINVALUE {E}"if E else'';F=A.args.get('maxvalue');F=f" MAXVALUE {F}"if F else'';J=A.args.get('cycle');D=''
		if J is not _D:D=f"{" NO"if not J else""} CYCLE";D=D.strip()if not B and not C else D
		G=''
		if B or C or D:G=f"{B}{C}{E}{F}{D}";G=f" ({G.strip()})"
		H=K.sql(A,_F);H=f"({H})"if H else'IDENTITY';return f"GENERATED{I} AS {H}{G}"
	def generatedasrowcolumnconstraint_sql(D,expression):A=expression;B='START'if A.args.get(_b)else'END';C=' HIDDEN'if A.args.get('hidden')else'';return f"GENERATED ALWAYS AS ROW {B}{C}"
	def periodforsystemtimeconstraint_sql(A,expression):B=expression;return f"PERIOD FOR SYSTEM_TIME ({A.sql(B,_A)}, {A.sql(B,_F)})"
	def notnullcolumnconstraint_sql(A,expression):return f"{""if expression.args.get(_AE)else"NOT "}NULL"
	def transformcolumnconstraint_sql(A,expression):return f"AS {A.sql(expression,_A)}"
	def primarykeycolumnconstraint_sql(B,expression):
		A=expression.args.get('desc')
		if A is not _D:return f"PRIMARY KEY{_v if A else" ASC"}"
		return'PRIMARY KEY'
	def uniquecolumnconstraint_sql(E,expression):A=expression;B=E.sql(A,_A);B=f" {B}"if B else'';C=A.args.get(_AF);C=f" USING {C}"if C else'';D=E.sql(A,'on_conflict');D=f" {D}"if D else'';F=' NULLS NOT DISTINCT'if A.args.get('nulls')else'';return f"UNIQUE{F}{B}{C}{D}"
	def createable_sql(A,expression,locations):return A.sql(expression,_A)
	def create_sql(A,expression):
		B=expression;G=A.sql(B,_G);G=A.dialect.INVERSE_CREATABLE_KIND_MAPPING.get(G)or G;K=B.args.get('properties');C=A.locate_properties(K)if K else defaultdict();P=A.createable_sql(B,C);E=''
		if C.get(exp.Properties.Location.POST_SCHEMA)or C.get(exp.Properties.Location.POST_WITH):
			E=A.sql(exp.Properties(expressions=[*C[exp.Properties.Location.POST_SCHEMA],*C[exp.Properties.Location.POST_WITH]]))
			if C.get(exp.Properties.Location.POST_SCHEMA):E=A.sep()+E
			elif not A.pretty:E=f" {E}"
		Q=' BEGIN'if B.args.get('begin')else'';R=' END'if B.args.get(_w)else'';D=A.sql(B,_F)
		if D:
			D=f"{Q}{A.sep()}{D}{R}"
			if A.CREATE_FUNCTION_RETURN_AS or not isinstance(B.expression,exp.Return):
				F=''
				if C.get(exp.Properties.Location.POST_ALIAS):F=A.properties(exp.Properties(expressions=C[exp.Properties.Location.POST_ALIAS]),wrapped=_C)
				F=f" {F}"if F else'';D=f" AS{F}{D}"
		L=''
		if C.get(exp.Properties.Location.POST_INDEX):L=A.properties(exp.Properties(expressions=C[exp.Properties.Location.POST_INDEX]),wrapped=_C,prefix=_E)
		H=A.expressions(B,key='indexes',indent=_C,sep=_E);H=f" {H}"if H else'';S=H+L;T=' OR REPLACE'if B.args.get('replace')else'';U=' OR REFRESH'if B.args.get('refresh')else'';V=' UNIQUE'if B.args.get(_x)else'';M=B.args.get('clustered')
		if M is _D:J=''
		elif M:J=' CLUSTERED COLUMNSTORE'
		else:J=' NONCLUSTERED COLUMNSTORE'
		N=''
		if C.get(exp.Properties.Location.POST_CREATE):N=A.properties(exp.Properties(expressions=C[exp.Properties.Location.POST_CREATE]),sep=_E,prefix=_E,wrapped=_C)
		W=''.join((J,T,U,V,N));O=''
		if C.get(exp.Properties.Location.POST_EXPRESSION):O=A.properties(exp.Properties(expressions=C[exp.Properties.Location.POST_EXPRESSION]),sep=_E,prefix=_E,wrapped=_C)
		X=_AH if B.args.get(_AG)else'';Y=' IF NOT EXISTS'if B.args.get(_I)else'';Z=' WITH NO SCHEMA BINDING'if B.args.get('no_schema_binding')else'';I=A.sql(B,'clone');I=f" {I}"if I else'';D=f"CREATE{W} {G}{X}{Y} {P}{E}{D}{O}{S}{Z}{I}";return A.prepend_ctes(B,D)
	def sequenceproperties_sql(B,expression):
		A=expression;C=B.sql(A,_b);C=f"START WITH {C}"if C else'';D=B.sql(A,_AD);D=f" INCREMENT BY {D}"if D else'';E=B.sql(A,'minvalue');E=f" MINVALUE {E}"if E else'';F=B.sql(A,'maxvalue');F=f" MAXVALUE {F}"if F else'';G=B.sql(A,'owned');G=f" OWNED BY {G}"if G else'';I=A.args.get('cache')
		if I is _D:J=''
		elif I is _B:J=' CACHE'
		else:J=f" CACHE {I}"
		H=B.expressions(A,key=_P,flat=_B,sep=_E);H=f" {H}"if H else'';return f"{C}{D}{E}{F}{J}{H}{G}".lstrip()
	def clone_sql(B,expression):A=expression;C=B.sql(A,_A);D='SHALLOW 'if A.args.get('shallow')else'';E='COPY'if A.args.get('copy')and B.SUPPORTS_TABLE_COPY else'CLONE';return f"{D}{E} {C}"
	def describe_sql(D,expression):C=expression;A=C.args.get('style');A=f" {A}"if A else'';B=D.sql(C,_c);B=f" {B}"if B else'';return f"DESCRIBE{A} {D.sql(C,_A)}{B}"
	def heredoc_sql(A,expression):B=expression;C=A.sql(B,'tag');return f"${C}${A.sql(B,_A)}${C}$"
	def prepend_ctes(B,expression,sql):
		A=sql;C=B.sql(expression,_h)
		if C:A=f"{C}{B.sep()}{A}"
		return A
	def with_sql(A,expression):B=expression;C=A.expressions(B,flat=_B);D='RECURSIVE 'if A.CTE_RECURSIVE_KEYWORD_REQUIRED and B.args.get('recursive')else'';return f"WITH {D}{C}"
	def cte_sql(C,expression):
		A=expression;D=A.args.get(_H)
		if D:D.add_comments(A.pop_comments())
		E=C.sql(A,_H);B=A.args.get(_y)
		if B is _C:B='NOT MATERIALIZED '
		elif B:B='MATERIALIZED '
		return f"{E} AS {B or""}{C.wrap(A)}"
	def tablealias_sql(A,expression):
		D=expression;C=A.sql(D,_A);B=A.expressions(D,key=_i,flat=_B);B=f"({B})"if B else''
		if B and not A.SUPPORTS_TABLE_ALIAS_COLUMNS:B='';A.unsupported('Named columns are not supported in table alias.')
		if not C and not A.dialect.UNNEST_COLUMN_ONLY:C=A._next_name()
		return f"{C}{B}"
	def bitstring_sql(A,expression):
		B=A.sql(expression,_A)
		if A.dialect.BIT_START:return f"{A.dialect.BIT_START}{B}{A.dialect.BIT_END}"
		return f"{int(B,2)}"
	def hexstring_sql(A,expression):
		B=A.sql(expression,_A)
		if A.dialect.HEX_START:return f"{A.dialect.HEX_START}{B}{A.dialect.HEX_END}"
		return f"{int(B,16)}"
	def bytestring_sql(A,expression):
		B=A.sql(expression,_A)
		if A.dialect.BYTE_START:return f"{A.dialect.BYTE_START}{B}{A.dialect.BYTE_END}"
		return B
	def unicodestring_sql(A,expression):
		D=expression;C=A.sql(D,_A);B=D.args.get('escape')
		if A.dialect.UNICODE_START:E='\\\\\\1';F,G=A.dialect.UNICODE_START,A.dialect.UNICODE_END
		else:E='\\\\u\\1';F,G=A.dialect.QUOTE_START,A.dialect.QUOTE_END
		if B:H=re.compile(f"{B.name}(\\d+)");I=f" UESCAPE {A.sql(B)}"if A.SUPPORTS_UESCAPE else''
		else:H=ESCAPED_UNICODE_RE;I=''
		if not A.dialect.UNICODE_START or B and not A.SUPPORTS_UESCAPE:C=H.sub(E,C)
		return f"{F}{C}{G}{I}"
	def rawstring_sql(A,expression):B=A.escape_str(expression.this.replace('\\','\\\\'),escape_backslash=_C);return f"{A.dialect.QUOTE_START}{B}{A.dialect.QUOTE_END}"
	def datatypeparam_sql(B,expression):C=expression;D=B.sql(C,_A);A=B.sql(C,_F);A=f" {A}"if A and B.DATA_TYPE_SPECIFIERS_ALLOWED else'';return f"{D}{A}"
	def datatype_sql(B,expression):
		C=expression;E='';F='';G=B.expressions(C,flat=_B);A=C.this
		if A==exp.DataType.Type.USERDEFINED and C.args.get(_G):D=B.sql(C,_G)
		else:D=B.TYPE_MAPPING.get(A,A.value)if isinstance(A,exp.DataType.Type)else A
		if G:
			if C.args.get('nested'):
				E=f"{B.STRUCT_DELIMITER[0]}{G}{B.STRUCT_DELIMITER[1]}"
				if C.args.get(_q)is not _D:H=('[',']')if A==exp.DataType.Type.ARRAY else('(',_O);F=B.expressions(C,key=_q,flat=_B);F=f"{H[0]}{F}{H[1]}"
			elif A==exp.DataType.Type.INTERVAL:E=f" {G}"
			else:E=f"({G})"
		D=f"{D}{E}{F}"
		if B.TZ_TO_WITH_TIME_ZONE and A in(exp.DataType.Type.TIMETZ,exp.DataType.Type.TIMESTAMPTZ):D=f"{D} WITH TIME ZONE"
		return D
	def directory_sql(C,expression):B=expression;D='LOCAL 'if B.args.get(_z)else'';A=C.sql(B,'row_format');A=f" {A}"if A else'';return f"{D}DIRECTORY {C.sql(B,_A)}{A}"
	def delete_sql(A,expression):
		B=expression;C=A.sql(B,_A);C=f" FROM {C}"if C else'';D=A.sql(B,_Q);D=f" USING {D}"if D else'';E=A.sql(B,_U);E=f" {E}"if E else'';G=A.sql(B,_V);H=A.sql(B,_d);I=A.sql(B,_e);F=A.expressions(B,key='tables');F=f" {F}"if F else''
		if A.RETURNING_END:J=f"{C}{D}{E}{G}{H}{I}"
		else:J=f"{H}{C}{D}{E}{G}{I}"
		return A.prepend_ctes(B,f"DELETE{F}{J}")
	def drop_sql(B,expression):A=expression;F=B.sql(A,_A);C=B.expressions(A,flat=_B);C=f" ({C})"if C else'';D=A.args[_G];D=B.dialect.INVERSE_CREATABLE_KIND_MAPPING.get(D)or D;G=_A0 if A.args.get(_I)else _E;H=_AH if A.args.get(_AG)else'';E=B.sql(A,_U);E=f" {E}"if E else'';I=_A2 if A.args.get(_A1)else'';J=_AI if A.args.get(_y)else'';K=' CASCADE'if A.args.get('cascade')else'';L=' CONSTRAINTS'if A.args.get(_AC)else'';M=' PURGE'if A.args.get('purge')else'';return f"DROP{I}{J} {D}{H}{G}{F}{E}{C}{K}{L}{M}"
	def set_operation(B,expression):
		C=expression;D=type(C);E=D.key.upper();A=C.args.get('distinct')
		if A is _C and D in(exp.Except,exp.Intersect)and not B.EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE:B.unsupported(f"{E} ALL is not supported")
		F=B.dialect.SET_OP_DISTINCT_BY_DEFAULT[D]
		if A is _D:
			A=F
			if A is _D:B.unsupported(f"{E} requires DISTINCT or ALL to be specified")
		if A is F:G=''
		else:G=_AJ if A else' ALL'
		H=' BY NAME'if C.args.get('by_name')else'';return f"{E}{G}{H}"
	def set_operations(A,expression):
		B=expression
		if not A.SET_OP_MODIFIERS:
			F=B.args.get(_e);G=B.args.get(_M)
			if F or G:
				D=A._move_ctes_to_top_level(exp.subquery(B,'_l_0',copy=_C).select('*',copy=_C))
				if F:D=D.limit(F.pop(),copy=_C)
				if G:D=D.order_by(G.pop(),copy=_C)
				return A.sql(D)
		I=[];E=[B]
		while E:
			C=E.pop()
			if isinstance(C,exp.SetOperation):E.append(C.expression);E.append(A.maybe_comment(A.set_operation(C),comments=C.comments,separated=_B));E.append(C.this)
			else:I.append(A.sql(C))
		H=A.sep().join(I);H=A.query_modifiers(B,H);return A.prepend_ctes(B,H)
	def fetch_sql(D,expression):
		B=expression;C=B.args.get('direction');C=f" {C}"if C else'';A=D.sql(B,'count');A=f" {A}"if A else''
		if B.args.get(_j):A=f"{A} PERCENT"
		E='WITH TIES'if B.args.get('with_ties')else'ONLY';return f"{D.seg("FETCH")}{C}{A} ROWS {E}"
	def filter_sql(A,expression):
		B=expression
		if A.AGGREGATE_FILTER_SUPPORTED:E=A.sql(B,_A);F=A.sql(B,_F).strip();return f"{E} FILTER({F})"
		C=B.this;D=C.this;G=B.expression.this;D.replace(exp.If(this=G.copy(),true=D.copy()));return A.sql(C)
	def hint_sql(A,expression):
		if not A.QUERY_HINTS:A.unsupported('Hints are not supported');return''
		return f" /*+ {A.expressions(expression,sep=A.QUERY_HINT_SEP).strip()} */"
	def indexparameters_sql(A,expression):
		B=expression;C=A.sql(B,_Q);C=f" USING {C}"if C else'';D=A.expressions(B,key=_i,flat=_B);D=f"({D})"if D else'';E=A.expressions(B,key=_AK,flat=_B);E=f" PARTITION BY {E}"if E else'';J=A.sql(B,_V);F=A.expressions(B,key='include',flat=_B)
		if F:F=f" INCLUDE ({F})"
		G=A.expressions(B,key='with_storage',flat=_B);G=f" WITH ({G})"if G else'';H=A.sql(B,'tablespace');H=f" USING INDEX TABLESPACE {H}"if H else'';I=A.sql(B,_R);I=f" ON {I}"if I else'';return f"{C}{D}{F}{G}{H}{E}{J}{I}"
	def index_sql(C,expression):A=expression;E='UNIQUE 'if A.args.get(_x)else'';F='PRIMARY 'if A.args.get('primary')else'';G='AMP 'if A.args.get('amp')else'';D=C.sql(A,_A);D=f"{D} "if D else'';B=C.sql(A,_t);B=f"{C.INDEX_ON} {B}"if B else'';H='INDEX 'if not B else'';I=C.sql(A,'params');return f"{E}{F}{G}{H}{D}{B}{I}"
	def identifier_sql(B,expression):
		C=expression;A=C.name;D=A.lower();A=D if B.normalize and not C.quoted else A;A=A.replace(B._identifier_end,B._escaped_identifier_end)
		if C.quoted or B.dialect.can_identify(A,B.identify)or D in B.RESERVED_KEYWORDS or not B.dialect.IDENTIFIERS_CAN_START_WITH_DIGIT and A[:1].isdigit():A=f"{B._identifier_start}{A}{B._identifier_end}"
		return A
	def hex_sql(A,expression):
		B=A.func(A.HEX_FUNC,A.sql(expression,_A))
		if A.dialect.HEX_LOWERCASE:B=A.func('LOWER',B)
		return B
	def lowerhex_sql(A,expression):
		B=A.func(A.HEX_FUNC,A.sql(expression,_A))
		if not A.dialect.HEX_LOWERCASE:B=A.func('LOWER',B)
		return B
	def inputoutputformat_sql(C,expression):D=expression;A=C.sql(D,_AL);A=f"INPUTFORMAT {A}"if A else'';B=C.sql(D,'output_format');B=f"OUTPUTFORMAT {B}"if B else'';return C.sep().join((A,B))
	def national_sql(A,expression,prefix='N'):B=A.sql(exp.Literal.string(expression.name));return f"{prefix}{B}"
	def partition_sql(A,expression):return f"PARTITION({A.expressions(expression,flat=_B)})"
	def properties_sql(A,expression):
		D=[];E=[]
		for C in expression.expressions:
			F=A.PROPERTIES_LOCATION[C.__class__]
			if F==exp.Properties.Location.POST_WITH:E.append(C)
			elif F==exp.Properties.Location.POST_SCHEMA:D.append(C)
		G=A.root_properties(exp.Properties(expressions=D));B=A.with_properties(exp.Properties(expressions=E))
		if G and B and not A.pretty:B=_E+B
		return G+B
	def root_properties(B,properties):
		A=properties
		if A.expressions:return B.expressions(A,indent=_C,sep=_E)
		return''
	def properties(B,properties,prefix='',sep=_J,suffix='',wrapped=_B):
		D=prefix;C=properties
		if C.expressions:
			A=B.expressions(C,sep=sep,indent=_C)
			if A:A=B.wrap(A)if wrapped else A;return f"{D}{_E if D.strip()else""}{A}{suffix}"
		return''
	def with_properties(A,properties):return A.properties(properties,prefix=A.seg(A.WITH_PROPERTIES_PREFIX,sep=''))
	def locate_properties(B,properties):
		C=defaultdict(list)
		for A in properties.expressions:
			D=B.PROPERTIES_LOCATION[A.__class__]
			if D!=exp.Properties.Location.UNSUPPORTED:C[D].append(A)
			else:B.unsupported(f"Unsupported property {A.key}")
		return C
	def property_name(B,expression,string_key=_C):
		A=expression
		if isinstance(A.this,exp.Dot):return B.sql(A,_A)
		return f"'{A.name}'"if string_key else A.name
	def property_sql(B,expression):
		A=expression;C=A.__class__
		if C==exp.Property:return f"{B.property_name(A)}={B.sql(A,_A3)}"
		D=exp.Properties.PROPERTY_TO_NAME.get(C)
		if not D:B.unsupported(f"Unsupported property {A.key}")
		return f"{D}={B.sql(A,_A)}"
	def likeproperty_sql(A,expression):
		B=expression
		if A.SUPPORTS_CREATE_TABLE_LIKE:
			C=_E.join(f"{B.name} {A.sql(B,_A3)}"for B in B.expressions);C=f" {C}"if C else'';D=f"LIKE {A.sql(B,_A)}{C}"
			if A.LIKE_PROPERTY_INSIDE_SCHEMA and not isinstance(B.parent,exp.Schema):D=f"({D})"
			return D
		if B.expressions:A.unsupported('Transpilation of LIKE property options is unsupported')
		E=exp.select('*').from_(B.this).limit(0);return f"AS {A.sql(E)}"
	def fallbackproperty_sql(D,expression):A=expression;B=_Z if A.args.get(_T)else'';C=' PROTECTION'if A.args.get('protection')else'';return f"{B}FALLBACK{C}"
	def journalproperty_sql(G,expression):A=expression;C=_Z if A.args.get(_T)else'';B=A.args.get(_z);B=f"{B} "if B else'';D='DUAL 'if A.args.get('dual')else'';E='BEFORE 'if A.args.get('before')else'';F='AFTER 'if A.args.get('after')else'';return f"{C}{B}{D}{E}{F}JOURNAL"
	def freespaceproperty_sql(B,expression):A=expression;C=B.sql(A,_A);D=' PERCENT'if A.args.get(_j)else'';return f"FREESPACE={C}{D}"
	def checksumproperty_sql(B,expression):
		A=expression
		if A.args.get(_L):property=_A4
		elif A.args.get(_R):property=_N
		else:property='OFF'
		return f"CHECKSUM={property}"
	def mergeblockratioproperty_sql(B,expression):
		A=expression
		if A.args.get(_T):return'NO MERGEBLOCKRATIO'
		if A.args.get(_L):return'DEFAULT MERGEBLOCKRATIO'
		C=' PERCENT'if A.args.get(_j)else'';return f"MERGEBLOCKRATIO={B.sql(A,_A)}{C}"
	def datablocksizeproperty_sql(F,expression):
		A=expression;D=A.args.get(_L);E=A.args.get('minimum');G=A.args.get('maximum')
		if D or E or G:
			if D:C=_A4
			elif E:C='MINIMUM'
			else:C='MAXIMUM'
			return f"{C} DATABLOCKSIZE"
		B=A.args.get('units');B=f" {B}"if B else'';return f"DATABLOCKSIZE={F.sql(A,"size")}{B}"
	def blockcompressionproperty_sql(D,expression):
		A=expression;C=A.args.get('autotemp');E=A.args.get('always');F=A.args.get(_L);G=A.args.get('manual');H=A.args.get('never')
		if C is not _D:B=f"AUTOTEMP({D.expressions(C)})"
		elif E:B='ALWAYS'
		elif F:B=_A4
		elif G:B='MANUAL'
		elif H:B='NEVER'
		return f"BLOCKCOMPRESSION={B}"
	def isolatedloadingproperty_sql(E,expression):B=expression;C=B.args.get(_T);C=' NO'if C else'';D=B.args.get('concurrent');D=' CONCURRENT'if D else'';A=E.sql(B,'target');A=f" {A}"if A else'';return f"WITH{C}{D} ISOLATED LOADING{A}"
	def partitionboundspec_sql(B,expression):
		A=expression
		if isinstance(A.this,list):return f"IN ({B.expressions(A,key=_A,flat=_B)})"
		if A.this:C=B.sql(A,_A);D=B.sql(A,_F);return f"WITH (MODULUS {C}, REMAINDER {D})"
		E=B.expressions(A,key='from_expressions',flat=_B);F=B.expressions(A,key='to_expressions',flat=_B);return f"FROM ({E}) TO ({F})"
	def partitionedofproperty_sql(B,expression):
		C=expression;D=B.sql(C,_A);A=C.expression
		if isinstance(A,exp.PartitionBoundSpec):A=f" FOR VALUES {B.sql(A)}"
		else:A=' DEFAULT'
		return f"PARTITION OF {D}{A}"
	def lockingproperty_sql(C,expression):A=expression;D=A.args.get(_G);E=f" {C.sql(A,_A)}"if A.this else'';B=A.args.get('for_or_in');B=f" {B}"if B else'';F=A.args.get('lock_type');G=' OVERRIDE'if A.args.get('override')else'';return f"LOCKING {D}{E}{B} {F}{G}"
	def withdataproperty_sql(E,expression):
		A=expression;D=f"WITH {_Z if A.args.get(_T)else""}DATA";B=A.args.get('statistics');C=''
		if B is not _D:C=f" AND {_Z if not B else""}STATISTICS"
		return f"{D}{C}"
	def withsystemversioningproperty_sql(C,expression):
		A=expression;B=C.sql(A,_A);B=f"HISTORY_TABLE={B}"if B else'';D=C.sql(A,'data_consistency');D=f"DATA_CONSISTENCY_CHECK={D}"if D else _D;E=C.sql(A,_AM);E=f"HISTORY_RETENTION_PERIOD={E}"if E else _D
		if B:F=C.func(_N,B,D,E)
		else:F=_N if A.args.get(_R)else'OFF'
		G=f"SYSTEM_VERSIONING={F}";return f"WITH({G})"if A.args.get(_h)else G
	def insert_sql(B,expression):
		N=' INTO';A=expression;O=B.sql(A,'hint');L=A.args.get(_AN)
		if isinstance(A.this,exp.Directory):C=_AO if L else N
		else:C=B.INSERT_OVERWRITE if L else N
		F=B.sql(A,'stored');F=f" {F}"if F else'';G=A.args.get('alternative');G=f" OR {G}"if G else'';P=' IGNORE'if A.args.get('ignore')else'';Q=A.args.get('is_function')
		if Q:C=f"{C} FUNCTION"
		C=f"{C} {B.sql(A,_A)}";R=_a if A.args.get(_I)else'';H=B.sql(A,_V);H=f"{B.sep()}REPLACE WHERE {H}"if H else'';D=f"{B.sep()}{B.sql(A,_F)}";E=B.sql(A,'conflict');E=f" {E}"if E else'';S=' BY NAME'if A.args.get('by_name')else'';M=B.sql(A,_d)
		if B.RETURNING_END:D=f"{D}{E}{M}"
		else:D=f"{M}{D}{E}"
		I=B.sql(A,_c);I=f" {I}"if I else'';J=B.sql(A,'settings');J=f" {J}"if J else'';K=B.sql(A,_A5);K=f"TABLE {K}"if K else'';T=f"INSERT{O}{G}{P}{C}{F}{S}{R}{I}{J}{H}{D}{K}";return B.prepend_ctes(A,T)
	def introducer_sql(A,expression):B=expression;return f"{A.sql(B,_A)} {A.sql(B,_F)}"
	def kill_sql(C,expression):D=expression;A=C.sql(D,_G);A=f" {A}"if A else'';B=C.sql(D,_A);B=f" {B}"if B else'';return f"KILL{A}{B}"
	def pseudotype_sql(A,expression):return expression.name
	def objectidentifier_sql(A,expression):return expression.name
	def onconflict_sql(A,expression):
		B=expression;F='ON DUPLICATE KEY'if B.args.get('duplicate')else'ON CONFLICT';C=A.sql(B,'constraint');C=f" ON CONSTRAINT {C}"if C else'';D=A.expressions(B,key='conflict_keys',flat=_B);D=f"({D}) "if D else _E;G=A.sql(B,'action');E=A.expressions(B,flat=_B)
		if E:H='SET 'if A.DUPLICATE_KEY_UPDATE_WITH_SET else'';E=f" {H}{E}"
		return f"{F}{C}{D}{G}{E}"
	def returning_sql(A,expression):return f"{A.seg("RETURNING")} {A.expressions(expression,flat=_B)}"
	def rowformatdelimitedproperty_sql(A,expression):B=expression;C=A.sql(B,'fields');C=f" FIELDS TERMINATED BY {C}"if C else'';D=A.sql(B,'escaped');D=f" ESCAPED BY {D}"if D else'';E=A.sql(B,'collection_items');E=f" COLLECTION ITEMS TERMINATED BY {E}"if E else'';F=A.sql(B,'map_keys');F=f" MAP KEYS TERMINATED BY {F}"if F else'';G=A.sql(B,'lines');G=f" LINES TERMINATED BY {G}"if G else'';H=A.sql(B,_p);H=f" NULL DEFINED AS {H}"if H else'';return f"ROW FORMAT DELIMITED{C}{D}{E}{F}{G}{H}"
	def withtablehint_sql(A,expression):return f"WITH ({A.expressions(expression,flat=_B)})"
	def indextablehint_sql(B,expression):C=expression;D=f"{B.sql(C,_A)} INDEX";A=B.sql(C,'target');A=f" FOR {A}"if A else'';return f"{D}{A} ({B.expressions(C,flat=_B)})"
	def historicaldata_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,_G);E=A.sql(B,_F);return f"{C} ({D} => {E})"
	def table_parts(B,expression):A=expression;return'.'.join(B.sql(A)for A in(A.args.get('catalog'),A.args.get('db'),A.args.get(_A))if A is not _D)
	def table_sql(A,expression,sep=' AS '):
		B=expression;D=A.table_parts(B);Q='ONLY 'if B.args.get('only')else'';E=A.sql(B,_c);E=f" {E}"if E else'';F=A.sql(B,'version');F=f" {F}"if F else'';C=A.sql(B,_H);C=f"{sep}{C}"if C else'';L=A.sql(B,_k)
		if A.dialect.ALIAS_POST_TABLESAMPLE:M=L;N=''
		else:M='';N=L
		G=A.expressions(B,key='hints',sep=_E);G=f" {G}"if G and A.TABLE_HINTS else'';R=A.expressions(B,key='pivots',sep='',flat=_B);S=A.indent(A.expressions(B,key='joins',sep='',flat=_B),skip_first=_B);T=A.expressions(B,key='laterals',sep='');H=A.sql(B,_W)
		if H:I=A.sql(B,'pattern');I=f", PATTERN => {I}"if I else'';H=f" (FILE_FORMAT => {H}{I})"
		K=B.args.get('ordinality')or''
		if K:K=f" WITH ORDINALITY{C}";C=''
		O=A.sql(B,'when')
		if O:D=f"{D} {O}"
		J=A.sql(B,'changes');J=f" {J}"if J else'';P=A.expressions(B,key='rows_from')
		if P:D=f"ROWS FROM {A.wrap(P)}"
		return f"{Q}{D}{J}{E}{F}{H}{M}{C}{G}{R}{N}{S}{T}{K}"
	def tablesample_sql(A,expression,tablesample_keyword=_D):
		B=expression;C=A.sql(B,'method');C=f"{C} "if C and A.TABLESAMPLE_WITH_METHOD else'';I=A.sql(B,'bucket_numerator');J=A.sql(B,'bucket_denominator');D=A.sql(B,'bucket_field');D=f" ON {D}"if D else'';K=f"BUCKET {I} OUT OF {J}{D}"if I else'';E=A.sql(B,'seed');E=f" {A.TABLESAMPLE_SEED_KEYWORD} ({E})"if E else'';F=A.sql(B,'size')
		if F and A.TABLESAMPLE_SIZE_IS_ROWS:F=f"{F} ROWS"
		G=A.sql(B,_j)
		if G and not A.dialect.TABLESAMPLE_SIZE_IS_PERCENT:G=f"{G} PERCENT"
		H=f"{K}{G}{F}"
		if A.TABLESAMPLE_REQUIRES_PARENS:H=f"({H})"
		return f" {tablesample_keyword or A.TABLESAMPLE_KEYWORDS} {C}{H}{E}"
	def pivot_sql(A,expression):
		B=expression;F=A.expressions(B,flat=_B)
		if B.this:
			G=A.sql(B,_A)
			if not F:return f"UNPIVOT {G}"
			J=f"{A.seg(_N)} {F}";C=A.expressions(B,key=_Q,flat=_B);C=f"{A.seg("USING")} {C}"if C else'';K=A.sql(B,_A6);return f"PIVOT {G}{J}{C}{K}"
		D=A.sql(B,_H);D=f" AS {D}"if D else'';L=A.seg('UNPIVOT'if B.unpivot else'PIVOT');M=A.sql(B,'field');H=B.args.get('include_nulls')
		if H is not _D:I=' INCLUDE NULLS 'if H else' EXCLUDE NULLS '
		else:I=''
		E=A.sql(B,'default_on_null');E=f" DEFAULT ON NULL ({E})"if E else'';return f"{L}{I}({F} FOR {M}{E}){D}"
	def version_sql(B,expression):A=expression;C=f"FOR {A.name}";D=A.text(_G);E=B.sql(A,_F);return f"{C} {D} {E}"
	def tuple_sql(A,expression):return f"({A.expressions(expression,dynamic=_B,new_line=_B,skip_first=_B,skip_last=_B)})"
	def update_sql(A,expression):
		B=expression;G=A.sql(B,_A);H=A.expressions(B,flat=_B);C=A.sql(B,_l);D=A.sql(B,_V);E=A.sql(B,_d);I=A.sql(B,_M);J=A.sql(B,_e)
		if A.RETURNING_END:F=f"{C}{D}{E}"
		else:F=f"{E}{C}{D}"
		K=f"UPDATE {G} SET {H}{F}{I}{J}";return A.prepend_ctes(B,K)
	def values_sql(A,expression,values_as_table=_B):
		F=values_as_table;B=expression;F=F and A.VALUES_AS_TABLE
		if F or not B.find_ancestor(exp.From,exp.Join):J=A.expressions(B);D=A.sql(B,_H);E=f"VALUES{A.seg("")}{J}";E=f"({E})"if A.WRAP_DERIVED_VALUES and(D or isinstance(B.parent,(exp.From,exp.Table)))else E;return f"{E} AS {D}"if D else E
		C=B.args.get(_H);I=C and C.columns;G=[]
		for(K,L)in enumerate(B.expressions):
			H=L.expressions
			if K==0 and I:H=[exp.alias_(A,B)for(A,B)in zip(H,I)]
			G.append(exp.Select(expressions=H))
		if A.pretty:M=reduce(lambda x,y:exp.union(x,y,distinct=_C,copy=_C),G);return A.subquery_sql(M.subquery(C and C.this,copy=_C))
		D=f" AS {A.sql(C,_A)}"if C else'';N=' UNION ALL '.join(A.sql(B)for B in G);return f"({N}){D}"
	def var_sql(A,expression):return A.sql(expression,_A)
	@unsupported_args(_X)
	def into_sql(self,expression):A=expression;B=_A2 if A.args.get(_A1)else'';C=_AP if A.args.get('unlogged')else'';return f"{self.seg("INTO")}{B or C} {self.sql(A,_A)}"
	def from_sql(A,expression):return f"{A.seg("FROM")} {A.sql(expression,_A)}"
	def groupingsets_sql(A,expression):B=A.expressions(expression,indent=_C);return f"GROUPING SETS {A.wrap(B)}"
	def rollup_sql(A,expression):B=A.expressions(expression,indent=_C);return f"ROLLUP {A.wrap(B)}"if B else _AQ
	def cube_sql(A,expression):B=A.expressions(expression,indent=_C);return f"CUBE {A.wrap(B)}"if B else _AR
	def group_sql(A,expression):
		B=expression;F=B.args.get('all')
		if F is _B:C=' ALL'
		elif F is _C:C=_AJ
		else:C=''
		D=A.op_expressions(f"GROUP BY{C}",B);G=A.expressions(B,key='grouping_sets');H=A.expressions(B,key='cube');I=A.expressions(B,key='rollup');E=csv(A.seg(G)if G else'',A.seg(H)if H else'',A.seg(I)if I else'',A.seg('WITH TOTALS')if B.args.get('totals')else'',sep=A.GROUPINGS_SEP)
		if B.expressions and E and E.strip()not in(_AR,_AQ):D=f"{D}{A.GROUPINGS_SEP}"
		return f"{D}{E}"
	def having_sql(A,expression):B=A.indent(A.sql(expression,_A));return f"{A.seg("HAVING")}{A.sep()}{B}"
	def connect_sql(A,expression):C=expression;B=A.sql(C,_b);B=A.seg(f"START WITH {B}")if B else'';E=' NOCYCLE'if C.args.get('nocycle')else'';D=A.sql(C,'connect');D=A.seg(f"CONNECT BY{E} {D}");return B+D
	def prior_sql(A,expression):return f"PRIOR {A.sql(expression,_A)}"
	def join_sql(A,expression):
		B=expression
		if not A.SEMI_ANTI_JOIN_WITH_SIDE and B.kind in('SEMI','ANTI'):I=_D
		else:I=B.side
		D=_E.join(A for A in(B.method,'GLOBAL'if B.args.get('global')else _D,I,B.kind,B.hint if A.JOIN_HINTS else _D)if A);E=A.sql(B,'match_condition');E=f" MATCH_CONDITION ({E})"if E else'';C=A.sql(B,_R);F=B.args.get(_Q)
		if not C and F:C=csv(*(A.sql(B)for B in F))
		G=B.this;H=A.sql(G)
		if C:
			C=A.indent(C,skip_first=_B);J=A.seg(_E*A.pad)if A.pretty else _E
			if F:C=f"{J}USING ({C})"
			else:C=f"{J}ON {C}"
		elif not D:
			if isinstance(G,exp.Lateral)and G.args.get(_AS)is not _D:return f" {H}"
			return f", {H}"
		if D!='STRAIGHT_JOIN':D=f"{D} JOIN"if D else'JOIN'
		return f"{A.seg(D)} {H}{E}{C}"
	def lambda_sql(B,expression,arrow_sep='->'):C=expression;A=B.expressions(C,flat=_B);A=f"({A})"if len(A.split(','))>1 else A;return f"{A} {arrow_sep} {B.sql(C,_A)}"
	def lateral_op(C,expression):
		B=expression.args.get(_AS)
		if B is _B:A='INNER JOIN '
		elif B is _C:A='LEFT JOIN '
		else:A=''
		return f"{A}LATERAL"
	def lateral_sql(B,expression):
		C=expression;E=B.sql(C,_A)
		if C.args.get('view'):A=C.args[_H];D=B.expressions(A,key=_i,flat=_B);F=f" {A.name}"if A.name else'';D=f" AS {D}"if D else'';G=B.seg(f"LATERAL VIEW{" OUTER"if C.args.get("outer")else""}");return f"{G}{B.sep()}{E}{F}{D}"
		A=B.sql(C,_H);A=f" AS {A}"if A else'';return f"{B.lateral_op(C)} {E}{A}"
	def limit_sql(A,expression,top=_C):D=expression;F=A.sql(D,_A);E=[A._simplify_unless_literal(B)if A.LIMIT_ONLY_LITERALS else B for B in(D.args.get(A)for A in(_f,_F))if B];B=_J.join(A.sql(B)for B in E);B=f"({B})"if top and any(not A.is_number for A in E)else B;C=A.expressions(D,flat=_B);C=f" BY {C}"if C else'';return f"{F}{A.seg("TOP"if top else"LIMIT")} {B}{C}"
	def offset_sql(A,expression):D=expression;E=A.sql(D,_A);B=D.expression;B=A._simplify_unless_literal(B)if A.LIMIT_ONLY_LITERALS else B;C=A.expressions(D,flat=_B);C=f" BY {C}"if C else'';return f"{E}{A.seg("OFFSET")} {A.sql(B)}{C}"
	def setitem_sql(B,expression):A=expression;C=B.sql(A,_G);C=f"{C} "if C else'';E=B.sql(A,_A);F=B.expressions(A);D=B.sql(A,'collate');D=f" COLLATE {D}"if D else'';G='GLOBAL 'if A.args.get('global')else'';return f"{G}{C}{E}{F}{D}"
	def set_sql(B,expression):A=expression;C=f" {B.expressions(A,flat=_B)}"if A.expressions else'';D=' TAG'if A.args.get('tag')else'';return f"{"UNSET"if A.args.get("unset")else"SET"}{D}{C}"
	def pragma_sql(A,expression):return f"PRAGMA {A.sql(expression,_A)}"
	def lock_sql(B,expression):
		D=expression
		if not B.LOCKING_READS_SUPPORTED:B.unsupported("Locking reads using 'FOR UPDATE/SHARE' are not supported");return''
		E='FOR UPDATE'if D.args['update']else'FOR SHARE';C=B.expressions(D,flat=_B);C=f" OF {C}"if C else'';A=D.args.get('wait')
		if A is not _D:
			if isinstance(A,exp.Literal):A=f" WAIT {B.sql(A)}"
			else:A=' NOWAIT'if A else' SKIP LOCKED'
		return f"{E}{C}{A or""}"
	def literal_sql(A,expression):
		C=expression;B=C.this or''
		if C.is_string:B=f"{A.dialect.QUOTE_START}{A.escape_str(B)}{A.dialect.QUOTE_END}"
		return B
	def escape_str(A,text,escape_backslash=_B):
		B=text
		if A.dialect.ESCAPED_SEQUENCES:C=A.dialect.ESCAPED_SEQUENCES;B=''.join(C.get(A,A)if escape_backslash or A!='\\'else A for A in B)
		return A._replace_line_breaks(B).replace(A.dialect.QUOTE_END,A._escaped_quote_end)
	def loaddata_sql(B,expression):A=expression;F=' LOCAL'if A.args.get(_z)else'';G=f" INPATH {B.sql(A,"inpath")}";H=_AO if A.args.get(_AN)else'';I=f" INTO TABLE {B.sql(A,_A)}";C=B.sql(A,_c);C=f" {C}"if C else'';D=B.sql(A,_AL);D=f" INPUTFORMAT {D}"if D else'';E=B.sql(A,'serde');E=f" SERDE {E}"if E else'';return f"LOAD DATA{F}{G}{H}{I}{C}{D}{E}"
	def null_sql(A,*B):return'NULL'
	def boolean_sql(A,expression):return'TRUE'if expression.this else'FALSE'
	def order_sql(C,expression,flat=_C):B=expression;A=C.sql(B,_A);A=f"{A} "if A else A;D='SIBLINGS 'if B.args.get('siblings')else'';return C.op_expressions(f"{A}ORDER {D}BY",B,flat=A or flat)
	def withfill_sql(A,expression):B=expression;C=A.sql(B,_l);C=f" FROM {C}"if C else'';D=A.sql(B,'to');D=f" TO {D}"if D else'';E=A.sql(B,'step');E=f" STEP {E}"if E else'';F=[f"{A.sql(B,_H)} AS {A.sql(B,_A)}"for B in B.args.get('interpolate')or[]];G=f" INTERPOLATE ({_J.join(F)})"if F else'';return f"WITH FILL{C}{D}{E}{G}"
	def cluster_sql(A,expression):return A.op_expressions('CLUSTER BY',expression)
	def distribute_sql(A,expression):return A.op_expressions('DISTRIBUTE BY',expression)
	def sort_sql(A,expression):return A.op_expressions('SORT BY',expression)
	def ordered_sql(B,expression):
		O=' NULLS LAST';H=' NULLS FIRST';C=expression;D=C.args.get('desc');G=not D;I=C.args.get('nulls_first');P=not I;J=B.dialect.NULL_ORDERING=='nulls_are_large';K=B.dialect.NULL_ORDERING=='nulls_are_small';L=B.dialect.NULL_ORDERING=='nulls_are_last';E=B.sql(C,_A);M=_v if D else' ASC'if D is _C else'';A=''
		if I and(G and J or D and K or L):A=H
		elif P and(G and K or D and J)and not L:A=O
		if A and not B.NULL_ORDERING_SUPPORTED:
			N=C.find_ancestor(exp.Window,exp.Select)
			if isinstance(N,exp.Window)and N.args.get('spec'):B.unsupported(f"'{A.strip()}' translation not supported in window functions");A=''
			elif B.NULL_ORDERING_SUPPORTED is _C and isinstance(C.find_ancestor(exp.AggFunc,exp.Select),exp.AggFunc)and(G and A==O or D and A==H):B.unsupported(f"'{A.strip()}' translation not supported for aggregate functions with {M} sort order");A=''
			elif B.NULL_ORDERING_SUPPORTED is _D:
				if C.this.is_int:B.unsupported(f"'{A.strip()}' translation not supported with positional ordering")
				elif not isinstance(C.this,exp.Rand):Q=_v if A==H else'';E=f"CASE WHEN {E} IS NULL THEN 1 ELSE 0 END{Q}, {E}"
				A=''
		F=B.sql(C,'with_fill');F=f" {F}"if F else'';return f"{E}{M}{A}{F}"
	def matchrecognizemeasure_sql(B,expression):C=expression;A=B.sql(C,'window_frame');A=f"{A} "if A else'';D=B.sql(C,_A);return f"{A}{D}"
	def matchrecognize_sql(A,expression):B=expression;I=A.partition_by_sql(B);J=A.sql(B,_M);C=A.expressions(B,key='measures');C=A.seg(f"MEASURES{A.seg(C)}")if C else'';D=A.sql(B,'rows');D=A.seg(D)if D else'';E=A.sql(B,'after');E=A.seg(E)if E else'';F=A.sql(B,'pattern');F=A.seg(f"PATTERN ({F})")if F else'';K=[f"{A.sql(B,_H)} AS {A.sql(B,_A)}"for B in B.args.get('define',[])];H=A.expressions(sqls=K);L=A.seg(f"DEFINE{A.seg(H)}")if H else'';M=''.join((I,J,C,D,E,F,L));G=A.sql(B,_H);G=f" {G}"if G else'';return f"{A.seg("MATCH_RECOGNIZE")} {A.wrap(M)}{G}"
	def query_modifiers(A,expression,*D):
		B=expression;C=B.args.get(_e)
		if A.LIMIT_FETCH=='LIMIT'and isinstance(C,exp.Fetch):C=exp.Limit(expression=exp.maybe_copy(C.args.get('count')))
		elif A.LIMIT_FETCH=='FETCH'and isinstance(C,exp.Limit):C=exp.Fetch(direction='FIRST',count=exp.maybe_copy(C.expression))
		return csv(*D,*[A.sql(B)for B in B.args.get('joins')or[]],A.sql(B,'connect'),A.sql(B,'match'),*[A.sql(B)for B in B.args.get('laterals')or[]],A.sql(B,'prewhere'),A.sql(B,_V),A.sql(B,_A6),A.sql(B,'having'),*[C(A,B)for C in A.AFTER_HAVING_MODIFIER_TRANSFORMS.values()],A.sql(B,_M),*A.offset_limit_modifiers(B,isinstance(C,exp.Fetch),C),*A.after_limit_modifiers(B),A.options_modifier(B),sep='')
	def options_modifier(B,expression):A=B.expressions(expression,key=_P);return f" {A}"if A else''
	def queryoption_sql(A,expression):return''
	def offset_limit_modifiers(A,expression,fetch,limit):D=limit;C=fetch;B=expression;return[A.sql(B,_f)if C else A.sql(D),A.sql(D)if C else A.sql(B,_f)]
	def after_limit_modifiers(B,expression):C=expression;A=B.expressions(C,key='locks',sep=_E);A=f" {A}"if A else'';return[A,B.sql(C,_k)]
	def select_sql(A,expression):
		L='into';B=expression;E=B.args.get(L)
		if not A.SUPPORTS_SELECT_INTO and E:E.pop()
		K=A.sql(B,'hint');G=A.sql(B,'distinct');G=f" {G}"if G else'';C=A.sql(B,_G);H=B.args.get(_e)
		if isinstance(H,exp.Limit)and A.LIMIT_IS_TOP:I=A.limit_sql(H,top=_B);H.pop()
		else:I=''
		F=A.expressions(B)
		if C:
			if C in A.SELECT_KINDS:C=f" AS {C}"
			else:
				if C=='STRUCT':F=A.expressions(sqls=[A.sql(exp.Struct(expressions=[exp.PropertyEQ(this=A.args.get(_H),expression=A.this)if isinstance(A,exp.Alias)else A for A in B.expressions]))])
				C=''
		M=f"{G}{K}{I}"if A.LIMIT_IS_TOP else f"{I}{K}{G}";F=f"{A.sep()}{F}"if F else F;D=A.query_modifiers(B,f"SELECT{M}{C}{F}",A.sql(B,L,comment=_C),A.sql(B,_l,comment=_C))
		if B.args.get(_h):D=A.maybe_comment(D,B);B.pop_comments()
		D=A.prepend_ctes(B,D)
		if not A.SUPPORTS_SELECT_INTO and E:
			if E.args.get(_A1):J=_A2
			elif A.SUPPORTS_UNLOGGED_TABLES and E.args.get('unlogged'):J=_AP
			else:J=''
			D=f"CREATE{J} TABLE {A.sql(E.this)} AS {D}"
		return D
	def schema_sql(C,expression):D=expression;A=C.sql(D,_A);B=C.schema_columns_sql(D);return f"{A} {B}"if A and B else A or B
	def schema_columns_sql(A,expression):
		B=expression
		if B.expressions:return f"({A.sep("")}{A.expressions(B)}{A.seg(_O,sep="")}"
		return''
	def star_sql(A,expression):E=expression;B=A.expressions(E,key='except',flat=_B);B=f"{A.seg(A.STAR_EXCEPT)} ({B})"if B else'';C=A.expressions(E,key='replace',flat=_B);C=f"{A.seg("REPLACE")} ({C})"if C else'';D=A.expressions(E,key='rename',flat=_B);D=f"{A.seg("RENAME")} ({D})"if D else'';return f"*{B}{C}{D}"
	def parameter_sql(A,expression):B=A.sql(expression,_A);return f"{A.PARAMETER_TOKEN}{B}"
	def sessionparameter_sql(C,expression):
		B=expression;D=C.sql(B,_A);A=B.text(_G)
		if A:A=f"{A}."
		return f"@@{A}{D}"
	def placeholder_sql(B,expression):A=expression;return f"{B.NAMED_PLACEHOLDER_TOKEN}{A.name}"if A.this else'?'
	def subquery_sql(A,expression,sep=' AS '):
		B=expression;C=A.sql(B,_H);C=f"{sep}{C}"if C else'';D=A.sql(B,_k)
		if A.dialect.ALIAS_POST_TABLESAMPLE and D:C=f"{D}{C}";B.set(_k,_D)
		E=A.expressions(B,key='pivots',sep='',flat=_B);F=A.query_modifiers(B,A.wrap(B),C,E);return A.prepend_ctes(B,F)
	def qualify_sql(A,expression):B=A.indent(A.sql(expression,_A));return f"{A.seg("QUALIFY")}{A.sep()}{B}"
	def unnest_sql(B,expression):
		E=expression;G=B.expressions(E,flat=_B);A=E.args.get(_H);C=E.args.get(_f)
		if B.UNNEST_WITH_ORDINALITY:
			if A and isinstance(C,exp.Expression):A.append(_i,C)
		if A and B.dialect.UNNEST_COLUMN_ONLY:F=A.columns;A=B.sql(F[0])if F else''
		else:A=B.sql(A)
		A=f" AS {A}"if A else A
		if B.UNNEST_WITH_ORDINALITY:D=f" WITH ORDINALITY{A}"if C else A
		elif isinstance(C,exp.Expression):D=f"{A} WITH OFFSET AS {B.sql(C)}"
		elif C:D=f"{A} WITH OFFSET"
		else:D=A
		return f"UNNEST({G}){D}"
	def prewhere_sql(A,expression):return''
	def where_sql(A,expression):B=A.indent(A.sql(expression,_A));return f"{A.seg("WHERE")}{A.sep()}{B}"
	def window_sql(B,expression):
		A=expression;E=B.sql(A,_A);G=B.partition_by_sql(A);C=A.args.get(_M);C=B.order_sql(C,flat=_B)if C else'';H=B.sql(A,'spec');F=B.sql(A,_H);I=B.sql(A,'over')or'OVER';E=f"{E} {"AS"if A.arg_key==_g else I}";D=A.args.get('first')
		if D is _D:D=''
		else:D='FIRST'if D else'LAST'
		if not G and not C and not H and F:return f"{E} {F}"
		J=_E.join(A for A in(F,D,G,C,H)if A);return f"{E} ({J})"
	def partition_by_sql(B,expression):A=B.expressions(expression,key=_AK,flat=_B);return f"PARTITION BY {A}"if A else''
	def windowspec_sql(A,expression):B=expression;C=A.sql(B,_G);D=csv(A.sql(B,_b),A.sql(B,'start_side'),sep=_E);E=csv(A.sql(B,_w),A.sql(B,'end_side'),sep=_E)or'CURRENT ROW';return f"{C} BETWEEN {D} AND {E}"
	def withingroup_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,_F)[1:];return f"{C} WITHIN GROUP ({D})"
	def between_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,'low');E=A.sql(B,'high');return f"{C} BETWEEN {D} AND {E}"
	def bracket_offset_expressions(B,expression,index_offset=_D):A=expression;return apply_index_offset(A.this,A.expressions,(index_offset or B.dialect.INDEX_OFFSET)-A.args.get(_f,0))
	def bracket_sql(A,expression):B=expression;C=A.bracket_offset_expressions(B);D=_J.join(A.sql(B)for B in C);return f"{A.sql(B,_A)}[{D}]"
	def all_sql(A,expression):return f"ALL {A.wrap(expression)}"
	def any_sql(C,expression):
		B=expression;A=C.sql(B,_A)
		if isinstance(B.this,(*exp.UNWRAPPED_QUERIES,exp.Paren)):
			if isinstance(B.this,exp.UNWRAPPED_QUERIES):A=C.wrap(A)
			return f"ANY{A}"
		return f"ANY {A}"
	def exists_sql(A,expression):return f"EXISTS{A.wrap(expression)}"
	def case_sql(A,expression):
		C=expression;D=A.sql(C,_A);B=[f"CASE {D}"if D else'CASE']
		for E in C.args['ifs']:B.append(f"WHEN {A.sql(E,_A)}");B.append(f"THEN {A.sql(E,"true")}")
		F=A.sql(C,_L)
		if F:B.append(f"ELSE {F}")
		B.append('END')
		if A.pretty and A.too_wide(B):return A.indent(_K.join(B),skip_first=_B,skip_last=_B)
		return _E.join(B)
	def constraint_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.expressions(B,flat=_B);return f"CONSTRAINT {C} {D}"
	def nextvaluefor_sql(B,expression):C=expression;A=C.args.get(_M);A=f" OVER ({B.order_sql(A,flat=_B)})"if A else'';return f"NEXT VALUE FOR {B.sql(C,_A)}{A}"
	def extract_sql(A,expression):B=expression;C=A.sql(B,_A)if A.EXTRACT_ALLOWS_QUOTES else B.this.name;D=A.sql(B,_F);return f"EXTRACT({C} FROM {D})"
	def trim_sql(C,expression):
		A=expression;D=C.sql(A,_u)
		if D=='LEADING':B='LTRIM'
		elif D=='TRAILING':B='RTRIM'
		else:B='TRIM'
		return C.func(B,A.this,A.expression)
	def convert_concat_args(C,expression):
		D='coalesce';B=expression;A=B.expressions
		if isinstance(B,exp.ConcatWs):A=A[1:]
		if C.dialect.STRICT_STRING_CONCAT and B.args.get(_m):A=[exp.cast(A,exp.DataType.Type.TEXT)for A in A]
		if not C.dialect.CONCAT_COALESCE and B.args.get(D):A=[exp.func(D,A,exp.Literal.string(''))for A in A]
		return A
	def concat_sql(A,expression):
		B=A.convert_concat_args(expression)
		if not A.SUPPORTS_SINGLE_ARG_CONCAT and len(B)==1:return A.sql(B[0])
		return A.func('CONCAT',*B)
	def concatws_sql(A,expression):B=expression;return A.func('CONCAT_WS',seq_get(B.expressions,0),*A.convert_concat_args(B))
	def check_sql(A,expression):B=A.sql(expression,key=_A);return f"CHECK ({B})"
	def foreignkey_sql(A,expression):B=expression;F=A.expressions(B,flat=_B);C=A.sql(B,'reference');C=f" {C}"if C else'';D=A.sql(B,_o);D=f" ON DELETE {D}"if D else'';E=A.sql(B,'update');E=f" ON UPDATE {E}"if E else'';return f"FOREIGN KEY ({F}){C}{D}{E}"
	def primarykey_sql(B,expression):C=expression;D=B.expressions(C,flat=_B);A=B.expressions(C,key=_P,flat=_B,sep=_E);A=f" {A}"if A else'';return f"PRIMARY KEY ({D}){A}"
	def if_sql(B,expression):A=expression;return B.case_sql(exp.Case(ifs=[A],default=A.args.get('false')))
	def matchagainst_sql(C,expression):B=expression;A=B.args.get('modifier');A=f" {A}"if A else'';return f"{C.func("MATCH",*B.expressions)} AGAINST({C.sql(B,_A)}{A})"
	def jsonkeyvalue_sql(A,expression):B=expression;return f"{A.sql(B,_A)}{A.JSON_KEY_VALUE_PAIR_SEP} {A.sql(B,_F)}"
	def jsonpath_sql(A,expression):
		C=expression;B=A.expressions(C,sep='',flat=_B).lstrip('.')
		if C.args.get('escape'):B=A.escape_str(B)
		if A.QUOTE_JSON_PATH:B=f"{A.dialect.QUOTE_START}{B}{A.dialect.QUOTE_END}"
		return B
	def json_path_part(C,expression):
		A=expression
		if isinstance(A,exp.JSONPathPart):
			D=C.TRANSFORMS.get(A.__class__)
			if not callable(D):C.unsupported(f"Unsupported JSONPathPart type {A.__class__.__name__}");return''
			return D(C,A)
		if isinstance(A,int):return str(A)
		if C.JSON_PATH_SINGLE_QUOTE_ESCAPE:B=A.replace("'","\\'");B=f"\\'{A}\\'"
		else:B=A.replace('"','\\"');B=f'"{B}"'
		return B
	def formatjson_sql(A,expression):return f"{A.sql(expression,_A)} FORMAT JSON"
	def jsonobject_sql(F,expression):
		A=expression;C=A.args.get(_A7);C=f" {C}"if C else'';B=A.args.get('unique_keys')
		if B is not _D:B=f" {"WITH"if B else"WITHOUT"} UNIQUE KEYS"
		else:B=''
		D=F.sql(A,_A8);D=f" RETURNING {D}"if D else'';E=F.sql(A,'encoding');E=f" ENCODING {E}"if E else'';return F.func('JSON_OBJECT'if isinstance(A,exp.JSONObject)else'JSON_OBJECTAGG',*A.expressions,suffix=f"{C}{B}{D}{E})")
	def jsonobjectagg_sql(A,expression):return A.jsonobject_sql(expression)
	def jsonarray_sql(D,expression):A=expression;B=A.args.get(_A7);B=f" {B}"if B else'';C=D.sql(A,_A8);C=f" RETURNING {C}"if C else'';E=' STRICT'if A.args.get(_A9)else'';return D.func('JSON_ARRAY',*A.expressions,suffix=f"{B}{C}{E})")
	def jsonarrayagg_sql(B,expression):A=expression;E=B.sql(A,_A);F=B.sql(A,_M);C=A.args.get(_A7);C=f" {C}"if C else'';D=B.sql(A,_A8);D=f" RETURNING {D}"if D else'';G=' STRICT'if A.args.get(_A9)else'';return B.func('JSON_ARRAYAGG',E,suffix=f"{F}{C}{D}{G})")
	def jsoncolumndef_sql(B,expression):
		C=expression;A=B.sql(C,_Y);A=f" PATH {A}"if A else'';E=B.sql(C,'nested_schema')
		if E:return f"NESTED{A} {E}"
		F=B.sql(C,_A);D=B.sql(C,_G);D=f" {D}"if D else'';return f"{F}{D}{A}"
	def jsonschema_sql(A,expression):return A.func('COLUMNS',*expression.expressions)
	def jsontable_sql(B,expression):A=expression;F=B.sql(A,_A);C=B.sql(A,_Y);C=f", {C}"if C else'';D=A.args.get('error_handling');D=f" {D}"if D else'';E=A.args.get('empty_handling');E=f" {E}"if E else'';G=B.sql(A,'schema');return B.func('JSON_TABLE',F,suffix=f"{C}{D}{E} {G})")
	def openjsoncolumndef_sql(C,expression):A=expression;D=C.sql(A,_A);E=C.sql(A,_G);B=C.sql(A,_Y);B=f" {B}"if B else'';F=' AS JSON'if A.args.get('as_json')else'';return f"{D} {E}{B}{F}"
	def openjson_sql(A,expression):C=expression;E=A.sql(C,_A);B=A.sql(C,_Y);B=f", {B}"if B else'';D=A.expressions(C);F=f" WITH ({A.seg(A.indent(D),sep="")}{A.seg(_O,sep="")}"if D else'';return f"OPENJSON({E}{B}){F}"
	def in_sql(B,expression):
		A=expression;D=A.args.get('query');E=A.args.get('unnest');F=A.args.get('field');G=' GLOBAL'if A.args.get('is_global')else''
		if D:C=B.sql(D)
		elif E:C=B.in_unnest_op(E)
		elif F:C=B.sql(F)
		else:C=f"({B.expressions(A,flat=_B)})"
		return f"{B.sql(A,_A)}{G} IN {C}"
	def in_unnest_op(A,unnest):return f"(SELECT {A.sql(unnest)})"
	def interval_sql(C,expression):
		D=expression;A=C.sql(D,'unit')
		if not C.INTERVAL_ALLOWS_PLURAL_FORM:A=C.TIME_PART_SINGULARS.get(A,A)
		A=f" {A}"if A else''
		if C.SINGLE_STRING_INTERVAL:B=D.this.name if D.this else'';return f"INTERVAL '{B}{A}'"if B else f"INTERVAL{A}"
		B=C.sql(D,_A)
		if B:E=isinstance(D.this,C.UNWRAPPED_INTERVAL_VALUES);B=f" {B}"if E else f" ({B})"
		return f"INTERVAL{B}{A}"
	def return_sql(A,expression):return f"RETURN {A.sql(expression,_A)}"
	def reference_sql(C,expression):D=expression;E=C.sql(D,_A);A=C.expressions(D,flat=_B);A=f"({A})"if A else'';B=C.expressions(D,key=_P,flat=_B,sep=_E);B=f" {B}"if B else'';return f"REFERENCES {E}{A}{B}"
	def anonymous_sql(B,expression):A=expression;C=A.parent;D=isinstance(C,exp.Dot)and A is C.expression;return B.func(B.sql(A,_A),*A.expressions,normalize=not D)
	def paren_sql(A,expression):B=A.seg(A.indent(A.sql(expression,_A)),sep='');return f"({B}{A.seg(_O,sep="")}"
	def neg_sql(B,expression):A=B.sql(expression,_A);C=_E if A[0]=='-'else'';return f"-{C}{A}"
	def not_sql(A,expression):return f"NOT {A.sql(expression,_A)}"
	def alias_sql(B,expression):C=expression;A=B.sql(C,_H);A=f" AS {A}"if A else'';return f"{B.sql(C,_A)}{A}"
	def pivotalias_sql(B,expression):
		C=expression;A=C.args[_H];D=isinstance(A,exp.Identifier);E=isinstance(A,exp.Literal)
		if D and not B.UNPIVOT_ALIASES_ARE_IDENTIFIERS:A.replace(exp.Literal.string(A.output_name))
		elif not D and E and B.UNPIVOT_ALIASES_ARE_IDENTIFIERS:A.replace(exp.to_identifier(A.output_name))
		return B.alias_sql(C)
	def aliases_sql(A,expression):B=expression;return f"{A.sql(B,_A)} AS ({A.expressions(B,flat=_B)})"
	def atindex_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,_F);return f"{C} AT {D}"
	def attimezone_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,'zone');return f"{C} AT TIME ZONE {D}"
	def fromtimezone_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,'zone');return f"{C} AT TIME ZONE {D} AT TIME ZONE 'UTC'"
	def add_sql(A,expression):return A.binary(expression,'+')
	def and_sql(A,expression,stack=_D):return A.connector_sql(expression,'AND',stack)
	def or_sql(A,expression,stack=_D):return A.connector_sql(expression,'OR',stack)
	def xor_sql(A,expression,stack=_D):return A.connector_sql(expression,'XOR',stack)
	def connector_sql(B,expression,op,stack=_D):
		C=expression;A=stack
		if A is not _D:
			if C.expressions:A.append(B.expressions(C,sep=f" {op} "))
			else:
				A.append(C.right)
				if C.comments and B.comments:
					for F in C.comments:
						if F:op+=f" /*{B.pad_comment(F)}*/"
				A.extend((op,C.left))
			return op
		A=[C];D=[];G=set()
		while A:
			E=A.pop()
			if isinstance(E,exp.Connector):G.add(getattr(B,f"{E.key}_sql")(E,A))
			else:
				H=B.sql(E)
				if D and D[-1]in G:D[-1]+=f" {H}"
				else:D.append(H)
		I=_K if B.pretty and B.too_wide(D)else _E;return I.join(D)
	def bitwiseand_sql(A,expression):return A.binary(expression,'&')
	def bitwiseleftshift_sql(A,expression):return A.binary(expression,'<<')
	def bitwisenot_sql(A,expression):return f"~{A.sql(expression,_A)}"
	def bitwiseor_sql(A,expression):return A.binary(expression,'|')
	def bitwiserightshift_sql(A,expression):return A.binary(expression,'>>')
	def bitwisexor_sql(A,expression):return A.binary(expression,'^')
	def cast_sql(A,expression,safe_prefix=_D):B=expression;C=A.sql(B,_W);C=f" FORMAT {C}"if C else'';D=A.sql(B,'to');D=f" {D}"if D else'';E=A.sql(B,'action');E=f" {E}"if E else'';return f"{safe_prefix or""}CAST({A.sql(B,_A)} AS{D}{C}{E})"
	def currentdate_sql(B,expression):A=B.sql(expression,_A);return f"CURRENT_DATE({A})"if A else'CURRENT_DATE'
	def collate_sql(A,expression):
		B=expression
		if A.COLLATE_IS_FUNC:return A.function_fallback_sql(B)
		return A.binary(B,'COLLATE')
	def command_sql(B,expression):A=expression;return f"{B.sql(A,_A)} {A.text(_F).strip()}"
	def comment_sql(B,expression):A=expression;C=B.sql(A,_A);D=A.args[_G];E=_AI if A.args.get(_y)else'';F=_A0 if A.args.get(_I)else _E;G=B.sql(A,_F);return f"COMMENT{F}ON{E} {D} {C} IS {G}"
	def mergetreettlaction_sql(B,expression):A=expression;F=B.sql(A,_A);G=' DELETE'if A.args.get(_o)else'';C=B.sql(A,'recompress');C=f" RECOMPRESS {C}"if C else'';D=B.sql(A,'to_disk');D=f" TO DISK {D}"if D else'';E=B.sql(A,'to_volume');E=f" TO VOLUME {E}"if E else'';return f"{F}{G}{C}{D}{E}"
	def mergetreettl_sql(A,expression):
		B=expression;D=A.sql(B,_V);E=A.sql(B,_A6);C=A.expressions(B,key='aggregates');C=A.seg('SET')+A.seg(C)if C else''
		if not(D or E or C)and len(B.expressions)==1:return f"TTL {A.expressions(B,flat=_B)}"
		return f"TTL{A.seg(A.expressions(B))}{D}{E}{C}"
	def transaction_sql(A,expression):return'BEGIN'
	def commit_sql(B,expression):
		A=expression.args.get('chain')
		if A is not _D:A=' AND CHAIN'if A else' AND NO CHAIN'
		return f"COMMIT{A or""}"
	def rollback_sql(B,expression):A=expression.args.get('savepoint');A=f" TO {A}"if A else'';return f"ROLLBACK{A}"
	def altercolumn_sql(B,expression):
		A=expression;C=B.sql(A,_A);F=B.sql(A,'dtype')
		if F:D=B.sql(A,'collate');D=f" COLLATE {D}"if D else'';E=B.sql(A,_Q);E=f" USING {E}"if E else'';return f"ALTER COLUMN {C} SET DATA TYPE {F}{D}{E}"
		G=B.sql(A,_L)
		if G:return f"ALTER COLUMN {C} SET DEFAULT {G}"
		H=B.sql(A,'comment')
		if H:return f"ALTER COLUMN {C} COMMENT {H}"
		I=A.args.get(_AE);J=A.args.get('drop')
		if not J and not I:B.unsupported('Unsupported ALTER COLUMN syntax')
		if I is not _D:K='DROP'if J else'SET';return f"ALTER COLUMN {C} {K} NOT NULL"
		return f"ALTER COLUMN {C} DROP DEFAULT"
	def alterdiststyle_sql(C,expression):
		B=expression;A=C.sql(B,_A)
		if not isinstance(B.this,exp.Var):A=f"KEY DISTKEY {A}"
		return f"ALTER DISTSTYLE {A}"
	def altersortkey_sql(C,expression):B=expression;D=' COMPOUND'if B.args.get('compound')else'';E=C.sql(B,_A);A=C.expressions(B,flat=_B);A=f"({A})"if A else'';return f"ALTER{D} SORTKEY {E or A}"
	def renametable_sql(B,expression):
		A=expression
		if not B.RENAME_TABLE_WITH_DB:A=A.transform(lambda n:exp.table_(n.this)if isinstance(n,exp.Table)else n).assert_is(exp.RenameTable)
		C=B.sql(A,_A);return f"RENAME TO {C}"
	def renamecolumn_sql(B,expression):A=expression;C=_a if A.args.get(_I)else'';D=B.sql(A,_A);E=B.sql(A,'to');return f"RENAME COLUMN{C} {D} TO {E}"
	def alterset_sql(A,expression):B=A.expressions(expression,flat=_B);return f"SET {B}"
	def alter_sql(C,expression):
		A=expression;B=A.args[_S]
		if isinstance(B[0],exp.ColumnDef):B=C.add_column_sql(A)
		elif isinstance(B[0],exp.Schema):B=C.expressions(A,key=_S,prefix='ADD COLUMNS ')
		elif isinstance(B[0],exp.Delete):B=C.expressions(A,key=_S,flat=_B)
		elif isinstance(B[0],exp.Query):B='AS '+C.expressions(A,key=_S)
		else:B=C.expressions(A,key=_S,flat=_B)
		F=_a if A.args.get(_I)else'';D=C.sql(A,_U);D=f" {D}"if D else'';G=' ONLY'if A.args.get('only')else'';E=C.expressions(A,key=_P);E=f", {E}"if E else'';H=C.sql(A,_G);I=' NOT VALID'if A.args.get('not_valid')else'';return f"ALTER {H}{F}{G} {C.sql(A,_A)}{D} {B}{I}{E}"
	def add_column_sql(A,expression):
		B=expression
		if A.ALTER_TABLE_INCLUDE_COLUMN_KEYWORD:return A.expressions(B,key=_S,prefix='ADD COLUMN ',skip_first=_B)
		return f"ADD {A.expressions(B,key=_S,flat=_B)}"
	def droppartition_sql(B,expression):A=expression;C=B.expressions(A);D=_A0 if A.args.get(_I)else _E;return f"DROP{D}{C}"
	def addconstraint_sql(A,expression):return f"ADD {A.expressions(expression)}"
	def distinct_sql(B,expression):
		C=expression;A=B.expressions(C,flat=_B)
		if not B.MULTI_ARG_DISTINCT and len(C.expressions)>1:
			E=exp.case()
			for F in C.expressions:E=E.when(F.is_(exp.null()),exp.null())
			A=B.sql(E.else_(f"({A})"))
		A=f" {A}"if A else'';D=B.sql(C,_R);D=f" ON {D}"if D else'';return f"DISTINCT{A}{D}"
	def ignorenulls_sql(A,expression):return A._embed_ignore_nulls(expression,'IGNORE NULLS')
	def respectnulls_sql(A,expression):return A._embed_ignore_nulls(expression,'RESPECT NULLS')
	def havingmax_sql(B,expression):A=expression;C=B.sql(A,_A);D=B.sql(A,_F);E='MAX'if A.args.get('max')else'MIN';return f"{C} HAVING {E} {D}"
	def intdiv_sql(B,expression):A=expression;return B.sql(exp.Cast(this=exp.Div(this=A.this,expression=A.expression),to=exp.DataType(this=exp.DataType.Type.INT)))
	def dpipe_sql(A,expression):
		B=expression
		if A.dialect.STRICT_STRING_CONCAT and B.args.get(_m):return A.func('CONCAT',*(exp.cast(A,exp.DataType.Type.TEXT)for A in B.flatten()))
		return A.binary(B,'||')
	def div_sql(B,expression):
		E='typed';A=expression;C,D=A.left,A.right
		if not B.dialect.SAFE_DIVISION and A.args.get(_m):D.replace(exp.Nullif(this=D.copy(),expression=exp.Literal.number(0)))
		if B.dialect.TYPED_DIVISION and not A.args.get(E):
			if not C.is_type(*exp.DataType.REAL_TYPES)and not D.is_type(*exp.DataType.REAL_TYPES):C.replace(exp.cast(C.copy(),to=exp.DataType.Type.DOUBLE))
		elif not B.dialect.TYPED_DIVISION and A.args.get(E):
			if C.is_type(*exp.DataType.INTEGER_TYPES)and D.is_type(*exp.DataType.INTEGER_TYPES):return B.sql(exp.cast(C/D,to=exp.DataType.Type.BIGINT))
		return B.binary(A,'/')
	def overlaps_sql(A,expression):return A.binary(expression,'OVERLAPS')
	def distance_sql(A,expression):return A.binary(expression,'<->')
	def dot_sql(A,expression):B=expression;return f"{A.sql(B,_A)}.{A.sql(B,_F)}"
	def eq_sql(A,expression):return A.binary(expression,'=')
	def propertyeq_sql(A,expression):return A.binary(expression,':=')
	def escape_sql(A,expression):return A.binary(expression,'ESCAPE')
	def glob_sql(A,expression):return A.binary(expression,'GLOB')
	def gt_sql(A,expression):return A.binary(expression,'>')
	def gte_sql(A,expression):return A.binary(expression,'>=')
	def ilike_sql(A,expression):return A.binary(expression,'ILIKE')
	def ilikeany_sql(A,expression):return A.binary(expression,'ILIKE ANY')
	def is_sql(B,expression):
		A=expression
		if not B.IS_BOOL_ALLOWED and isinstance(A.expression,exp.Boolean):return B.sql(A.this if A.expression.this else exp.not_(A.this))
		return B.binary(A,'IS')
	def like_sql(A,expression):return A.binary(expression,'LIKE')
	def likeany_sql(A,expression):return A.binary(expression,'LIKE ANY')
	def similarto_sql(A,expression):return A.binary(expression,'SIMILAR TO')
	def lt_sql(A,expression):return A.binary(expression,'<')
	def lte_sql(A,expression):return A.binary(expression,'<=')
	def mod_sql(A,expression):return A.binary(expression,'%')
	def mul_sql(A,expression):return A.binary(expression,'*')
	def neq_sql(A,expression):return A.binary(expression,'<>')
	def nullsafeeq_sql(A,expression):return A.binary(expression,'IS NOT DISTINCT FROM')
	def nullsafeneq_sql(A,expression):return A.binary(expression,'IS DISTINCT FROM')
	def slice_sql(A,expression):return A.binary(expression,':')
	def sub_sql(A,expression):return A.binary(expression,'-')
	def trycast_sql(A,expression):return A.cast_sql(expression,safe_prefix='TRY_')
	def try_sql(A,expression):
		B=expression
		if not A.TRY_SUPPORTED:A.unsupported('Unsupported TRY function');return A.sql(B,_A)
		return A.func('TRY',B.this)
	def log_sql(A,expression):
		D=expression;B=D.this;C=D.expression
		if A.dialect.LOG_BASE_FIRST is _C:B,C=C,B
		elif A.dialect.LOG_BASE_FIRST is _D and C:
			if B.name in('2','10'):return A.func(f"LOG{B.name}",C)
			A.unsupported(f"Unsupported logarithm with base {A.sql(B)}")
		return A.func('LOG',B,C)
	def use_sql(C,expression):D=expression;A=C.sql(D,_G);A=f" {A}"if A else'';B=C.sql(D,_A);B=f" {B}"if B else'';return f"USE{A}{B}"
	def binary(C,expression,op):
		D=expression;E=[];B=[D];G=type(D)
		while B:
			A=B.pop()
			if type(A)is G:
				F=A.args.get('operator')
				if F:op=f"OPERATOR({C.sql(F)})"
				B.append(A.right);B.append(f" {C.maybe_comment(op,comments=A.comments)} ");B.append(A.left)
			else:E.append(C.sql(A))
		return''.join(E)
	def function_fallback_sql(D,expression):
		A=expression;C=[]
		for F in A.arg_types:
			B=A.args.get(F)
			if isinstance(B,list):
				for G in B:C.append(G)
			elif B is not _D:C.append(B)
		if D.normalize_functions:E=A.sql_name()
		else:E=A._meta and A.meta.get('name')or A.sql_name()
		return D.func(E,*C)
	def func(B,name,*C,prefix='(',suffix=_O,normalize=_B):A=name;A=B.normalize_func(A)if normalize else A;return f"{A}{prefix}{B.format_args(*C)}{suffix}"
	def format_args(A,*C):
		B=tuple(A.sql(B)for B in C if B is not _D and not isinstance(B,bool))
		if A.pretty and A.too_wide(B):return A.indent(_K+',\n'.join(B)+_K,skip_first=_B,skip_last=_B)
		return _J.join(B)
	def too_wide(A,args):return sum(len(A)for A in args)>A.max_text_width
	def format_time(A,expression,inverse_time_mapping=_D,inverse_time_trie=_D):return format_time(A.sql(expression,_W),inverse_time_mapping or A.dialect.INVERSE_TIME_MAPPING,inverse_time_trie or A.dialect.INVERSE_TIME_TRIE)
	def expressions(A,expression=_D,key=_D,sqls=_D,flat=_C,indent=_B,skip_first=_C,skip_last=_C,sep=_J,prefix='',dynamic=_C,new_line=_C):
		K=expression;G=prefix;C=sep;D=K.args.get(key or _X)if K else sqls
		if not D:return''
		if flat:return C.join(A for A in(A.sql(B)for B in D)if A)
		L=len(D);B=[]
		for(H,I)in enumerate(D):
			E=A.sql(I,comment=_C)
			if not E:continue
			F=A.maybe_comment('',I)if isinstance(I,exp.Expression)else''
			if A.pretty:
				if A.leading_comma:B.append(f"{C if H>0 else""}{G}{E}{F}")
				else:B.append(f"{G}{E}{(C.rstrip()if F else C)if H+1<L else""}{F}")
			else:B.append(f"{G}{E}{F}{C if H+1<L else""}")
		if A.pretty and(not dynamic or A.too_wide(B)):
			if new_line:B.insert(0,'');B.append('')
			J=_K.join(A.rstrip()for A in B)
		else:J=''.join(B)
		return A.indent(J,skip_first=skip_first,skip_last=skip_last)if indent else J
	def op_expressions(B,op,expression,flat=_C):
		D=expression;A=flat;A=A or isinstance(D.parent,exp.Properties);C=B.expressions(D,flat=A)
		if A:return f"{op} {C}"
		return f"{B.seg(op)}{B.sep()if C else""}{C}"
	def naked_property(B,expression):
		A=expression;C=exp.Properties.PROPERTY_TO_NAME.get(A.__class__)
		if not C:B.unsupported(f"Unsupported property {A.__class__.__name__}")
		return f"{C} {B.sql(A,_A)}"
	def tag_sql(B,expression):A=expression;return f"{A.args.get("prefix")}{B.sql(A.this)}{A.args.get("postfix")}"
	def token_sql(B,token_type):A=token_type;return B.TOKEN_MAPPING.get(A,A.name)
	def userdefinedfunction_sql(A,expression):C=expression;D=A.sql(C,_A);B=A.no_identify(A.expressions,C);B=A.wrap(B)if C.args.get('wrapped')else f" {B}";return f"{D}{B}"
	def joinhint_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.expressions(B,flat=_B);return f"{C}({D})"
	def kwarg_sql(A,expression):return A.binary(expression,'=>')
	def when_sql(B,expression):
		E=expression;G='MATCHED'if E.args['matched']else'NOT MATCHED';H=' BY SOURCE'if B.MATCHED_BY_SOURCE and E.args.get(_A5)else'';F=B.sql(E,_AT);F=f" AND {F}"if F else'';A=E.args.get('then')
		if isinstance(A,exp.Insert):D=B.sql(A,_A);D=f"INSERT {D}"if D else'INSERT';C=B.sql(A,_F);C=f"{D} VALUES {C}"if C else D
		elif isinstance(A,exp.Update):
			if isinstance(A.args.get(_X),exp.Star):C=f"UPDATE {B.sql(A,_X)}"
			else:C=f"UPDATE SET {B.expressions(A,flat=_B)}"
		else:C=B.sql(A)
		return f"WHEN {G}{H}{F} THEN {C}"
	def merge_sql(A,expression):
		B=expression;C=B.this;F='';G=C.args.get('hints')
		if G and C.alias and isinstance(G[0],exp.WithTableHint):F=f" AS {A.sql(C.args[_H].pop())}"
		I=A.sql(C);J=f"USING {A.sql(B,_Q)}";K=f"ON {A.sql(B,_R)}";D=A.expressions(B,sep=_E,indent=_C);H=A.sql(B,_d)
		if H:D=f"{D}{H}"
		E=A.sep();return A.prepend_ctes(B,f"MERGE INTO {I}{F}{E}{J}{E}{K}{E}{D}")
	@unsupported_args(_W)
	def tochar_sql(self,expression):return self.sql(exp.cast(expression.this,exp.DataType.Type.TEXT))
	def tonumber_sql(A,expression):
		B=expression
		if not A.SUPPORTS_TO_NUMBER:A.unsupported('Unsupported TO_NUMBER function');return A.sql(exp.cast(B.this,exp.DataType.Type.DOUBLE))
		C=B.args.get(_W)
		if not C:A.unsupported('Conversion format is required for TO_NUMBER');return A.sql(exp.cast(B.this,exp.DataType.Type.DOUBLE))
		return A.func('TO_NUMBER',B.this,C)
	def dictproperty_sql(A,expression):B=expression;D=A.sql(B,_A);E=A.sql(B,_G);C=A.expressions(B,key='settings',sep=_E);F=f"({A.sep("")}{C}{A.seg(_O,sep="")}"if C else'()';return f"{D}({E}{F})"
	def dictrange_sql(A,expression):B=expression;C=A.sql(B,_A);max=A.sql(B,'max');min=A.sql(B,'min');return f"{C}(MIN {min} MAX {max})"
	def dictsubproperty_sql(A,expression):B=expression;return f"{A.sql(B,_A)} {A.sql(B,_A3)}"
	def duplicatekeyproperty_sql(A,expression):return f"DUPLICATE KEY ({A.expressions(expression,flat=_B)})"
	def distributedbyproperty_sql(A,expression):B=expression;C=A.expressions(B,flat=_B);C=f" {A.wrap(C)}"if C else'';D=A.sql(B,'buckets');E=A.sql(B,_G);D=f" BUCKETS {D}"if D else'';F=A.sql(B,_M);return f"DISTRIBUTED BY {E}{C}{D}{F}"
	def oncluster_sql(A,expression):return''
	def clusteredbyproperty_sql(B,expression):C=expression;D=B.expressions(C,key=_X,flat=_B);A=B.expressions(C,key='sorted_by',flat=_B);A=f" SORTED BY ({A})"if A else'';E=B.sql(C,'buckets');return f"CLUSTERED BY ({D}){A} INTO {E} BUCKETS"
	def anyvalue_sql(A,expression):
		B=expression;C=A.sql(B,_A);D=A.sql(B,'having')
		if D:C=f"{C} HAVING {"MAX"if B.args.get("max")else"MIN"} {D}"
		return A.func('ANY_VALUE',C)
	def querytransform_sql(A,expression):B=expression;H=A.func(_AA,*B.expressions);C=A.sql(B,'row_format_before');C=f" {C}"if C else'';D=A.sql(B,'record_writer');D=f" RECORDWRITER {D}"if D else'';I=f" USING {A.sql(B,"command_script")}";E=A.sql(B,'schema');E=f" AS {E}"if E else'';F=A.sql(B,'row_format_after');F=f" {F}"if F else'';G=A.sql(B,'record_reader');G=f" RECORDREADER {G}"if G else'';return f"{H}{C}{D}{I}{E}{F}{G}"
	def indexconstraintoption_sql(A,expression):
		B=expression;C=A.sql(B,'key_block_size')
		if C:return f"KEY_BLOCK_SIZE = {C}"
		D=A.sql(B,_Q)
		if D:return f"USING {D}"
		E=A.sql(B,'parser')
		if E:return f"WITH PARSER {E}"
		F=A.sql(B,'comment')
		if F:return f"COMMENT {F}"
		G=B.args.get('visible')
		if G is not _D:return'VISIBLE'if G else'INVISIBLE'
		H=A.sql(B,'engine_attr')
		if H:return f"ENGINE_ATTRIBUTE = {H}"
		I=A.sql(B,'secondary_engine_attr')
		if I:return f"SECONDARY_ENGINE_ATTRIBUTE = {I}"
		A.unsupported('Unsupported index constraint option.');return''
	def checkcolumnconstraint_sql(B,expression):A=expression;C=' ENFORCED'if A.args.get('enforced')else'';return f"CHECK ({B.sql(A,_A)}){C}"
	def indexcolumnconstraint_sql(A,expression):B=expression;C=A.sql(B,_G);C=f"{C} INDEX"if C else'INDEX';D=A.sql(B,_A);D=f" {D}"if D else'';E=A.sql(B,_AF);E=f" USING {E}"if E else'';F=A.expressions(B,flat=_B);F=f" ({F})"if F else'';G=A.expressions(B,key=_P,sep=_E);G=f" {G}"if G else'';return f"{C}{D}{E}{F}{G}"
	def nvl2_sql(B,expression):
		A=expression
		if B.NVL2_SUPPORTED:return B.function_fallback_sql(A)
		C=exp.Case().when(A.this.is_(exp.null()).not_(copy=_C),A.args['true'],copy=_C);D=A.args.get('false')
		if D:C.else_(D,copy=_C)
		return B.sql(C)
	def comprehension_sql(A,expression):B=expression;D=A.sql(B,_A);E=A.sql(B,_F);F=A.sql(B,'iterator');C=A.sql(B,_AT);C=f" IF {C}"if C else'';return f"{D} FOR {E} IN {F}{C}"
	def columnprefix_sql(A,expression):B=expression;return f"{A.sql(B,_A)}({A.sql(B,_F)})"
	def opclass_sql(A,expression):B=expression;return f"{A.sql(B,_A)} {A.sql(B,_F)}"
	def predict_sql(A,expression):B=expression;D=A.sql(B,_A);D=f"MODEL {D}";C=A.sql(B,_F);C=f"TABLE {C}"if not isinstance(B.expression,exp.Subquery)else C;E=A.sql(B,'params_struct');return A.func('PREDICT',D,C,E or _D)
	def forin_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,_F);return f"FOR {C} DO {D}"
	def refresh_sql(B,expression):A=expression;C=B.sql(A,_A);D=''if isinstance(A.this,exp.Literal)else'TABLE ';return f"REFRESH {D}{C}"
	def toarray_sql(B,expression):
		A=expression.this
		if not A.type:from sqlglot.optimizer.annotate_types import annotate_types as C;A=C(A)
		if A.is_type(exp.DataType.Type.ARRAY):return B.sql(A)
		D=A.is_(exp.null());return B.sql(exp.func('IF',D,exp.null(),exp.array(A,copy=_C)))
	def tsordstotime_sql(B,expression):
		A=expression.this
		if isinstance(A,exp.TsOrDsToTime)or A.is_type(exp.DataType.Type.TIME):return B.sql(A)
		return B.sql(exp.cast(A,exp.DataType.Type.TIME))
	def tsordstotimestamp_sql(B,expression):
		A=expression.this
		if isinstance(A,exp.TsOrDsToTimestamp)or A.is_type(exp.DataType.Type.TIMESTAMP):return B.sql(A)
		return B.sql(exp.cast(A,exp.DataType.Type.TIMESTAMP))
	def tsordstodate_sql(A,expression):
		C=expression;B=C.this;D=A.format_time(C)
		if D and D not in(A.dialect.TIME_FORMAT,A.dialect.DATE_FORMAT):return A.sql(exp.cast(exp.StrToTime(this=B,format=C.args[_W]),exp.DataType.Type.DATE))
		if isinstance(B,exp.TsOrDsToDate)or B.is_type(exp.DataType.Type.DATE):return A.sql(B)
		return A.sql(exp.cast(B,exp.DataType.Type.DATE))
	def unixdate_sql(A,expression):return A.sql(exp.func('DATEDIFF',expression.this,exp.cast(exp.Literal.string('1970-01-01'),exp.DataType.Type.DATE),'day'))
	def lastday_sql(A,expression):
		B=expression
		if A.LAST_DAY_SUPPORTS_DATE_PART:return A.function_fallback_sql(B)
		C=B.text('unit')
		if C and C!='MONTH':A.unsupported('Date parts are not supported in LAST_DAY.')
		return A.func('LAST_DAY',B.this)
	def dateadd_sql(B,expression):A=expression;from sqlglot.dialects.dialect import unit_to_str as C;return B.func('DATE_ADD',A.this,A.expression,C(A))
	def arrayany_sql(A,expression):
		B=expression
		if A.CAN_IMPLEMENT_ARRAY_ANY:C=exp.ArrayFilter(this=B.this,expression=B.expression);D=exp.ArraySize(this=C).neq(0);E=exp.ArraySize(this=B.this).eq(0);return A.sql(exp.paren(E.or_(D)))
		from sqlglot.dialects import Dialect as F
		if A.dialect.__class__!=F:A.unsupported('ARRAY_ANY is unsupported')
		return A.function_fallback_sql(B)
	def struct_sql(B,expression):A=expression;A.set(_X,[exp.alias_(A.expression,A.name if A.this.is_string else A.this)if isinstance(A,exp.PropertyEQ)else A for A in A.expressions]);return B.function_fallback_sql(A)
	def partitionrange_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,_F);return f"{C} TO {D}"
	def truncatetable_sql(B,expression):A=expression;G='DATABASE'if A.args.get('is_database')else'TABLE';H=f" {B.expressions(A)}";I=_a if A.args.get(_I)else'';C=B.sql(A,_U);C=f" {C}"if C else'';D=B.sql(A,'identity');D=f" {D} IDENTITY"if D else'';E=B.sql(A,'option');E=f" {E}"if E else'';F=B.sql(A,_c);F=f" {F}"if F else'';return f"TRUNCATE {G}{I}{H}{C}{D}{E}{F}"
	def convert_sql(E,expression):
		D=expression;A=D.this;C=D.expression;G=D.args.get('style');H=D.args.get(_m);L=D.args.get(_A9)
		if not A or not C:return''
		if not seq_get(A.expressions,0)and A.this in E.PARAMETERIZABLE_TEXT_TYPES:A=exp.DataType.build(A.this,expressions=[exp.Literal.number(30)],nested=_C)
		B=_D;I=exp.Cast if L else exp.TryCast
		if isinstance(G,exp.Literal)and G.is_int:
			from sqlglot.dialects.tsql import TSQL;J=G.name;K=TSQL.CONVERT_FORMAT_MAPPING.get(J)
			if not K:E.unsupported(f"Unsupported T-SQL 'style' value: {J}")
			F=exp.Literal.string(K)
			if A.this==exp.DataType.Type.DATE:B=exp.StrToDate(this=C,format=F)
			elif A.this==exp.DataType.Type.DATETIME:B=exp.StrToTime(this=C,format=F)
			elif A.this in E.PARAMETERIZABLE_TEXT_TYPES:B=I(this=exp.TimeToStr(this=C,format=F),to=A,safe=H)
			elif A.this==exp.DataType.Type.TEXT:B=exp.TimeToStr(this=C,format=F)
		if not B:B=I(this=C,to=A,safe=H)
		return E.sql(B)
	def _jsonpathkey_sql(B,expression):
		A=expression.this
		if isinstance(A,exp.JSONPathWildcard):A=B.json_path_part(A);return f".{A}"if A else''
		if exp.SAFE_IDENTIFIER_RE.match(A):return f".{A}"
		A=B.json_path_part(A);return f"[{A}]"if B.JSON_PATH_BRACKETED_KEY_SUPPORTED else f".{A}"
	def _jsonpathsubscript_sql(B,expression):A=B.json_path_part(expression.this);return f"[{A}]"if A else''
	def _simplify_unless_literal(B,expression):
		A=expression
		if not isinstance(A,exp.Literal):from sqlglot.optimizer.simplify import simplify as C;A=C(A,dialect=B.dialect)
		return A
	def _embed_ignore_nulls(B,expression,text):
		G='inline';A=expression
		if B.IGNORE_NULLS_IN_FUNC and not A.meta.get(G):
			C=sorted(A.find_all(exp.HavingMax,exp.Order,exp.Limit),key=lambda x:0 if isinstance(x,exp.HavingMax)else 1 if isinstance(x,exp.Order)else 2)
			if C:D=C[0];E=A.__class__(this=D.this.copy());E.meta[G]=_B;D.this.replace(E);return B.sql(A.this)
			F=A.find(exp.AggFunc)
			if F:return B.sql(F)[:-1]+f" {text})"
		return f"{B.sql(A,_A)} {text}"
	def _replace_line_breaks(A,string):
		"We don't want to extra indent line breaks so we temporarily replace them with sentinels.";B=string
		if A.pretty:return B.replace(_K,A.SENTINEL_LINE_BREAK)
		return B
	def copyparameter_sql(A,expression):
		G=' = ';B=expression;C=A.sql(B,_A)
		if B.expressions:E=C.upper();H=_E if E=='FILE_FORMAT'else _J;D=_E if E in('COPY_OPTIONS','FORMAT_OPTIONS')else G;I=A.expressions(B,flat=_B,sep=H);return f"{C}{D}({I})"
		F=A.sql(B,_F)
		if not F:return C
		D=G if A.COPY_PARAMS_EQ_REQUIRED else _E;return f"{C}{D}{F}"
	def credentials_sql(C,expression):
		A=expression;H=A.args.get(_n)
		if isinstance(H,exp.Literal):B=C.sql(A,_n);B=f"CREDENTIALS {B}"if B else''
		else:B=C.expressions(A,key=_n,flat=_B,sep=_E);B=f"CREDENTIALS = ({B})"if H is not _D else''
		D=C.sql(A,'storage');D=f"STORAGE_INTEGRATION = {D}"if D else'';E=C.expressions(A,key='encryption',flat=_B,sep=_E);E=f" ENCRYPTION = ({E})"if E else'';F=C.sql(A,'iam_role');F=f"IAM_ROLE {F}"if F else'';G=C.sql(A,'region');G=f" REGION {G}"if G else'';return f"{B}{D}{E}{F}{G}"
	def copy_sql(A,expression):
		C=expression;D=A.sql(C,_A);D=f" INTO {D}"if A.COPY_HAS_INTO_KEYWORD else f" {D}";E=A.sql(C,_n);E=A.seg(E)if E else'';F=A.seg('FROM'if C.args.get(_G)else'TO');G=A.expressions(C,key='files',flat=_B);H=_J if A.dialect.COPY_PARAMS_ARE_CSV else _E;B=A.expressions(C,key='params',sep=H,new_line=_B,skip_last=_B,skip_first=_B,indent=A.COPY_PARAMS_ARE_WRAPPED)
		if B:
			if A.COPY_PARAMS_ARE_WRAPPED:B=f" WITH ({B})"
			elif not A.pretty:B=f" {B}"
		return f"COPY{D}{F} {G}{E}{B}"
	def semicolon_sql(A,expression):return''
	def datadeletionproperty_sql(C,expression):
		D=expression;E=_N if D.args.get(_R)else'OFF';A=C.sql(D,'filter_column');A=f"FILTER_COLUMN={A}"if A else _D;B=C.sql(D,_AM);B=f"RETENTION_PERIOD={B}"if B else _D
		if A or B:E=C.func(_N,A,B)
		return f"DATA_DELETION={E}"
	def maskingpolicycolumnconstraint_sql(B,expression):C=expression;D=B.sql(C,_A);A=B.expressions(C,flat=_B);A=f" USING ({A})"if A else'';return f"MASKING POLICY {D}{A}"
	def gapfill_sql(B,expression):C=expression;A=B.sql(C,_A);A=f"TABLE {A}";return B.func('GAP_FILL',A,*[B for(A,B)in C.args.items()if A!=_A])
	def scope_resolution(A,rhs,scope_name):return A.func('SCOPE_RESOLUTION',scope_name or _D,rhs)
	def scoperesolution_sql(B,expression):
		C=expression;D=B.sql(C,_A);A=C.expression
		if isinstance(A,exp.Func):A=f"{B.sql(A,_A)}({B.format_args(*A.expressions)})"
		else:A=B.sql(C,_F)
		return B.scope_resolution(A,D)
	def parsejson_sql(A,expression):
		B=expression
		if A.PARSE_JSON_NAME is _D:return A.sql(B.this)
		return A.func(A.PARSE_JSON_NAME,B.this,B.expression)
	def rand_sql(A,expression):
		E='RAND';B=expression;C=A.sql(B,'lower');D=A.sql(B,'upper')
		if C and D:return f"({D} - {C}) * {A.func(E,B.this)} + {C}"
		return A.func(E,B.this)
	def changes_sql(A,expression):D=expression;E=A.sql(D,'information');E=f"INFORMATION => {E}";B=A.sql(D,'at_before');B=f"{A.seg("")}{B}"if B else'';C=A.sql(D,_w);C=f"{A.seg("")}{C}"if C else'';return f"CHANGES ({E}){B}{C}"
	def pad_sql(B,expression):
		A=expression;D='L'if A.args.get('is_left')else'R';C=B.sql(A,'fill_pattern')or _D
		if not C and B.PAD_FILL_PATTERN_IS_REQUIRED:C="' '"
		return B.func(f"{D}PAD",A.this,A.expression,C)
	def summarize_sql(B,expression):A=expression;C=' TABLE'if A.args.get(_t)else'';return f"SUMMARIZE{C} {B.sql(A.this)}"
	def explodinggenerateseries_sql(B,expression):
		C=expression;D=exp.GenerateSeries(**C.args);A=C.parent
		if isinstance(A,(exp.Alias,exp.TableAlias)):A=A.parent
		if B.SUPPORTS_EXPLODING_PROJECTIONS and not isinstance(A,(exp.Table,exp.Unnest)):return B.sql(exp.Unnest(expressions=[D]))
		if isinstance(A,exp.Select):B.unsupported('GenerateSeries projection unnesting is not supported.')
		return B.sql(D)
	def arrayconcat_sql(A,expression,name='ARRAY_CONCAT'):
		B=expression;D=B.expressions
		if not A.ARRAY_CONCAT_IS_VAR_LEN:C=reduce(lambda x,y:exp.ArrayConcat(this=x,expressions=[y]),D)
		else:C=A.expressions(B)
		return A.func(name,B.this,C)
	def converttimezone_sql(C,expression):
		A=expression
		if C.SUPPORTS_CONVERT_TIMEZONE:return C.function_fallback_sql(A)
		D=A.args.get('source_tz');E=A.args.get('target_tz');B=A.args.get('timestamp')
		if D and B:B=exp.AtTimeZone(this=exp.cast(B,exp.DataType.Type.TIMESTAMPNTZ),zone=D)
		F=exp.AtTimeZone(this=B,zone=E);return C.sql(F)
	def json_sql(E,expression):
		B=expression;A=E.sql(B,_A);A=f" {A}"if A else'';D=B.args.get(_h)
		if D is _D:C=''
		elif not D:C=' WITHOUT'
		else:C=' WITH'
		F=' UNIQUE KEYS'if B.args.get(_x)else'';return f"JSON{A}{C}{F}"
	def jsonvalue_sql(A,expression):
		B=expression
		def F(arg):B=arg;return B if isinstance(B,str)else f"DEFAULT {A.sql(B)}"
		E=A.sql(B,_Y);C=A.sql(B,_d);C=f" RETURNING {C}"if C else'';D=A.sql(B,_AU);D=f" {D}"if D else'';return A.func('JSON_VALUE',B.this,f"{E}{C}{D}")
	def conditionalinsert_sql(C,expression):B=expression;D='ELSE 'if B.args.get('else_')else'';A=C.sql(B,_F);A=f"WHEN {A} THEN "if A else D;E=C.sql(B,_A)[len('INSERT'):].strip();return f"{A}{E}"
	def multitableinserts_sql(A,expression):B=expression;C=A.sql(B,_G);D=A.seg(A.expressions(B,sep=_E));E=f"INSERT {C}{D}{A.seg(A.sql(B,_A5))}";return E
	def oncondition_sql(D,expression):
		F='error';E='empty';C=expression;A=C.args.get(E);A=f"DEFAULT {A} ON EMPTY"if isinstance(A,exp.Expression)else D.sql(C,E);B=C.args.get(F);B=f"DEFAULT {B} ON ERROR"if isinstance(B,exp.Expression)else D.sql(C,F)
		if B and A:B=f"{A} {B}"if D.dialect.ON_CONDITION_EMPTY_BEFORE_ERROR else f"{B} {A}";A=''
		G=D.sql(C,_p);return f"{A}{B}{G}"
	def jsonexists_sql(A,expression):B=expression;F=A.sql(B,_A);E=A.sql(B,_Y);C=A.expressions(B,'passing');C=f" PASSING {C}"if C else'';D=A.sql(B,_AU);D=f" {D}"if D else'';E=f"{E}{C}{D}";return A.func('JSON_EXISTS',F,E)
	def arrayagg_sql(B,expression):
		A=expression;C=B.function_fallback_sql(A)
		if B.dialect.ARRAY_AGG_INCLUDES_NULLS and A.args.get('nulls_excluded'):
			D=A.parent
			if isinstance(D,exp.Filter):E=D.expression.this;E.replace(E.and_(A.this.is_(exp.null()).not_()))
			else:F=A.this;G=B.expressions(F)if isinstance(F,exp.Distinct)else B.sql(A,_A);C=f"{C} FILTER(WHERE {G} IS NOT NULL)"
		return C
	def apply_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,_F);return f"{C} APPLY({D})"
	def grant_sql(B,expression):A=expression;E=B.expressions(A,key='privileges',flat=_B);C=B.sql(A,_G);C=f" {C}"if C else'';D=B.sql(A,'securable');D=f" {D}"if D else'';F=B.expressions(A,key='principals',flat=_B);G=' WITH GRANT OPTION'if A.args.get('grant_option')else'';return f"GRANT {E} ON{C}{D} TO {F}{G}"
	def grantprivilege_sql(B,expression):C=expression;D=B.sql(C,_A);A=B.expressions(C,flat=_B);A=f"({A})"if A else'';return f"{D}{A}"
	def grantprincipal_sql(B,expression):C=expression;D=B.sql(C,_A);A=B.sql(C,_G);A=f"{A} "if A else'';return f"{A}{D}"
	def columns_sql(C,expression):
		B=expression;A=C.function_fallback_sql(B)
		if B.args.get('unpack'):A=f"*{A}"
		return A
	def overlay_sql(A,expression):B=expression;D=A.sql(B,_A);E=A.sql(B,_F);F=A.sql(B,_l);C=A.sql(B,'for');C=f" FOR {C}"if C else'';return f"OVERLAY({D} PLACING {E} FROM {F}{C})"