from sqlglot import alias,exp
from sqlglot.errors import OptimizeError
from sqlglot.optimizer.scope import traverse_scope
from sqlglot.schema import ensure_schema
def isolate_table_selects(expression,schema=None):
	E=False;C=expression;B=schema;B=ensure_schema(B)
	for D in traverse_scope(C):
		if len(D.selected_sources)==1:continue
		for(F,A)in D.selected_sources.values():
			if not isinstance(A,exp.Table)or not B.column_names(A)or isinstance(A.parent,exp.Subquery)or isinstance(A.parent.parent,exp.Table):continue
			if not A.alias:raise OptimizeError('Tables require an alias. Run qualify_tables optimization.')
			A.replace(exp.select('*').from_(alias(A,A.alias_or_name,table=True),copy=E).subquery(A.alias,copy=E))
	return C