'Parse SQL statements.'
_A=None
from sqlparse import sql,cli,engine,tokens,filters,formatter
__version__='0.5.2.dev0'
__all__=['engine','filters','formatter','sql','tokens','cli']
def parse(sql,encoding=_A):'Parse sql and return a list of statements.\n\n    :param sql: A string containing one or more SQL statements.\n    :param encoding: The encoding of the statement (optional).\n    :returns: A tuple of :class:`~sqlparse.sql.Statement` instances.\n    ';return tuple(parsestream(sql,encoding))
def parsestream(stream,encoding=_A):'Parses sql statements from file-like object.\n\n    :param stream: A file-like object.\n    :param encoding: The encoding of the stream contents (optional).\n    :returns: A generator of :class:`~sqlparse.sql.Statement` instances.\n    ';A=engine.FilterStack();A.enable_grouping();return A.run(stream,encoding)
def format(sql,encoding=_A,**B):'Format *sql* according to *options*.\n\n    Available options are documented in :ref:`formatting`.\n\n    In addition to the formatting options this function accepts the\n    keyword "encoding" which determines the encoding of the statement.\n\n    :returns: The formatted SQL statement as string.\n    ';A=engine.FilterStack();B=formatter.validate_options(B);A=formatter.build_filter_stack(A,B);A.postprocess.append(filters.SerializerUnicode());return''.join(A.run(sql,encoding))
def split(sql,encoding=_A,strip_semicolon=False):'Split *sql* into single statements.\n\n    :param sql: A string containing one or more SQL statements.\n    :param encoding: The encoding of the statement (optional).\n    :param strip_semicolon: If True, remove trainling semicolons\n        (default: False).\n    :returns: A list of strings.\n    ';A=engine.FilterStack(strip_semicolon=strip_semicolon);return[str(A).strip()for A in A.run(sql,encoding)]