_B=False
_A=None
import re
from sqlparse import sql,tokens as T
from sqlparse.utils import split_unquoted_newlines
class StripCommentsFilter:
	@staticmethod
	def _process(tlist):
		A=tlist
		def F():return A.token_next_by(i=sql.Comment,t=T.Comment)
		def G(token):
			'Returns either a whitespace or the line breaks from token.';A=re.search('([\\r\\n]+) *$',token.value)
			if A is not _A:return sql.Token(T.Whitespace.Newline,A.groups()[0])
			else:return sql.Token(T.Whitespace,' ')
		B,C=F()
		while C:
			H,D=A.token_prev(B,skip_ws=_B);I,E=A.token_next(B,skip_ws=_B)
			if D is _A or E is _A or D.is_whitespace or D.match(T.Punctuation,'(')or E.is_whitespace or E.match(T.Punctuation,')'):
				if D is not _A and not D.match(T.Punctuation,'('):A.tokens.insert(B,G(C))
				A.tokens.remove(C)
			else:A.tokens[B]=G(C)
			B,C=F()
	def process(B,stmt):A=stmt;[B.process(A)for A in A.get_sublists()];StripCommentsFilter._process(A);return A
class StripWhitespaceFilter:
	def _stripws(A,tlist):B=tlist;C='_stripws_{cls}'.format(cls=type(B).__name__);D=getattr(A,C.lower(),A._stripws_default);D(B)
	@staticmethod
	def _stripws_default(tlist):
		B=_B;C=True
		for A in tlist.tokens:
			if A.is_whitespace:A.value=''if B or C else' '
			B=A.is_whitespace;C=_B
	def _stripws_identifierlist(D,tlist):
		B=tlist;C=_A
		for A in list(B.tokens):
			if C and A.ttype is T.Punctuation and A.value==',':B.tokens.remove(C)
			C=A if A.is_whitespace else _A
		return D._stripws_default(B)
	def _stripws_parenthesis(B,tlist):
		A=tlist
		while A.tokens[1].is_whitespace:A.tokens.pop(1)
		while A.tokens[-2].is_whitespace:A.tokens.pop(-2)
		if A.tokens[-2].is_group:
			while A.tokens[-2].tokens[-1].is_whitespace:A.tokens[-2].tokens.pop(-1)
		B._stripws_default(A)
	def process(B,stmt,depth=0):
		C=depth;A=stmt;[B.process(A,C+1)for A in A.get_sublists()];B._stripws(A)
		if C==0 and A.tokens and A.tokens[-1].is_whitespace:A.tokens.pop(-1)
		return A
class SpacesAroundOperatorsFilter:
	@staticmethod
	def _process(tlist):
		B=tlist;C=T.Operator,T.Comparison;A,D=B.token_next_by(t=C)
		while D:
			G,E=B.token_next(A,skip_ws=_B)
			if E and E.ttype!=T.Whitespace:B.insert_after(A,sql.Token(T.Whitespace,' '))
			H,F=B.token_prev(A,skip_ws=_B)
			if F and F.ttype!=T.Whitespace:B.insert_before(A,sql.Token(T.Whitespace,' '));A+=1
			A,D=B.token_next_by(t=C,idx=A)
	def process(B,stmt):A=stmt;[B.process(A)for A in A.get_sublists()];SpacesAroundOperatorsFilter._process(A);return A
class StripTrailingSemicolonFilter:
	def process(B,stmt):
		A=stmt
		while A.tokens and(A.tokens[-1].is_whitespace or A.tokens[-1].value==';'):A.tokens.pop()
		return A
class SerializerUnicode:
	@staticmethod
	def process(stmt):A=split_unquoted_newlines(stmt);return'\n'.join(A.rstrip()for A in A)