_A=None
import itertools,re
from collections import deque
from contextlib import contextmanager
SPLIT_REGEX=re.compile('\n(\n (?:                     # Start of non-capturing group\n  (?:\\r\\n|\\r|\\n)      |  # Match any single newline, or\n  [^\\r\\n\'"]+          |  # Match any character series without quotes or\n                         # newlines, or\n  "(?:[^"\\\\]|\\\\.)*"   |  # Match double-quoted strings, or\n  \'(?:[^\'\\\\]|\\\\.)*\'      # Match single quoted strings\n )\n)\n',re.VERBOSE)
LINE_MATCH=re.compile('(\\r\\n|\\r|\\n)')
def split_unquoted_newlines(stmt):
	'Split a string on all unquoted newlines.\n\n    Unlike str.splitlines(), this will ignore CR/LF/CR+LF if the requisite\n    character is inside of a string.';C=str(stmt);D=SPLIT_REGEX.split(C);A=['']
	for B in D:
		if not B:continue
		elif LINE_MATCH.match(B):A.append('')
		else:A[-1]+=B
	return A
def remove_quotes(val):
	'Helper that removes surrounding quotes from strings.';A=val
	if A is _A:return
	if A[0]in('"',"'",'`')and A[0]==A[-1]:A=A[1:-1]
	return A
def recurse(*D):
	'Function decorator to help with recursion\n\n    :param cls: Classes to not recurse over\n    :return: function\n    '
	def A(f):
		def A(tlist):
			B=tlist
			for C in B.get_sublists():
				if not isinstance(C,D):A(C)
			f(B)
		return A
	return A
def imt(token,i=_A,m=_A,t=_A):
	'Helper function to simplify comparisons Instance, Match and TokenType\n    :param token:\n    :param i: Class or Tuple/List of Classes\n    :param m: Tuple of TokenType & Value. Can be list of Tuple for multiple\n    :param t: TokenType or Tuple/List of TokenTypes\n    :return:  bool\n    ';C=False;B=True;A=token
	if A is _A:return C
	if i and isinstance(A,i):return B
	if m:
		if isinstance(m,list):
			if any(A.match(*B)for B in m):return B
		elif A.match(*m):return B
	if t:
		if isinstance(t,list):
			if any(A.ttype in B for B in t):return B
		elif A.ttype in t:return B
	return C
def consume(iterator,n):'Advance the iterator n-steps ahead. If n is none, consume entirely.';deque(itertools.islice(iterator,n),maxlen=0)
@contextmanager
def offset(filter_,n=0):A=filter_;A.offset+=n;yield;A.offset-=n
@contextmanager
def indent(filter_,n=1):A=filter_;A.indent+=n;yield;A.indent-=n