_H='return_stmt'
_G='trailer'
_F='file_input'
_E='operator'
_D=False
_C='\n'
_B=True
_A=None
from textwrap import dedent
from parso import split_lines
from jedi import debug
from jedi.api.exceptions import RefactoringError
from jedi.api.refactoring import Refactoring,EXPRESSION_PARTS
from jedi.common import indent_block
from jedi.parser_utils import function_is_classmethod,function_is_staticmethod
_DEFINITION_SCOPES='suite',_F
_VARIABLE_EXCTRACTABLE=EXPRESSION_PARTS+'atom testlist_star_expr testlist test lambdef lambdef_nocond keyword name number string fstring'.split()
def extract_variable(inference_state,path,module_node,name,pos,until_pos):
	A=_find_nodes(module_node,pos,until_pos);debug.dbg('Extracting nodes: %s',A);B,C=_is_expression_with_error(A)
	if not B:raise RefactoringError(C)
	D=name+' = '+_expression_nodes_to_string(A);E={path:_replace(A,name,D,pos)};return Refactoring(inference_state,E)
def _is_expression_with_error(nodes):
	'\n    Returns a tuple (is_expression, error_string).\n    ';A=nodes
	if any(A.type=='name'and A.is_definition()for A in A):return _D,'Cannot extract a name that defines something'
	if A[0].type not in _VARIABLE_EXCTRACTABLE:return _D,'Cannot extract a "%s"'%A[0].type
	return _B,''
def _find_nodes(module_node,pos,until_pos):
	'\n    Looks up a module and tries to find the appropriate amount of nodes that\n    are in there.\n    ';H=module_node;E=until_pos;D=pos;A=H.get_leaf_for_position(D,include_prefixes=_B)
	if E is _A:
		if A.type==_E:
			B=A.get_next_leaf()
			if B is not _A and B.start_pos==D:A=B
		if _is_not_extractable_syntax(A):A=A.parent
		if A.parent.type==_G:A=A.parent.parent
		while A.parent.type in EXPRESSION_PARTS:A=A.parent
		F=[A]
	else:
		if A.end_pos==D:
			B=A.get_next_leaf()
			if B is not _A:A=B
		if _is_not_extractable_syntax(A):A=A.parent
		C=H.get_leaf_for_position(E,include_prefixes=_B)
		if C.start_pos>E:
			C=C.get_previous_leaf()
			if C is _A:raise RefactoringError('Cannot extract anything from that')
		G=A
		while G.end_pos<C.end_pos:G=G.parent
		F=_remove_unwanted_expression_nodes(G,D,E)
	if len(F)==1 and A.type in(_H,'yield_expr'):return[F[0].children[1]]
	return F
def _replace(nodes,expression_replacement,extracted,pos,insert_before_leaf=_A,remaining_prefix=_A):
	G=expression_replacement;D=remaining_prefix;B=nodes;A=insert_before_leaf;J=_get_parent_definition(B[0])
	if A is _A:A=J.get_first_leaf()
	F=B[0].get_first_leaf();E=split_lines(A.prefix,keepends=_B)
	if F is A:
		if D is not _A:E[:-1]=D
	E[-1:-1]=[indent_block(extracted,E[-1])+_C];H=''.join(E);C={}
	if F is A:C[B[0]]=H+G
	else:
		if D is _A:I=F.prefix
		else:I=D+_get_indentation(B[0])
		C[B[0]]=I+G;C[A]=H+A.value
	for K in B[1:]:C[K]=''
	return C
def _expression_nodes_to_string(nodes):return''.join(B.get_code(include_prefix=A!=0)for(A,B)in enumerate(nodes))
def _suite_nodes_to_string(nodes,pos):A=nodes;B=A[0];C,D=_split_prefix_at(B.get_first_leaf(),pos[0]-1);E=D+B.get_code(include_prefix=_D)+''.join(A.get_code()for A in A[1:]);return C,E
def _split_prefix_at(leaf,until_line):"\n    Returns a tuple of the leaf's prefix, split at the until_line\n    position.\n    ";A=leaf.start_pos[0]-until_line;B=split_lines(leaf.prefix,keepends=_B);return''.join(B[:-A]),''.join(B[-A:])
def _get_indentation(node):return split_lines(node.get_first_leaf().prefix)[-1]
def _get_parent_definition(node):
	'\n    Returns the statement where a node is defined.\n    ';A=node
	while A is not _A:
		if A.parent.type in _DEFINITION_SCOPES:return A
		A=A.parent
	raise NotImplementedError('We should never even get here')
def _remove_unwanted_expression_nodes(parent_node,pos,until_pos):
	'\n    This function makes it so for `1 * 2 + 3` you can extract `2 + 3`, even\n    though it is not part of the expression.\n    ';F=until_pos;E=pos;D=parent_node;H=D.type;I=H in('suite',_F)
	if H in EXPRESSION_PARTS or I:
		A=D.children
		for(C,B)in enumerate(A):
			if B.end_pos>E:
				J=C
				if B.type==_E:J-=1
				break
		for(C,B)in reversed(list(enumerate(A))):
			if B.start_pos<F:
				G=C
				if B.type==_E:G+=1
				for K in A[C:]:
					if _is_not_extractable_syntax(K):G+=1
					else:break
				break
		A=A[J:G+1]
		if not I:A[0:1]=_remove_unwanted_expression_nodes(A[0],E,F);A[-1:]=_remove_unwanted_expression_nodes(A[-1],E,F)
		return A
	return[D]
def _is_not_extractable_syntax(node):A=node;return A.type==_E or A.type=='keyword'and A.value not in('None','True','False')
def extract_function(inference_state,path,module_context,name,pos,until_pos):
	P=until_pos;O=', ';N='return ';I=pos;H=module_context;A=_find_nodes(H.tree_node,I,P);assert len(A);J,c=_is_expression_with_error(A);B=H.create_context(A[0]);Q=B.is_bound_method();E,F=list(_find_inputs_and_outputs(H,B,A))
	if B.is_module():R=_A
	else:X=_get_code_insertion_node(B.tree_node,Q);R=X.get_first_leaf()
	if J:C=N+_expression_nodes_to_string(A)+_C;S=_A;G=_D
	else:
		G=_is_node_ending_return_stmt(A[-1])
		if not G:F=list(_find_needed_output_variables(B,A[0].parent,A[-1].end_pos,F))or[F[-1]]if F else[]
		S,C=_suite_nodes_to_string(A,I);K=A[-1].get_next_leaf();Y,Z=_split_prefix_at(K,P[0]);C+=Y;C=dedent(C)
		if not G:T=O.join(F);C+=N+T+_C
	_check_for_non_extractables(A[:-1]if G else A);U='';D=_A
	if Q:
		if not function_is_staticmethod(B.tree_node):
			V=B.get_value().get_param_names()
			if len(V):D=V[0].string_name;E=[A for A in E if A!=D]
		if function_is_classmethod(B.tree_node):U='@classmethod\n'
	else:C+=_C
	a='%sdef %s(%s):\n%s'%(U,name,O.join(E if D is _A else[D]+E),indent_block(C));L='%s(%s)'%((''if D is _A else D+'.')+name,O.join(E))
	if J:M=L
	elif G:M=N+L+_C
	else:M=T+' = '+L+_C
	W=_replace(A,M,a,I,R,S)
	if not J:W[K]=Z+K.value
	b={path:W};return Refactoring(inference_state,b)
def _check_for_non_extractables(nodes):
	for A in nodes:
		try:B=A.children
		except AttributeError:
			if A.value=='return':raise RefactoringError('Can only extract return statements if they are at the end.')
			if A.value=='yield':raise RefactoringError('Cannot extract yield statements.')
		else:_check_for_non_extractables(B)
def _is_name_input(module_context,names,first,last):
	for A in names:
		if A.api_type=='param'or not A.parent_context.is_module():
			if A.get_root_context()is not module_context:return _B
			if A.start_pos is _A or not first<=A.start_pos<last:return _B
	return _D
def _find_inputs_and_outputs(module_context,context,nodes):
	B=nodes;F=B[0].start_pos;G=B[-1].end_pos;C=[];D=[]
	for A in _find_non_global_names(B):
		if A.is_definition():
			if A not in D:D.append(A.value)
		elif A.value not in C:
			E=context.goto(A,A.start_pos)
			if not E or _is_name_input(module_context,E,F,G):C.append(A.value)
	return C,D
def _find_non_global_names(nodes):
	for A in nodes:
		try:B=A.children
		except AttributeError:
			if A.type=='name':yield A
		else:
			if A.type==_G and A.children[0]=='.':continue
			yield from _find_non_global_names(B)
def _get_code_insertion_node(node,is_bound_method):
	A=node
	if not is_bound_method or function_is_staticmethod(A):
		while A.parent.type!=_F:A=A.parent
	while A.parent.type in('async_funcdef','decorated','async_stmt'):A=A.parent
	return A
def _find_needed_output_variables(context,search_node,at_least_pos,return_variables):
	'\n    Searches everything after at_least_pos in a node and checks if any of the\n    return_variables are used in there and returns those.\n    ';A=return_variables
	for C in search_node.children:
		if C.start_pos<at_least_pos:continue
		A=set(A)
		for B in _find_non_global_names([C]):
			if not B.is_definition()and B.value in A:A.remove(B.value);yield B.value
def _is_node_ending_return_stmt(node):
	A=node.type
	if A=='simple_stmt':return _is_node_ending_return_stmt(node.children[0])
	return A==_H