'\nA static version of getattr.\nThis is a backport of the Python 3 code with a little bit of additional\ninformation returned to enable Jedi to make decisions.\n'
_B=False
_A='__dict__'
import types
from jedi import debug
_sentinel=object()
def _check_instance(obj,attr):
	A={}
	try:A=object.__getattribute__(obj,_A)
	except AttributeError:pass
	return dict.get(A,attr,_sentinel)
def _check_class(klass,attr):
	for A in _static_getmro(klass):
		if _shadowed_dict(type(A))is _sentinel:
			try:return A.__dict__[attr]
			except KeyError:pass
	return _sentinel
def _is_type(obj):
	try:_static_getmro(obj)
	except TypeError:return _B
	return True
def _shadowed_dict(klass):
	C=type.__dict__[_A]
	for B in _static_getmro(klass):
		try:A=C.__get__(B)[_A]
		except KeyError:pass
		else:
			if not(type(A)is types.GetSetDescriptorType and A.__name__==_A and A.__objclass__ is B):return A
	return _sentinel
def _static_getmro(klass):
	B=klass;A=type.__dict__['__mro__'].__get__(B)
	if not isinstance(A,(tuple,list)):debug.warning('mro of %s returned %s, should be a tuple'%(B,A));return()
	return A
def _safe_hasattr(obj,name):return _check_class(type(obj),name)is not _sentinel
def _safe_is_data_descriptor(obj):return _safe_hasattr(obj,'__set__')or _safe_hasattr(obj,'__delete__')
def getattr_static(obj,attr,default=_sentinel):
	"Retrieve attributes without triggering dynamic lookup via the\n       descriptor protocol,  __getattr__ or __getattribute__.\n\n       Note: this function may not be able to retrieve all attributes\n       that getattr can fetch (like dynamically created attributes)\n       and may find attributes that getattr can't (like descriptors\n       that raise AttributeError). It can also return descriptor objects\n       instead of instance members in some cases. See the\n       documentation for details.\n\n       Returns a tuple `(attr, is_get_descriptor)`. is_get_descripter means that\n       the attribute is a descriptor that has a `__get__` attribute.\n    ";I='__get__';F=default;D=attr;B=obj;E=_sentinel
	if not _is_type(B):
		C=type(B);G=_shadowed_dict(C)
		if G is _sentinel or type(G)is types.MemberDescriptorType:E=_check_instance(B,D)
	else:C=B
	A=_check_class(C,D)
	if E is not _sentinel and A is not _sentinel:
		if _safe_hasattr(A,I)and _safe_is_data_descriptor(A):return A,True
	if E is not _sentinel:return E,_B
	if A is not _sentinel:return A,_safe_hasattr(A,I)
	if B is C:
		for H in _static_getmro(type(C)):
			if _shadowed_dict(type(H))is _sentinel:
				try:return H.__dict__[D],_B
				except KeyError:pass
	if F is not _sentinel:return F,_B
	raise AttributeError(D)