_B='__init__'
_A=None
import sys,os,inspect,importlib
from pathlib import Path
from zipfile import ZipFile
from zipimport import zipimporter,ZipImportError
from importlib.machinery import all_suffixes
from jedi.inference.compiled import access
from jedi import debug
from jedi import parser_utils
from jedi.file_io import KnownContentFileIO,ZipFileIO
def get_sys_path():return sys.path
def load_module(inference_state,**A):return access.load_module(inference_state,**A)
def get_compiled_method_return(inference_state,id,attribute,*A,**B):C=inference_state.compiled_subprocess.get_access_handle(id);return getattr(C.access,attribute)(*A,**B)
def create_simple_object(inference_state,obj):return access.create_access_path(inference_state,obj)
def get_module_info(inference_state,sys_path=_A,full_name=_A,**B):
	'\n    Returns Tuple[Union[NamespaceInfo, FileIO, None], Optional[bool]]\n    ';A=sys_path
	if A is not _A:sys.path,C=A,sys.path
	try:return _find_module(full_name=full_name,**B)
	except ImportError:return _A,_A
	finally:
		if A is not _A:sys.path=C
def get_builtin_module_names(inference_state):return sys.builtin_module_names
def _test_raise_error(inference_state,exception_type):'\n    Raise an error to simulate certain problems for unit tests.\n    ';raise exception_type
def _test_print(inference_state,stderr=_A,stdout=_A):
	'\n    Force some prints in the subprocesses. This exists for unit tests.\n    ';B=stdout;A=stderr
	if A is not _A:print(A,file=sys.stderr);sys.stderr.flush()
	if B is not _A:print(B);sys.stdout.flush()
def _get_init_path(directory_path):
	'\n    The __init__ file can be searched in a directory. If found return it, else\n    None.\n    '
	for B in all_suffixes():
		A=os.path.join(directory_path,_B+B)
		if os.path.exists(A):return A
def safe_literal_eval(inference_state,value):return parser_utils.safe_literal_eval(value)
def iter_module_names(*A,**B):return list(_iter_module_names(*A,**B))
def _iter_module_names(inference_state,paths):
	for C in paths:
		try:D=((A.name,A.is_dir())for A in os.scandir(C))
		except:pass
		for(A,E)in D:
			if E:
				if A!='__pycache__'and A.isidentifier():yield A
			else:
				if A.endswith('.pyi'):B=A[:-4]
				else:B=inspect.getmodulename(A)
				if B and'.'not in B:
					if B!=_B:yield B
def _find_module(string,path=_A,full_name=_A,is_global_search=True):
	'\n    Provides information about a module.\n\n    This function isolates the differences in importing libraries introduced with\n    python 3.3 on; it gets a module name and optionally a path. It will return a\n    tuple containin an open file for the module (if not builtin), the filename\n    or the name of the module if it is a builtin one and a boolean indicating\n    if the module is contained in a package.\n    ';D=full_name;C=path;B=string;A=_A;E=_A
	for F in sys.meta_path:
		if is_global_search and F!=importlib.machinery.PathFinder:G=_A
		else:G=C
		try:H=F.find_spec
		except AttributeError:continue
		A=H(B,G)
		if A is not _A:
			if A.origin=='frozen':continue
			E=A.loader
			if E is _A and not A.has_location:D=B if not C else D;I=ImplicitNSInfo(D,A.submodule_search_locations._path);return I,True
			break
	return _find_module_py33(B,C,E)
def _find_module_py33(string,path=_A,loader=_A,full_name=_A,is_global_search=True):
	C=string;A=loader
	if not A:
		B=importlib.machinery.PathFinder.find_spec(C,path)
		if B is not _A:A=B.loader
	if A is _A and path is _A:
		try:
			B=importlib.util.find_spec(C)
			if B is not _A:A=B.loader
		except ValueError as D:raise ImportError('Originally  '+repr(D))
	if A is _A:raise ImportError("Couldn't find a loader for {}".format(C))
	return _from_loader(A,C)
def _from_loader(loader,string):
	C=string;A=loader
	try:F=A.is_package
	except AttributeError:B=False
	else:B=F(C)
	try:G=A.get_filename
	except AttributeError:return _A,B
	else:E=G(C)
	try:H=type(A).get_source
	except AttributeError:raise ImportError('get_source was not defined on loader')
	if H is not importlib.machinery.SourceFileLoader.get_source:D=A.get_source(C)
	else:D=_get_source(A,C)
	if D is _A:return _A,B
	if isinstance(A,zipimporter):return ZipFileIO(E,D,Path(A.archive)),B
	return KnownContentFileIO(E,D),B
def _get_source(loader,fullname):
	'\n    This method is here as a replacement for SourceLoader.get_source. That\n    method returns unicode, but we prefer bytes.\n    ';B=fullname;A=loader;C=A.get_filename(B)
	try:return A.get_data(C)
	except OSError:raise ImportError('source not available through get_data()',name=B)
def _zip_list_subdirectory(zip_path,zip_subdir_path):
	A=zip_subdir_path;D=ZipFile(zip_path);A=Path(A);E=D.namelist()
	for C in E:
		B=Path(C)
		if B.parent==A:B=B.relative_to(A);yield(B.name,C.endswith('/'))
class ImplicitNSInfo:
	'Stores information returned from an implicit namespace spec'
	def __init__(A,name,paths):A.name=name;A.paths=paths