_D='try_stmt'
_C='if_stmt'
_B=None
_A=True
from typing import Dict,Optional
from jedi.parser_utils import get_flow_branch_keyword,is_scope,get_parent_scope
from jedi.inference.recursion import execution_allowed
from jedi.inference.helpers import is_big_annoying_library
class Status:
	lookup_table:Dict[Optional[bool],'Status']={}
	def __init__(A,value,name):B=value;A._value=B;A._name=name;Status.lookup_table[B]=A
	def invert(A):
		if A is REACHABLE:return UNREACHABLE
		elif A is UNREACHABLE:return REACHABLE
		else:return UNSURE
	def __and__(A,other):
		B=other
		if UNSURE in(A,B):return UNSURE
		else:return REACHABLE if A._value and B._value else UNREACHABLE
	def __repr__(A):return'<%s: %s>'%(type(A).__name__,A._name)
REACHABLE=Status(_A,'reachable')
UNREACHABLE=Status(False,'unreachable')
UNSURE=Status(_B,'unsure')
def _get_flow_scopes(node):
	A=node
	while _A:
		A=get_parent_scope(A,include_flows=_A)
		if A is _B or is_scope(A):return
		yield A
def reachability_check(context,value_scope,node,origin_scope=_B):
	E=context;D=node;A=origin_scope
	if is_big_annoying_library(E)or not E.inference_state.flow_analysis_enabled:return UNSURE
	F=get_parent_scope(D,include_flows=_A)
	if A is not _B:
		I=list(_get_flow_scopes(A));J=list(_get_flow_scopes(D));B=_A
		for C in I:
			if C in J:
				G=get_flow_branch_keyword(C,D);H=get_flow_branch_keyword(C,A);B=G==H
				if C.type==_C:
					if not B:return UNREACHABLE
				elif C.type==_D:
					if not B and H=='else'and G=='except':return UNREACHABLE
				if B:break
		while A is not _B:
			if F==A and B:return REACHABLE
			A=A.parent
	return _break_check(E,value_scope,F,D)
def _break_check(context,value_scope,flow_scope,node):
	E=node;D=value_scope;C=context;A=flow_scope;B=REACHABLE
	if A.type==_C:
		if A.is_node_after_else(E):
			for G in A.get_test_nodes():
				B=_check_if(C,G)
				if B in(REACHABLE,UNSURE):break
			B=B.invert()
		else:
			F=A.get_corresponding_test_node(E)
			if F is not _B:B=_check_if(C,F)
	elif A.type in(_D,'while_stmt'):return UNSURE
	if B in(UNREACHABLE,UNSURE):return B
	if D!=A and D!=A.parent:A=get_parent_scope(A,include_flows=_A);return B&_break_check(C,D,A,E)
	else:return B
def _check_if(context,node):
	A=context
	with execution_allowed(A.inference_state,node)as C:
		if not C:return UNSURE
		D=A.infer_node(node);B=set(A.py__bool__()for A in D)
		if len(B)==1:return Status.lookup_table[B.pop()]
		else:return UNSURE