_D='module'
_C=True
_B=False
_A=None
from jedi import debug
from jedi.inference.base_value import ValueSet,NO_VALUES
from jedi.inference.utils import to_list
from jedi.inference.gradual.stub_value import StubModuleValue
from jedi.inference.gradual.typeshed import try_to_load_stub_cached
from jedi.inference.value.decorator import Decoratee
def _stub_to_python_value_set(stub_value,ignore_compiled=_B):
	A=stub_value;G=A.get_root_context()
	if not G.is_stub():return ValueSet([A])
	D=_A
	if isinstance(A,Decoratee):D=A._original_value
	E=A.is_instance()
	if E:F=getattr(A,'_arguments',_A);A=A.py__class__()
	C=A.get_qualified_names()
	if C is _A:return NO_VALUES
	H=A.is_bound_method()
	if H:I=C[-1];C=C[:-1];E=_C;F=_A
	B=_infer_from_stub(G,C,ignore_compiled)
	if E:B=ValueSet.from_sets(A.execute_with_values()if F is _A else A.execute(F)for A in B if A.is_class())
	if H:B=B.py__getattribute__(I)
	if D is not _A:B=ValueSet(Decoratee(A,D)for A in B)
	return B
def _infer_from_stub(stub_module_context,qualified_names,ignore_compiled):
	B=stub_module_context;from jedi.inference.compiled.mixed import MixedObject as D;C=B.get_value();assert isinstance(C,(StubModuleValue,D)),B;A=C.non_stub_value_set
	if ignore_compiled:A=A.filter(lambda c:not c.is_compiled())
	for E in qualified_names:A=A.py__getattribute__(E)
	return A
@to_list
def _try_stub_to_python_names(names,prefer_stub_to_compiled=_B):
	C=prefer_stub_to_compiled
	for A in names:
		H=A.get_root_context()
		if not H.is_stub():yield A;continue
		if A.api_type==_D:
			D=convert_values(A.infer(),ignore_compiled=C)
			if D:
				for B in D:yield B.name
				continue
		else:
			B=A.get_defining_qualified_value()
			if B is not _A:
				E=_stub_to_python_value_set(B,ignore_compiled=C)
				if E:
					F=E.goto(A.get_public_name())
					if F:
						for G in F:
							if G.get_root_context().is_stub():yield A
							else:yield G
						continue
		yield A
def _load_stub_module(module):
	A=module
	if A.is_stub():return A
	return try_to_load_stub_cached(A.inference_state,import_names=A.string_names,python_value_set=ValueSet([A]),parent_module_value=_A,sys_path=A.inference_state.get_sys_path())
@to_list
def _python_to_stub_names(names,fallback_to_python=_B):
	E=fallback_to_python
	for A in names:
		H=A.get_root_context()
		if H.is_stub():yield A;continue
		if A.api_type==_D:
			C=_B
			for D in A.goto():
				if D.api_type==_D:
					I=convert_values(D.infer(),only_stubs=_C)
					for B in I:yield B.name;C=_C
				else:
					for J in _python_to_stub_names([D],fallback_to_python=E):yield J;C=_C
			if C:continue
		else:
			B=A.get_defining_qualified_value()
			if B is not _A:
				F=to_stub(B)
				if F:
					G=F.goto(A.get_public_name())
					if G:yield from G;continue
		if E:yield A
def convert_names(names,only_stubs=_B,prefer_stubs=_B,prefer_stub_to_compiled=_C):
	C=only_stubs;B=names;A=prefer_stubs
	if C and A:raise ValueError('You cannot use both of only_stubs and prefer_stubs.')
	with debug.increase_indent_cm('convert names'):
		if C or A:return _python_to_stub_names(B,fallback_to_python=A)
		else:return _try_stub_to_python_names(B,prefer_stub_to_compiled=prefer_stub_to_compiled)
def convert_values(values,only_stubs=_B,prefer_stubs=_B,ignore_compiled=_C):
	C=only_stubs;B=values;A=prefer_stubs;assert not(C and A)
	with debug.increase_indent_cm('convert values'):
		if C or A:return ValueSet.from_sets(to_stub(B)or(ValueSet({B})if A else NO_VALUES)for B in B)
		else:return ValueSet.from_sets(_stub_to_python_value_set(A,ignore_compiled=ignore_compiled)or ValueSet({A})for A in B)
def to_stub(value):
	A=value
	if A.is_stub():return ValueSet([A])
	D=A.is_instance()
	if D:A=A.py__class__()
	C=A.get_qualified_names();E=_load_stub_module(A.get_root_context().get_value())
	if E is _A or C is _A:return NO_VALUES
	F=A.is_bound_method()
	if F:G=C[-1];C=C[:-1];D=_C
	B=ValueSet([E])
	for H in C:B=B.py__getattribute__(H)
	if D:B=ValueSet.from_sets(A.execute_with_values()for A in B if A.is_class())
	if F:B=B.py__getattribute__(G)
	return B