_A=None
from jedi import debug
from jedi.inference.base_value import ValueSet,NO_VALUES,ValueWrapper
from jedi.inference.gradual.base import BaseTypingValue
class TypeVarClass(ValueWrapper):
	def py__call__(A,arguments):
		B=arguments;C=B.unpack();E,F=next(C,(_A,_A));D=A._find_string_name(F)
		if D is _A or E is not _A:debug.warning('Found a variable without a name %s',B);return NO_VALUES
		return ValueSet([TypeVar.create_cached(A.inference_state,A.parent_context,tree_name=A.tree_node.name,var_name=D,unpacked_args=C)])
	def _find_string_name(F,lazy_value):
		B=lazy_value
		if B is _A:return
		A=B.infer()
		if not A:return
		if len(A)>1:debug.warning('Found multiple values for a type variable: %s',A)
		D=next(iter(A))
		try:E=D.get_safe_value
		except AttributeError:return
		else:
			C=E(default=_A)
			if isinstance(C,str):return C
			return
class TypeVar(BaseTypingValue):
	def __init__(A,parent_context,tree_name,var_name,unpacked_args):
		super().__init__(parent_context,tree_name);A._var_name=var_name;A._constraints_lazy_values=[];A._bound_lazy_value=_A;A._covariant_lazy_value=_A;A._contravariant_lazy_value=_A
		for(B,C)in unpacked_args:
			if B is _A:A._constraints_lazy_values.append(C)
			elif B=='bound':A._bound_lazy_value=C
			elif B=='covariant':A._covariant_lazy_value=C
			elif B=='contravariant':A._contra_variant_lazy_value=C
			else:debug.warning('Invalid TypeVar param name %s',B)
	def py__name__(A):return A._var_name
	def get_filters(A,*B,**C):return iter([])
	def _get_classes(A):
		if A._bound_lazy_value is not _A:return A._bound_lazy_value.infer()
		if A._constraints_lazy_values:return A.constraints
		debug.warning('Tried to infer the TypeVar %s without a given type',A._var_name);return NO_VALUES
	def is_same_class(A,other):return True
	@property
	def constraints(self):return ValueSet.from_sets(A.infer()for A in self._constraints_lazy_values)
	def define_generics(A,type_var_dict):
		try:B=type_var_dict[A.py__name__()]
		except KeyError:pass
		else:
			if B:return B
		return ValueSet({A})
	def execute_annotation(A):return A._get_classes().execute_annotation()
	def infer_type_vars(A,value_set):
		def B():
			for A in value_set:
				B=A.py__class__()
				if A.is_function()or A.is_class():B=TypeWrapper(B,A)
				yield B
		C=A.py__name__();return{C:ValueSet(B())}
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A.py__name__())
class TypeWrapper(ValueWrapper):
	def __init__(A,wrapped_value,original_value):super().__init__(wrapped_value);A._original_value=original_value
	def execute_annotation(A):return ValueSet({A._original_value})