_B=False
_A=None
import copy,sys,re,os
from itertools import chain
from contextlib import contextmanager
from parso.python import tree
def is_stdlib_path(path):
	A=path.parts
	if'dist-packages'in A or'site-packages'in A:return _B
	B=os.path.join(sys.prefix,'lib','python');return bool(re.match(re.escape(B)+'\\d.\\d',str(path)))
def deep_ast_copy(obj):
	'\n    Much, much faster than copy.deepcopy, but just for parser tree nodes.\n    ';A=copy.copy(obj);D=[]
	for C in obj.children:
		if isinstance(C,tree.Leaf):B=copy.copy(C);B.parent=A
		else:B=deep_ast_copy(C);B.parent=A
		D.append(B)
	A.children=D;return A
def infer_call_of_leaf(context,leaf,cut_own_trailer=_B):
	'\n    Creates a "call" node that consist of all ``trailer`` and ``power``\n    objects.  E.g. if you call it with ``append``::\n\n        list([]).append(3) or None\n\n    You would get a node with the content ``list([]).append`` back.\n\n    This generates a copy of the original ast node.\n\n    If you\'re using the leaf, e.g. the bracket `)` it will return ``list([])``.\n\n    We use this function for two purposes. Given an expression ``bar.foo``,\n    we may want to\n      - infer the type of ``foo`` to offer completions after foo\n      - infer the type of ``bar`` to be able to jump to the definition of foo\n    The option ``cut_own_trailer`` must be set to true for the second purpose.\n    ';K='trailer';F=leaf;C=context;A=F.parent
	if A.type=='fstring':from jedi.inference import compiled as L;return L.get_string_value_set(C.inference_state)
	if A.type!=K or F not in(A.children[0],A.children[-1]):
		if F==':':from jedi.inference.base_value import NO_VALUES as M;return M
		if A.type=='atom':return C.infer_node(A)
		return C.infer_node(F)
	B=A.parent;G=B.children.index(A)
	if cut_own_trailer:H=G
	else:H=G+1
	if B.type=='error_node':
		I=G
		while True:
			I-=1;D=B.children[I]
			if D.type!=K:break
		E=B.children[I+1:H]
	else:D=B.children[0];E=B.children[1:H]
	if D=='await':D=E[0];E=E[1:]
	J=C.infer_node(D);from jedi.inference.syntax_tree import infer_trailer as N
	for A in E:J=N(C,J,A)
	return J
def get_names_of_node(node):
	A=node
	try:B=A.children
	except AttributeError:
		if A.type=='name':return[A]
		else:return[]
	else:return list(chain.from_iterable(get_names_of_node(A)for A in B))
def is_string(value):A=value;return A.is_compiled()and isinstance(A.get_safe_value(default=_A),str)
def is_literal(value):A=value;return is_number(A)or is_string(A)
def _get_safe_value_or_none(value,accept):
	A=value;A=A.get_safe_value(default=_A)
	if isinstance(A,accept):return A
def get_int_or_none(value):return _get_safe_value_or_none(value,int)
def get_str_or_none(value):return _get_safe_value_or_none(value,str)
def is_number(value):return _get_safe_value_or_none(value,(int,float))is not _A
class SimpleGetItemNotFound(Exception):0
@contextmanager
def reraise_getitem_errors(*A):
	try:yield
	except A as B:raise SimpleGetItemNotFound(B)
def parse_dotted_names(nodes,is_import_from,until_node=_A):
	C=until_node;D=0;B=[]
	for A in nodes[1:]:
		if A in('.','...'):
			if not B:D+=len(A.value)
		elif A.type=='dotted_name':
			for E in A.children[::2]:
				B.append(E)
				if E is C:break
			else:continue
			break
		elif A.type=='name':
			B.append(A)
			if A is C:break
		elif A==',':
			if not is_import_from:B=[]
		else:break
	return D,B
def values_from_qualified_names(inference_state,*A):return inference_state.import_module(A[:-1]).py__getattribute__(A[-1])
def is_big_annoying_library(context):
	A=context.get_root_context().string_names
	if A is _A:return _B
	return A[0]in('pandas','numpy','tensorflow','matplotlib')