from __future__ import annotations
_p='TRY_STRPTIME'
_o='returns_list_for_maps'
_n='UNNEST'
_m='STR_SPLIT_REGEX'
_l='STR_SPLIT'
_k='REGEXP_REPLACE'
_j='REGEXP_MATCHES'
_i='QUANTILE_DISC'
_h='QUANTILE_CONT'
_g='MAKE_TIME'
_f='ENCODE'
_e='DATE_TRUNC'
_d='DATEDIFF'
_c='UINTEGER'
_b='TIMESTAMP_NS'
_a='TIMESTAMP_MS'
_Z='TIMESTAMP_S'
_Y='EXCLUDE'
_X='EPOCH_MS'
_W='is_end_exclusive'
_V='ARRAY_REVERSE_SORT'
_U='safe'
_T='BLOB'
_S='RESERVOIR'
_R='duckdb'
_Q='DECODE'
_P='STRUCT_PACK'
_O='MAKE_TIMESTAMP'
_N='expression'
_M='ARRAY_SORT'
_L='STRPTIME'
_K='sec'
_J='EPOCH'
_I='TO_TIMESTAMP'
_H='STRFTIME'
_G='method'
_F='DATE_DIFF'
_E='TEXT'
_D=None
_C='this'
_B=True
_A=False
import typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.expressions import DATA_TYPE
from sqlglot.dialects.dialect import Dialect,JSON_EXTRACT_TYPE,NormalizationStrategy,approx_count_distinct_sql,arg_max_or_min_no_count,arrow_json_extract_sql,binary_from_function,bool_xor_sql,build_default_decimal_type,date_trunc_to_time,datestrtodate_sql,no_datetime_sql,encode_decode_sql,build_formatted_time,inline_array_unless_query,no_comment_column_constraint_sql,no_safe_divide_sql,no_time_sql,no_timestamp_sql,pivot_column_names,regexp_extract_sql,rename_func,str_position_sql,str_to_time_sql,timestamptrunc_sql,timestrtotime_sql,unit_to_var,unit_to_str,sha256_sql,build_regexp_extract
from sqlglot.helper import seq_get
from sqlglot.tokens import TokenType
from sqlglot.parser import binary_range_parser
DATETIME_DELTA=t.Union[exp.DateAdd,exp.TimeAdd,exp.DatetimeAdd,exp.TsOrDsAdd,exp.DateSub,exp.DatetimeSub]
WINDOW_FUNCS_WITH_IGNORE_NULLS=exp.FirstValue,exp.LastValue,exp.Lag,exp.Lead,exp.NthValue
def _date_delta_sql(self,expression):
	A=expression;B=A.this;D=unit_to_var(A);E='+'if isinstance(A,(exp.DateAdd,exp.TimeAdd,exp.DatetimeAdd,exp.TsOrDsAdd))else'-';C=_D
	if isinstance(A,exp.TsOrDsAdd):C=A.return_type
	elif B.is_string:C=exp.DataType.Type.DATETIME if isinstance(A,(exp.DatetimeAdd,exp.DatetimeSub))else exp.DataType.Type.DATE
	B=exp.cast(B,C)if C else B;return f"{self.sql(B)} {E} {self.sql(exp.Interval(this=A.expression,unit=D))}"
def _date_sql(self,expression):
	D=expression;A=self;B=f"CAST({A.sql(D,_C)} AS DATE)";E=A.sql(D,'zone')
	if E:C=A.func(_H,B,"'%d/%m/%Y'");C=f"{C} || ' ' || {E}";B=A.func(_L,C,"'%d/%m/%Y %Z'")
	return B
def _timediff_sql(self,expression):A=expression;B=exp.cast(A.this,exp.DataType.Type.TIME);C=exp.cast(A.expression,exp.DataType.Type.TIME);return self.func(_F,unit_to_str(A),C,B)
@generator.unsupported_args((_N,"DuckDB's ARRAY_SORT does not support a comparator."))
def _array_sort_sql(self,expression):return self.func(_M,expression.this)
def _sort_array_sql(self,expression):A=expression;B=_V if A.args.get('asc')==exp.false()else _M;return self.func(B,A.this)
def _build_sort_array_desc(args):return exp.SortArray(this=seq_get(args,0),asc=exp.false())
def _build_date_diff(args):A=args;return exp.DateDiff(this=seq_get(A,2),expression=seq_get(A,1),unit=seq_get(A,0))
def _build_generate_series(end_exclusive=_A):
	def A(args):
		A=args
		if len(A)==1:A.insert(0,exp.Literal.number('0'))
		B=exp.GenerateSeries.from_arg_list(A);B.set(_W,end_exclusive);return B
	return A
def _build_make_timestamp(args):
	A=args
	if len(A)==1:return exp.UnixToTime(this=seq_get(A,0),scale=exp.UnixToTime.MICROS)
	return exp.TimestampFromParts(year=seq_get(A,0),month=seq_get(A,1),day=seq_get(A,2),hour=seq_get(A,3),min=seq_get(A,4),sec=seq_get(A,5))
def _struct_sql(self,expression):
	D=expression;B=self;C=[];E=D.find_ancestor(exp.Cast);F=E and any(A.is_type(exp.DataType.Type.STRUCT)for A in E.find_all(exp.DataType))
	for(J,A)in enumerate(D.expressions):
		G=isinstance(A,exp.PropertyEQ);H=A.expression if G else A
		if F:C.append(B.sql(H))
		else:K=A.name if G else f"_{J}";C.append(f"{B.sql(exp.Literal.string(K))}: {B.sql(H)}")
	I=', '.join(C);return f"ROW({I})"if F else f"{{{I}}}"
def _datatype_sql(self,expression):
	B=self;A=expression
	if A.is_type('array'):return f"{B.expressions(A,flat=_B)}[{B.expressions(A,key="values",flat=_B)}]"
	if A.is_type(exp.DataType.Type.TIME,exp.DataType.Type.TIMETZ,exp.DataType.Type.TIMESTAMPTZ):return A.this.value
	return B.datatype_sql(A)
def _json_format_sql(self,expression):A=expression;B=self.func('TO_JSON',A.this,A.args.get('options'));return f"CAST({B} AS TEXT)"
def _unix_to_time_sql(self,expression):
	D=expression;A=self;B=D.args.get('scale');C=D.this
	if B in(_D,exp.UnixToTime.SECONDS):return A.func(_I,C)
	if B==exp.UnixToTime.MILLIS:return A.func(_X,C)
	if B==exp.UnixToTime.MICROS:return A.func(_O,C)
	return A.func(_I,exp.Div(this=C,expression=exp.func('POW',10,B)))
WRAPPED_JSON_EXTRACT_EXPRESSIONS=exp.Binary,exp.Bracket,exp.In
def _arrow_json_extract_sql(self,expression):
	A=expression;B=arrow_json_extract_sql(self,A)
	if not A.same_parent and isinstance(A.parent,WRAPPED_JSON_EXTRACT_EXPRESSIONS):B=self.wrap(B)
	return B
def _implicit_datetime_cast(arg,type=exp.DataType.Type.DATE):A=arg;return exp.cast(A,type)if isinstance(A,exp.Literal)else A
def _date_diff_sql(self,expression):A=expression;B=_implicit_datetime_cast(A.this);C=_implicit_datetime_cast(A.expression);return self.func(_F,unit_to_str(A),C,B)
def _generate_datetime_array_sql(self,expression):
	A=expression;C=isinstance(A,exp.GenerateDateArray);type=exp.DataType.Type.DATE if C else exp.DataType.Type.TIMESTAMP;D=_implicit_datetime_cast(A.args.get('start'),type=type);E=_implicit_datetime_cast(A.args.get('end'),type=type);B=exp.GenerateSeries(start=D,end=E,step=A.args.get('step'))
	if C:B=exp.cast(B,exp.DataType.build('ARRAY<DATE>'))
	return self.sql(B)
class DuckDB(Dialect):
	NULL_ORDERING='nulls_are_last';SUPPORTS_USER_DEFINED_TYPES=_A;SAFE_DIVISION=_B;INDEX_OFFSET=1;CONCAT_COALESCE=_B;SUPPORTS_ORDER_BY_ALL=_B;SUPPORTS_FIXED_SIZE_ARRAYS=_B;STRICT_JSON_PATH_SYNTAX=_A;NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_INSENSITIVE
	def to_json_path(C,path):
		A=path
		if isinstance(A,exp.Literal):
			B=A.name
			if B.startswith('/')or'[#'in B:return A
		return super().to_json_path(A)
	class Tokenizer(tokens.Tokenizer):HEREDOC_STRINGS=['$'];HEREDOC_TAG_IS_IDENTIFIER=_B;HEREDOC_STRING_ALTERNATIVE=TokenType.PARAMETER;KEYWORDS={**tokens.Tokenizer.KEYWORDS,'//':TokenType.DIV,'**':TokenType.DSTAR,'^@':TokenType.CARET_AT,'@>':TokenType.AT_GT,'<@':TokenType.LT_AT,'ATTACH':TokenType.COMMAND,'BINARY':TokenType.VARBINARY,'BITSTRING':TokenType.BIT,'BPCHAR':TokenType.TEXT,'CHAR':TokenType.TEXT,'CHARACTER VARYING':TokenType.TEXT,_Y:TokenType.EXCEPT,'LOGICAL':TokenType.BOOLEAN,'ONLY':TokenType.ONLY,'PIVOT_WIDER':TokenType.PIVOT,'POSITIONAL':TokenType.POSITIONAL,'SIGNED':TokenType.INT,'STRING':TokenType.TEXT,'SUMMARIZE':TokenType.SUMMARIZE,_Z:TokenType.TIMESTAMP_S,_a:TokenType.TIMESTAMP_MS,_b:TokenType.TIMESTAMP_NS,'TIMESTAMP_US':TokenType.TIMESTAMP,'UBIGINT':TokenType.UBIGINT,_c:TokenType.UINT,'USMALLINT':TokenType.USMALLINT,'UTINYINT':TokenType.UTINYINT,'VARCHAR':TokenType.TEXT};KEYWORDS.pop('/*+');SINGLE_TOKENS={**tokens.Tokenizer.SINGLE_TOKENS,'$':TokenType.PARAMETER}
	class Parser(parser.Parser):
		BITWISE={**parser.Parser.BITWISE,TokenType.TILDA:exp.RegexpLike};BITWISE.pop(TokenType.CARET);RANGE_PARSERS={**parser.Parser.RANGE_PARSERS,TokenType.DAMP:binary_range_parser(exp.ArrayOverlaps),TokenType.CARET_AT:binary_range_parser(exp.StartsWith)};EXPONENT={**parser.Parser.EXPONENT,TokenType.CARET:exp.Pow,TokenType.DSTAR:exp.Pow};FUNCTIONS_WITH_ALIASED_ARGS={*parser.Parser.FUNCTIONS_WITH_ALIASED_ARGS,_P};FUNCTIONS={**parser.Parser.FUNCTIONS,_V:_build_sort_array_desc,_M:exp.SortArray.from_arg_list,_d:_build_date_diff,_F:_build_date_diff,_e:date_trunc_to_time,'DATETRUNC':date_trunc_to_time,_Q:lambda args:exp.Decode(this=seq_get(args,0),charset=exp.Literal.string('utf-8')),_f:lambda args:exp.Encode(this=seq_get(args,0),charset=exp.Literal.string('utf-8')),_J:exp.TimeToUnix.from_arg_list,_X:lambda args:exp.UnixToTime(this=seq_get(args,0),scale=exp.UnixToTime.MILLIS),'JSON':exp.ParseJSON.from_arg_list,'JSON_EXTRACT_PATH':parser.build_extract_json_with_path(exp.JSONExtract),'JSON_EXTRACT_STRING':parser.build_extract_json_with_path(exp.JSONExtractScalar),'LIST_HAS':exp.ArrayContains.from_arg_list,'LIST_REVERSE_SORT':_build_sort_array_desc,'LIST_SORT':exp.SortArray.from_arg_list,'LIST_VALUE':lambda args:exp.Array(expressions=args),_g:exp.TimeFromParts.from_arg_list,_O:_build_make_timestamp,'MEDIAN':lambda args:exp.PercentileCont(this=seq_get(args,0),expression=exp.Literal.number(.5)),_h:exp.PercentileCont.from_arg_list,_i:exp.PercentileDisc.from_arg_list,'REGEXP_EXTRACT':build_regexp_extract,_j:exp.RegexpLike.from_arg_list,_k:lambda args:exp.RegexpReplace(this=seq_get(args,0),expression=seq_get(args,1),replacement=seq_get(args,2),modifiers=seq_get(args,3)),_H:build_formatted_time(exp.TimeToStr,_R),'STRING_SPLIT':exp.Split.from_arg_list,'STRING_SPLIT_REGEX':exp.RegexpSplit.from_arg_list,'STRING_TO_ARRAY':exp.Split.from_arg_list,_L:build_formatted_time(exp.StrToTime,_R),_P:exp.Struct.from_arg_list,_l:exp.Split.from_arg_list,_m:exp.RegexpSplit.from_arg_list,_I:exp.UnixToTime.from_arg_list,_n:exp.Explode.from_arg_list,'XOR':binary_from_function(exp.BitwiseXor),'GENERATE_SERIES':_build_generate_series(),'RANGE':_build_generate_series(end_exclusive=_B)};FUNCTIONS.pop('DATE_SUB');FUNCTIONS.pop('GLOB');FUNCTION_PARSERS=parser.Parser.FUNCTION_PARSERS.copy();FUNCTION_PARSERS.pop(_Q);NO_PAREN_FUNCTION_PARSERS={**parser.Parser.NO_PAREN_FUNCTION_PARSERS,'MAP':lambda self:self._parse_map()};TABLE_ALIAS_TOKENS=parser.Parser.TABLE_ALIAS_TOKENS-{TokenType.SEMI,TokenType.ANTI};PLACEHOLDER_PARSERS={**parser.Parser.PLACEHOLDER_PARSERS,TokenType.PARAMETER:lambda self:self.expression(exp.Placeholder,this=self._prev.text)if self._match(TokenType.NUMBER)or self._match_set(self.ID_VAR_TOKENS)else _D};TYPE_CONVERTERS={exp.DataType.Type.DECIMAL:build_default_decimal_type(precision=18,scale=3),exp.DataType.Type.TEXT:lambda dtype:exp.DataType.build(_E)}
		def _parse_table_sample(B,as_modifier=_A):
			A=super()._parse_table_sample(as_modifier=as_modifier)
			if A and not A.args.get(_G):
				if A.args.get('size'):A.set(_G,exp.var(_S))
				else:A.set(_G,exp.var('SYSTEM'))
			return A
		def _parse_bracket(B,this=_D):
			A=super()._parse_bracket(this)
			if isinstance(A,exp.Bracket):A.set(_o,_B)
			return A
		def _parse_map(A):
			if A._match(TokenType.L_BRACE,advance=_A):return A.expression(exp.ToMap,this=A._parse_bracket())
			B=A._parse_wrapped_csv(A._parse_assignment);return A.expression(exp.Map,keys=seq_get(B,0),values=seq_get(B,1))
		def _parse_struct_types(A,type_required=_A):return A._parse_field_def()
		def _pivot_column_names(B,aggregations):
			A=aggregations
			if len(A)==1:return super()._pivot_column_names(A)
			return pivot_column_names(A,dialect=_R)
	class Generator(generator.Generator):
		PARAMETER_TOKEN='$';NAMED_PLACEHOLDER_TOKEN='$';JOIN_HINTS=_A;TABLE_HINTS=_A;QUERY_HINTS=_A;LIMIT_FETCH='LIMIT';STRUCT_DELIMITER='(',')';RENAME_TABLE_WITH_DB=_A;NVL2_SUPPORTED=_A;SEMI_ANTI_JOIN_WITH_SIDE=_A;TABLESAMPLE_KEYWORDS='USING SAMPLE';TABLESAMPLE_SEED_KEYWORD='REPEATABLE';LAST_DAY_SUPPORTS_DATE_PART=_A;JSON_KEY_VALUE_PAIR_SEP=',';IGNORE_NULLS_IN_FUNC=_B;JSON_PATH_BRACKETED_KEY_SUPPORTED=_A;SUPPORTS_CREATE_TABLE_LIKE=_A;MULTI_ARG_DISTINCT=_A;CAN_IMPLEMENT_ARRAY_ANY=_B;SUPPORTS_TO_NUMBER=_A;COPY_HAS_INTO_KEYWORD=_A;STAR_EXCEPT=_Y;PAD_FILL_PATTERN_IS_REQUIRED=_B;ARRAY_CONCAT_IS_VAR_LEN=_A;TRANSFORMS={**generator.Generator.TRANSFORMS,exp.ApproxDistinct:approx_count_distinct_sql,exp.Array:inline_array_unless_query,exp.ArrayFilter:rename_func('LIST_FILTER'),exp.ArraySize:rename_func('ARRAY_LENGTH'),exp.ArgMax:arg_max_or_min_no_count('ARG_MAX'),exp.ArgMin:arg_max_or_min_no_count('ARG_MIN'),exp.ArraySort:_array_sort_sql,exp.ArraySum:rename_func('LIST_SUM'),exp.BitwiseXor:rename_func('XOR'),exp.CommentColumnConstraint:no_comment_column_constraint_sql,exp.CurrentDate:lambda*A:'CURRENT_DATE',exp.CurrentTime:lambda*A:'CURRENT_TIME',exp.CurrentTimestamp:lambda*A:'CURRENT_TIMESTAMP',exp.DayOfMonth:rename_func('DAYOFMONTH'),exp.DayOfWeek:rename_func('DAYOFWEEK'),exp.DayOfWeekIso:rename_func('ISODOW'),exp.DayOfYear:rename_func('DAYOFYEAR'),exp.DataType:_datatype_sql,exp.Date:_date_sql,exp.DateAdd:_date_delta_sql,exp.DateFromParts:rename_func('MAKE_DATE'),exp.DateSub:_date_delta_sql,exp.DateDiff:_date_diff_sql,exp.DateStrToDate:datestrtodate_sql,exp.Datetime:no_datetime_sql,exp.DatetimeSub:_date_delta_sql,exp.DatetimeAdd:_date_delta_sql,exp.DateToDi:lambda self,e:f"CAST(STRFTIME({self.sql(e,_C)}, {DuckDB.DATEINT_FORMAT}) AS INT)",exp.Decode:lambda self,e:encode_decode_sql(self,e,_Q,replace=_A),exp.DiToDate:lambda self,e:f"CAST(STRPTIME(CAST({self.sql(e,_C)} AS TEXT), {DuckDB.DATEINT_FORMAT}) AS DATE)",exp.Encode:lambda self,e:encode_decode_sql(self,e,_f,replace=_A),exp.GenerateDateArray:_generate_datetime_array_sql,exp.GenerateTimestampArray:_generate_datetime_array_sql,exp.Explode:rename_func(_n),exp.IntDiv:lambda self,e:self.binary(e,'//'),exp.IsInf:rename_func('ISINF'),exp.IsNan:rename_func('ISNAN'),exp.JSONExtract:_arrow_json_extract_sql,exp.JSONExtractScalar:_arrow_json_extract_sql,exp.JSONFormat:_json_format_sql,exp.LogicalOr:rename_func('BOOL_OR'),exp.LogicalAnd:rename_func('BOOL_AND'),exp.MD5Digest:lambda self,e:self.func('UNHEX',self.func('MD5',e.this)),exp.MonthsBetween:lambda self,e:self.func(_d,"'month'",exp.cast(e.expression,exp.DataType.Type.TIMESTAMP,copy=_B),exp.cast(e.this,exp.DataType.Type.TIMESTAMP,copy=_B)),exp.PercentileCont:rename_func(_h),exp.PercentileDisc:rename_func(_i),exp.Pivot:transforms.preprocess([transforms.unqualify_columns]),exp.RegexpExtract:regexp_extract_sql,exp.RegexpReplace:lambda self,e:self.func(_k,e.this,e.expression,e.args.get('replacement'),e.args.get('modifiers')),exp.RegexpLike:rename_func(_j),exp.RegexpSplit:rename_func(_m),exp.Return:lambda self,e:self.sql(e,_C),exp.ReturnsProperty:lambda self,e:'TABLE'if isinstance(e.this,exp.Schema)else'',exp.Rand:rename_func('RANDOM'),exp.SafeDivide:no_safe_divide_sql,exp.SHA:rename_func('SHA1'),exp.SHA2:sha256_sql,exp.Split:rename_func(_l),exp.SortArray:_sort_array_sql,exp.StrPosition:str_position_sql,exp.StrToUnix:lambda self,e:self.func(_J,self.func(_L,e.this,self.format_time(e))),exp.Struct:_struct_sql,exp.Transform:rename_func('LIST_TRANSFORM'),exp.TimeAdd:_date_delta_sql,exp.Time:no_time_sql,exp.TimeDiff:_timediff_sql,exp.Timestamp:no_timestamp_sql,exp.TimestampDiff:lambda self,e:self.func(_F,exp.Literal.string(e.unit),e.expression,e.this),exp.TimestampTrunc:timestamptrunc_sql(),exp.TimeStrToDate:lambda self,e:self.sql(exp.cast(e.this,exp.DataType.Type.DATE)),exp.TimeStrToTime:timestrtotime_sql,exp.TimeStrToUnix:lambda self,e:self.func(_J,exp.cast(e.this,exp.DataType.Type.TIMESTAMP)),exp.TimeToStr:lambda self,e:self.func(_H,e.this,self.format_time(e)),exp.TimeToUnix:rename_func(_J),exp.TsOrDiToDi:lambda self,e:f"CAST(SUBSTR(REPLACE(CAST({self.sql(e,_C)} AS TEXT), '-', ''), 1, 8) AS INT)",exp.TsOrDsAdd:_date_delta_sql,exp.TsOrDsDiff:lambda self,e:self.func(_F,f"'{e.args.get("unit")or"DAY"}'",exp.cast(e.expression,exp.DataType.Type.TIMESTAMP),exp.cast(e.this,exp.DataType.Type.TIMESTAMP)),exp.UnixToStr:lambda self,e:self.func(_H,self.func(_I,e.this),self.format_time(e)),exp.DatetimeTrunc:lambda self,e:self.func(_e,unit_to_str(e),exp.cast(e.this,exp.DataType.Type.DATETIME)),exp.UnixToTime:_unix_to_time_sql,exp.UnixToTimeStr:lambda self,e:f"CAST(TO_TIMESTAMP({self.sql(e,_C)}) AS TEXT)",exp.VariancePop:rename_func('VAR_POP'),exp.WeekOfYear:rename_func('WEEKOFYEAR'),exp.Xor:bool_xor_sql};SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript,exp.JSONPathWildcard};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.BINARY:_T,exp.DataType.Type.BPCHAR:_E,exp.DataType.Type.CHAR:_E,exp.DataType.Type.FLOAT:'REAL',exp.DataType.Type.NCHAR:_E,exp.DataType.Type.NVARCHAR:_E,exp.DataType.Type.UINT:_c,exp.DataType.Type.VARBINARY:_T,exp.DataType.Type.ROWVERSION:_T,exp.DataType.Type.VARCHAR:_E,exp.DataType.Type.TIMESTAMPNTZ:'TIMESTAMP',exp.DataType.Type.TIMESTAMP_S:_Z,exp.DataType.Type.TIMESTAMP_MS:_a,exp.DataType.Type.TIMESTAMP_NS:_b};RESERVED_KEYWORDS={'array','analyse','union','all','when','in_p','default','create_p','window','asymmetric','to','else','localtime','from','end_p','select','current_date','foreign','with','grant','session_user','or','except','references','fetch','limit','group_p','leading','into','collate','offset','do','then','localtimestamp','check_p','lateral_p','current_role','where','asc_p','placing','desc_p','user','unique','initially','column','both','some','as','any','only','deferrable','null_p','current_time','true_p','table','case','trailing','variadic','for','on','distinct','false_p','not','constraint','current_timestamp','returning','primary','intersect','having','analyze','current_user','and','cast','symmetric','using','order','current_catalog'};UNWRAPPED_INTERVAL_VALUES=exp.Literal,exp.Paren;PROPERTIES_LOCATION={A:exp.Properties.Location.UNSUPPORTED for A in generator.Generator.PROPERTIES_LOCATION};PROPERTIES_LOCATION[exp.LikeProperty]=exp.Properties.Location.POST_SCHEMA;PROPERTIES_LOCATION[exp.TemporaryProperty]=exp.Properties.Location.POST_CREATE;PROPERTIES_LOCATION[exp.ReturnsProperty]=exp.Properties.Location.POST_ALIAS
		def fromiso8601timestamp_sql(A,expression):return A.sql(exp.cast(expression.this,exp.DataType.Type.TIMESTAMPTZ))
		def strtotime_sql(B,expression):
			A=expression
			if A.args.get(_U):C=B.format_time(A);return f"CAST({B.func(_p,A.this,C)} AS TIMESTAMP)"
			return str_to_time_sql(B,A)
		def strtodate_sql(B,expression):
			A=expression
			if A.args.get(_U):C=B.format_time(A);return f"CAST({B.func(_p,A.this,C)} AS DATE)"
			return f"CAST({str_to_time_sql(B,A)} AS DATE)"
		def parsejson_sql(B,expression):
			C=expression;A=C.this
			if C.args.get(_U):return B.sql(exp.case().when(exp.func('json_valid',A),A).else_(exp.null()))
			return B.func('JSON',A)
		def timefromparts_sql(C,expression):
			A=expression;B=A.args.get('nano')
			if B is not _D:A.set(_K,A.args[_K]+B.pop()/exp.Literal.number(1e9))
			return rename_func(_g)(C,A)
		def timestampfromparts_sql(E,expression):
			A=expression;B=A.args[_K];C=A.args.get('milli')
			if C is not _D:B+=C.pop()/exp.Literal.number(1e3)
			D=A.args.get('nano')
			if D is not _D:B+=D.pop()/exp.Literal.number(1e9)
			if C or D:A.set(_K,B)
			return rename_func(_O)(E,A)
		def tablesample_sql(D,expression,tablesample_keyword=_D):
			C=tablesample_keyword;A=expression
			if not isinstance(A.parent,exp.Select):C='TABLESAMPLE'
			if A.args.get('size'):
				B=A.args.get(_G)
				if B and B.name.upper()!=_S:D.unsupported(f"Sampling method {B} is not supported with a discrete sample count, defaulting to reservoir sampling");A.set(_G,exp.var(_S))
			return super().tablesample_sql(A,tablesample_keyword=C)
		def interval_sql(D,expression):
			B=expression;A=_D;C=B.text('unit').lower()
			if C.startswith('week'):A=7
			if C.startswith('quarter'):A=90
			if A:return f"({A} * {super().interval_sql(exp.Interval(this=B.this,unit=exp.var("DAY")))})"
			return super().interval_sql(B)
		def columndef_sql(B,expression,sep=' '):
			A=expression
			if isinstance(A.parent,exp.UserDefinedFunction):return B.sql(A,_C)
			return super().columndef_sql(A,sep)
		def join_sql(B,expression):
			A=expression
			if A.side=='LEFT'and not A.args.get('on')and isinstance(A.this,exp.Unnest):return super().join_sql(A.on(exp.true()))
			return super().join_sql(A)
		def generateseries_sql(B,expression):
			A=expression
			if A.args.get(_W):return rename_func('RANGE')(B,A)
			return B.function_fallback_sql(A)
		def bracket_sql(E,expression):
			B=expression;A=B.this
			if isinstance(A,exp.Array):A.replace(exp.paren(A))
			C=super().bracket_sql(B)
			if not B.args.get(_o):
				if not A.type:from sqlglot.optimizer.annotate_types import annotate_types as D;A=D(A)
				if A.is_type(exp.DataType.Type.MAP):C=f"({C})[1]"
			return C
		def withingroup_sql(C,expression):
			A=expression;E=C.sql(A,_N);B=A.this
			if isinstance(B,exp.PERCENTILES):
				D=A.find(exp.Ordered)
				if D:B.set(_N,B.this);B.set(_C,D.this)
			F=C.sql(A,_C).rstrip(')');return f"{F}{E})"
		def length_sql(B,expression):
			D=expression;C='LENGTH';A=D.this
			if not D.args.get('binary')or A.is_string:return B.func(C,A)
			if not A.type:from sqlglot.optimizer.annotate_types import annotate_types as E;A=E(A)
			if A.is_type(*exp.DataType.TEXT_TYPES):return B.func(C,A)
			F=exp.cast(A,exp.DataType.Type.VARBINARY);G=exp.cast(A,exp.DataType.Type.VARCHAR);H=exp.case(B.func('TYPEOF',A)).when("'VARCHAR'",exp.Anonymous(this=C,expressions=[G])).when("'BLOB'",B.func('OCTET_LENGTH',F));return B.sql(H)
		def objectinsert_sql(A,expression):
			B=expression;C=B.this;D=B.args.get('key');F=D.name if isinstance(D,exp.Expression)else'';G=A.sql(B,'value');E=f"{F} := {G}"
			if isinstance(C,exp.Struct)and not C.expressions:return A.func(_P,E)
			return A.func('STRUCT_INSERT',C,E)
		def unnest_sql(D,expression):
			C='alias';A=expression;E=A.args.get('explode_array')
			if E:
				A.expressions.append(exp.Kwarg(this=exp.var('max_depth'),expression=exp.Literal.number(2)));B=A.args.get(C)
				if B:A.set(C,_D);B=exp.TableAlias(this=seq_get(B.args.get('columns'),0))
				F=super().unnest_sql(A);G=exp.Select(expressions=[F]).subquery(B);return D.sql(G)
			return super().unnest_sql(A)
		def ignorenulls_sql(B,expression):
			A=expression
			if isinstance(A.this,WINDOW_FUNCS_WITH_IGNORE_NULLS):return super().ignorenulls_sql(A)
			return B.sql(A,_C)
		def arraytostring_sql(A,expression):
			B=expression;C=A.sql(B,_C);D=A.sql(B,'null')
			if D:C=f"LIST_TRANSFORM({C}, x -> COALESCE(x, {D}))"
			return A.func('ARRAY_TO_STRING',C,B.expression)