from __future__ import annotations
_N='JSON_EXTRACT_PATH_TEXT'
_M='sysdate'
_L='TO_HEX'
_K='SYSDATE'
_J='STRTOL'
_I='SPLIT_TO_ARRAY'
_H='LISTAGG'
_G='DATEDIFF'
_F='DATEADD'
_E='TIMESTAMP'
_D='this'
_C='VARBYTE'
_B=True
_A=False
import typing as t
from sqlglot import exp,transforms
from sqlglot.dialects.dialect import NormalizationStrategy,concat_to_dpipe_sql,concat_ws_to_dpipe_sql,date_delta_sql,generatedasidentitycolumnconstraint_sql,json_extract_segments,no_tablesample_sql,rename_func,map_date_part
from sqlglot.dialects.postgres import Postgres
from sqlglot.helper import seq_get
from sqlglot.tokens import TokenType
from sqlglot.parser import build_convert_timezone
if t.TYPE_CHECKING:from sqlglot._typing import E
def _build_date_delta(expr_type):
	B=expr_type
	def A(args):
		A=args;C=B(this=seq_get(A,2),expression=seq_get(A,1),unit=map_date_part(seq_get(A,0)))
		if B is exp.TsOrDsAdd:C.set('return_type',exp.DataType.build(_E))
		return C
	return A
class Redshift(Postgres):
	NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_INSENSITIVE;SUPPORTS_USER_DEFINED_TYPES=_A;INDEX_OFFSET=0;COPY_PARAMS_ARE_CSV=_A;HEX_LOWERCASE=_B;HAS_DISTINCT_ARRAY_CONSTRUCTORS=_B;TIME_FORMAT="'YYYY-MM-DD HH24:MI:SS'";TIME_MAPPING={**Postgres.TIME_MAPPING,'MON':'%b','HH24':'%H','HH':'%I'}
	class Parser(Postgres.Parser):
		FUNCTIONS={**Postgres.Parser.FUNCTIONS,'ADD_MONTHS':lambda args:exp.TsOrDsAdd(this=seq_get(args,0),expression=seq_get(args,1),unit=exp.var('month'),return_type=exp.DataType.build(_E)),'CONVERT_TIMEZONE':lambda args:build_convert_timezone(args,'UTC'),_F:_build_date_delta(exp.TsOrDsAdd),'DATE_ADD':_build_date_delta(exp.TsOrDsAdd),_G:_build_date_delta(exp.TsOrDsDiff),'DATE_DIFF':_build_date_delta(exp.TsOrDsDiff),'GETDATE':exp.CurrentTimestamp.from_arg_list,_H:exp.GroupConcat.from_arg_list,_I:lambda args:exp.StringToArray(this=seq_get(args,0),expression=seq_get(args,1)or exp.Literal.string(',')),_J:exp.FromBase.from_arg_list};NO_PAREN_FUNCTION_PARSERS={**Postgres.Parser.NO_PAREN_FUNCTION_PARSERS,'APPROXIMATE':lambda self:self._parse_approximate_count(),_K:lambda self:self.expression(exp.CurrentTimestamp,sysdate=_B)};SUPPORTS_IMPLICIT_UNNEST=_B
		def _parse_table(A,schema=_A,joins=_A,alias_tokens=None,parse_bracket=_A,is_db_reference=_A,parse_partition=_A):C=A._match(TokenType.UNPIVOT);B=super()._parse_table(schema=schema,joins=joins,alias_tokens=alias_tokens,parse_bracket=parse_bracket,is_db_reference=is_db_reference);return A.expression(exp.Pivot,this=B,unpivot=_B)if C else B
		def _parse_convert(A,strict,safe=None):B=A._parse_types();A._match(TokenType.COMMA);C=A._parse_bitwise();return A.expression(exp.TryCast,this=C,to=B,safe=safe)
		def _parse_approximate_count(A):
			C=A._index-1;B=A._parse_function()
			if isinstance(B,exp.Count)and isinstance(B.this,exp.Distinct):return A.expression(exp.ApproxDistinct,this=seq_get(B.this.expressions,0))
			A._retreat(C)
	class Tokenizer(Postgres.Tokenizer):BIT_STRINGS=[];HEX_STRINGS=[];STRING_ESCAPES=['\\',"'"];KEYWORDS={**Postgres.Tokenizer.KEYWORDS,'(+)':TokenType.JOIN_MARKER,'HLLSKETCH':TokenType.HLLSKETCH,'MINUS':TokenType.EXCEPT,'SUPER':TokenType.SUPER,'TOP':TokenType.TOP,'UNLOAD':TokenType.COMMAND,_C:TokenType.VARBINARY,'BINARY VARYING':TokenType.VARBINARY};KEYWORDS.pop('VALUES');SINGLE_TOKENS=Postgres.Tokenizer.SINGLE_TOKENS.copy();SINGLE_TOKENS.pop('#')
	class Generator(Postgres.Generator):
		LOCKING_READS_SUPPORTED=_A;QUERY_HINTS=_A;VALUES_AS_TABLE=_A;TZ_TO_WITH_TIME_ZONE=_B;NVL2_SUPPORTED=_B;LAST_DAY_SUPPORTS_DATE_PART=_A;CAN_IMPLEMENT_ARRAY_ANY=_A;MULTI_ARG_DISTINCT=_B;COPY_PARAMS_ARE_WRAPPED=_A;HEX_FUNC=_L;PARSE_JSON_NAME='JSON_PARSE';ARRAY_CONCAT_IS_VAR_LEN=_A;SUPPORTS_CONVERT_TIMEZONE=_B;EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE=_A;WITH_PROPERTIES_PREFIX=' ';TYPE_MAPPING={**Postgres.Generator.TYPE_MAPPING,exp.DataType.Type.BINARY:_C,exp.DataType.Type.INT:'INTEGER',exp.DataType.Type.TIMETZ:'TIME',exp.DataType.Type.TIMESTAMPTZ:_E,exp.DataType.Type.VARBINARY:_C,exp.DataType.Type.ROWVERSION:_C};TRANSFORMS={**Postgres.Generator.TRANSFORMS,exp.ArrayConcat:lambda self,e:self.arrayconcat_sql(e,name='ARRAY_CONCAT'),exp.Concat:concat_to_dpipe_sql,exp.ConcatWs:concat_ws_to_dpipe_sql,exp.ApproxDistinct:lambda self,e:f"APPROXIMATE COUNT(DISTINCT {self.sql(e,_D)})",exp.CurrentTimestamp:lambda self,e:_K if e.args.get(_M)else'GETDATE()',exp.DateAdd:date_delta_sql(_F),exp.DateDiff:date_delta_sql(_G),exp.DistKeyProperty:lambda self,e:self.func('DISTKEY',e.this),exp.DistStyleProperty:lambda self,e:self.naked_property(e),exp.Explode:lambda self,e:self.explode_sql(e),exp.FromBase:rename_func(_J),exp.GeneratedAsIdentityColumnConstraint:generatedasidentitycolumnconstraint_sql,exp.JSONExtract:json_extract_segments(_N),exp.JSONExtractScalar:json_extract_segments(_N),exp.GroupConcat:rename_func(_H),exp.Hex:lambda self,e:self.func('UPPER',self.func(_L,self.sql(e,_D))),exp.Select:transforms.preprocess([transforms.eliminate_distinct_on,transforms.eliminate_semi_and_anti_joins,transforms.unqualify_unnest,transforms.unnest_generate_date_array_using_recursive_cte]),exp.SortKeyProperty:lambda self,e:f"{"COMPOUND "if e.args["compound"]else""}SORTKEY({self.format_args(*e.this)})",exp.StartsWith:lambda self,e:f"{self.sql(e.this)} LIKE {self.sql(e.expression)} || '%'",exp.StringToArray:rename_func(_I),exp.TableSample:no_tablesample_sql,exp.TsOrDsAdd:date_delta_sql(_F),exp.TsOrDsDiff:date_delta_sql(_G),exp.UnixToTime:lambda self,e:f"(TIMESTAMP 'epoch' + {self.sql(e.this)} * INTERVAL '1 SECOND')"};TRANSFORMS.pop(exp.Pivot);TRANSFORMS.pop(exp.ParseJSON);TRANSFORMS.pop(exp.Pow);TRANSFORMS.pop(exp.AnyValue);TRANSFORMS.pop(exp.LastDay);TRANSFORMS.pop(exp.SHA2);RESERVED_KEYWORDS={'aes128','aes256','all','allowoverwrite','analyse','analyze','and','any','array','as','asc','authorization','az64','backup','between','binary','blanksasnull','both','bytedict','bzip2','case','cast','check','collate','column','constraint','create','credentials','cross','current_date','current_time','current_timestamp','current_user','current_user_id','default','deferrable','deflate','defrag','delta','delta32k','desc','disable','distinct','do','else','emptyasnull','enable','encode','encrypt     ','encryption','end','except','explicit','false','for','foreign','freeze','from','full','globaldict256','globaldict64k','grant','group','gzip','having','identity','ignore','ilike','in','initially','inner','intersect','interval','into','is','isnull','join','leading','left','like','limit','localtime','localtimestamp','lun','luns','lzo','lzop','minus','mostly16','mostly32','mostly8','natural','new','not','notnull','null','nulls','off','offline','offset','oid','old','on','only','open','or','order','outer','overlaps','parallel','partition','percent','permissions','pivot','placing','primary','raw','readratio','recover','references','rejectlog','resort','respect','restore','right','select','session_user','similar','snapshot','some',_M,'system','table','tag','tdes','text255','text32k','then','timestamp','to','top','trailing','true','truncatecolumns','type','union','unique','unnest','unpivot','user','using','verbose','wallet','when','where','with','without'}
		def unnest_sql(A,expression):
			B=expression;C=B.expressions;D=len(C)
			if D!=1:A.unsupported(f"Unsupported number of arguments in UNNEST: {D}");return''
			if isinstance(B.find_ancestor(exp.From,exp.Join,exp.Select),exp.Select):A.unsupported('Unsupported UNNEST when not used in FROM/JOIN clauses');return''
			E=A.sql(seq_get(C,0));F=A.expressions(B.args.get('alias'),key='columns',flat=_B);return f"{E} AS {F}"if F else E
		def cast_sql(B,expression,safe_prefix=None):
			A=expression
			if A.is_type(exp.DataType.Type.JSON):return B.sql(A,_D)
			return super().cast_sql(A,safe_prefix=safe_prefix)
		def datatype_sql(D,expression):
			'\n            Redshift converts the `TEXT` data type to `VARCHAR(255)` by default when people more generally mean\n            VARCHAR of max length which is `VARCHAR(max)` in Redshift. Therefore if we get a `TEXT` data type\n            without precision we convert it to `VARCHAR(max)` and if it does have precision then we just convert\n            `TEXT` to `VARCHAR`.\n            ';B='expressions';A=expression
			if A.is_type('text'):
				A.set(_D,exp.DataType.Type.VARCHAR);C=A.args.get(B)
				if not C:A.append(B,exp.var('MAX'))
			return super().datatype_sql(A)
		def alterset_sql(D,expression):E=expression;A=D.expressions(E,flat=_B);A=f" TABLE PROPERTIES ({A})"if A else'';B=D.sql(E,'location');B=f" LOCATION {B}"if B else'';C=D.expressions(E,key='file_format',flat=_B,sep=' ');C=f" FILE FORMAT {C}"if C else'';return f"SET{A}{B}{C}"
		def array_sql(B,expression):
			A=expression
			if A.args.get('bracket_notation'):return super().array_sql(A)
			return rename_func('ARRAY')(B,A)
		def explode_sql(A,expression):A.unsupported('Unsupported EXPLODE() function');return''