from __future__ import annotations
_I='FROM_UNIXTIME'
_H='DATETIME'
_G='expressions'
_F='PROPERTIES'
_E='REGEXP'
_D='DATE_DIFF'
_C='DATE_TRUNC'
_B='properties'
_A=False
import typing as t
from sqlglot import exp
from sqlglot.dialects.dialect import approx_count_distinct_sql,arrow_json_extract_sql,build_timestamp_trunc,rename_func,unit_to_str,inline_array_sql,property_sql
from sqlglot.dialects.mysql import MySQL
from sqlglot.helper import seq_get
class StarRocks(MySQL):
	STRICT_JSON_PATH_SYNTAX=_A
	class Parser(MySQL.Parser):
		FUNCTIONS={**MySQL.Parser.FUNCTIONS,_C:build_timestamp_trunc,'DATEDIFF':lambda args:exp.DateDiff(this=seq_get(args,0),expression=seq_get(args,1),unit=exp.Literal.string('DAY')),_D:lambda args:exp.DateDiff(this=seq_get(args,1),expression=seq_get(args,2),unit=seq_get(args,0)),_E:exp.RegexpLike.from_arg_list};PROPERTY_PARSERS={**MySQL.Parser.PROPERTY_PARSERS,_F:lambda self:self._parse_wrapped_properties()}
		def _parse_create(D):
			A=super()._parse_create()
			if isinstance(A,exp.Create)and isinstance(A.this,exp.Schema):
				B=A.args.get(_B)
				if B:
					C=B.find(exp.PrimaryKey)
					if C:A.this.append(_G,C.pop())
			return A
		def _parse_unnest(F,with_alias=True):
			E='columns';D='alias';C='unnest';B=super()._parse_unnest(with_alias=with_alias)
			if B:
				A=B.args.get(D)
				if not A:A=exp.TableAlias(this=exp.to_identifier(C),columns=[exp.to_identifier(C)]);B.set(D,A)
				elif not A.args.get(E):A.set(E,[exp.to_identifier(C)])
			return B
	class Generator(MySQL.Generator):
		EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE=_A;JSON_TYPE_REQUIRED_FOR_EXTRACTION=_A;VARCHAR_REQUIRES_SIZE=_A;PARSE_JSON_NAME:t.Optional[str]='PARSE_JSON';WITH_PROPERTIES_PREFIX=_F;CAST_MAPPING={};TYPE_MAPPING={**MySQL.Generator.TYPE_MAPPING,exp.DataType.Type.TEXT:'STRING',exp.DataType.Type.TIMESTAMP:_H,exp.DataType.Type.TIMESTAMPTZ:_H};PROPERTIES_LOCATION={**MySQL.Generator.PROPERTIES_LOCATION,exp.PrimaryKey:exp.Properties.Location.POST_SCHEMA};TRANSFORMS={**MySQL.Generator.TRANSFORMS,exp.Array:inline_array_sql,exp.ApproxDistinct:approx_count_distinct_sql,exp.DateDiff:lambda self,e:self.func(_D,unit_to_str(e),e.this,e.expression),exp.JSONExtractScalar:arrow_json_extract_sql,exp.JSONExtract:arrow_json_extract_sql,exp.Property:property_sql,exp.RegexpLike:rename_func(_E),exp.StrToUnix:lambda self,e:self.func('UNIX_TIMESTAMP',e.this,self.format_time(e)),exp.TimestampTrunc:lambda self,e:self.func(_C,unit_to_str(e),e.this),exp.TimeStrToDate:rename_func('TO_DATE'),exp.UnixToStr:lambda self,e:self.func(_I,e.this,self.format_time(e)),exp.UnixToTime:rename_func(_I),exp.ArrayFilter:rename_func('ARRAY_FILTER')};TRANSFORMS.pop(exp.DateTrunc)
		def create_sql(G,expression):
			B=expression;C=B.this
			if isinstance(C,exp.Schema):
				D=C.find(exp.PrimaryKey)
				if D:
					A=B.args.get(_B)
					if not A:A=exp.Properties(expressions=[]);B.set(_B,A)
					E=A.find(exp.EngineProperty);F=E.index or 0 if E else-1;A.set(_G,D.pop(),F+1,overwrite=_A)
			return super().create_sql(B)