from __future__ import annotations
_H='RANDOM'
_G='ST_GEOMETRY'
_F='SAMPLE'
_E='QUARTER'
_D='%a'
_C=False
_B=True
_A='this'
import typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,max_or_greatest,min_or_least,rename_func,to_number_with_nls_param
from sqlglot.helper import seq_get
from sqlglot.tokens import TokenType
def _date_add_sql(kind):
	def A(self,expression):
		C=expression;B=self;E=B.sql(C,_A);F=C.args.get('unit');A=B._simplify_unless_literal(C.expression)
		if not isinstance(A,exp.Literal):B.unsupported('Cannot add non literal')
		if isinstance(A,exp.Neg):D={'+':'-','-':'+'};A=exp.Literal.string(A.this.to_py())
		else:D={'+':'+','-':'-'};A.set('is_string',_B)
		return f"{E} {D[kind]} {B.sql(exp.Interval(this=A,unit=F))}"
	return A
class Teradata(Dialect):
	SUPPORTS_SEMI_ANTI_JOIN=_C;TYPED_DIVISION=_B;TIME_MAPPING={'YY':'%y','Y4':'%Y','YYYY':'%Y','M4':'%B','M3':'%b','M':'%-M','MI':'%M','MM':'%m','MMM':'%b','MMMM':'%B','D':'%-d','DD':'%d','D3':'%j','DDD':'%j','H':'%-H','HH':'%H','HH24':'%H','S':'%-S','SS':'%S','SSSSSS':'%f','E':_D,'EE':_D,'E3':_D,'E4':'%A','EEE':_D,'EEEE':'%A'}
	class Tokenizer(tokens.Tokenizer):KEYWORDS={**tokens.Tokenizer.KEYWORDS,'**':TokenType.DSTAR,'^=':TokenType.NEQ,'BYTEINT':TokenType.SMALLINT,'COLLECT':TokenType.COMMAND,'DEL':TokenType.DELETE,'EQ':TokenType.EQ,'GE':TokenType.GTE,'GT':TokenType.GT,'HELP':TokenType.COMMAND,'INS':TokenType.INSERT,'LE':TokenType.LTE,'LT':TokenType.LT,'MINUS':TokenType.EXCEPT,'MOD':TokenType.MOD,'NE':TokenType.NEQ,'NOT=':TokenType.NEQ,_F:TokenType.TABLE_SAMPLE,'SEL':TokenType.SELECT,_G:TokenType.GEOMETRY,'TOP':TokenType.TOP,'UPD':TokenType.UPDATE};KEYWORDS.pop('/*+');SINGLE_TOKENS={**tokens.Tokenizer.SINGLE_TOKENS};SINGLE_TOKENS.pop('%')
	class Parser(parser.Parser):
		TABLESAMPLE_CSV=_B;VALUES_FOLLOWED_BY_PAREN=_C;CHARSET_TRANSLATORS={'GRAPHIC_TO_KANJISJIS','GRAPHIC_TO_LATIN','GRAPHIC_TO_UNICODE','GRAPHIC_TO_UNICODE_PadSpace','KANJI1_KanjiEBCDIC_TO_UNICODE','KANJI1_KanjiEUC_TO_UNICODE','KANJI1_KANJISJIS_TO_UNICODE','KANJI1_SBC_TO_UNICODE','KANJISJIS_TO_GRAPHIC','KANJISJIS_TO_LATIN','KANJISJIS_TO_UNICODE','LATIN_TO_GRAPHIC','LATIN_TO_KANJISJIS','LATIN_TO_UNICODE','LOCALE_TO_UNICODE','UNICODE_TO_GRAPHIC','UNICODE_TO_GRAPHIC_PadGraphic','UNICODE_TO_GRAPHIC_VarGraphic','UNICODE_TO_KANJI1_KanjiEBCDIC','UNICODE_TO_KANJI1_KanjiEUC','UNICODE_TO_KANJI1_KANJISJIS','UNICODE_TO_KANJI1_SBC','UNICODE_TO_KANJISJIS','UNICODE_TO_LATIN','UNICODE_TO_LOCALE','UNICODE_TO_UNICODE_FoldSpace','UNICODE_TO_UNICODE_Fullwidth','UNICODE_TO_UNICODE_Halfwidth','UNICODE_TO_UNICODE_NFC','UNICODE_TO_UNICODE_NFD','UNICODE_TO_UNICODE_NFKC','UNICODE_TO_UNICODE_NFKD'};FUNC_TOKENS={*parser.Parser.FUNC_TOKENS};FUNC_TOKENS.remove(TokenType.REPLACE);STATEMENT_PARSERS={**parser.Parser.STATEMENT_PARSERS,TokenType.DATABASE:lambda self:self.expression(exp.Use,this=self._parse_table(schema=_C)),TokenType.REPLACE:lambda self:self._parse_create()};FUNCTION_PARSERS={**parser.Parser.FUNCTION_PARSERS,'TRYCAST':parser.Parser.FUNCTION_PARSERS['TRY_CAST'],'RANGE_N':lambda self:self._parse_rangen(),'TRANSLATE':lambda self:self._parse_translate(self.STRICT_CAST)};FUNCTIONS={**parser.Parser.FUNCTIONS,_H:lambda args:exp.Rand(lower=seq_get(args,0),upper=seq_get(args,1))};EXPONENT={TokenType.DSTAR:exp.Pow}
		def _parse_translate(A,strict):
			B=A._parse_assignment()
			if not A._match(TokenType.USING):A.raise_error('Expected USING in TRANSLATE')
			if A._match_texts(A.CHARSET_TRANSLATORS):C=A._prev.text.split('_TO_');D=A.expression(exp.CharacterSet,this=C[1])
			else:A.raise_error('Expected a character set translator after USING in TRANSLATE')
			return A.expression(exp.Cast if strict else exp.TryCast,this=B,to=D)
		def _parse_update(A):return A.expression(exp.Update,**{_A:A._parse_table(alias_tokens=A.UPDATE_ALIAS_TOKENS),'from':A._parse_from(joins=_B),'expressions':A._match(TokenType.SET)and A._parse_csv(A._parse_equality),'where':A._parse_where()})
		def _parse_rangen(A):B=A._parse_id_var();A._match(TokenType.BETWEEN);C=A._parse_csv(A._parse_assignment);D=A._match_text_seq('EACH')and A._parse_assignment();return A.expression(exp.RangeN,this=B,expressions=C,each=D)
		def _parse_index_params(B):
			A=super()._parse_index_params()
			if A.args.get('on'):A.set('on',None);B._retreat(B._index-2)
			return A
	class Generator(generator.Generator):
		LIMIT_IS_TOP=_B;JOIN_HINTS=_C;TABLE_HINTS=_C;QUERY_HINTS=_C;TABLESAMPLE_KEYWORDS=_F;LAST_DAY_SUPPORTS_DATE_PART=_C;CAN_IMPLEMENT_ARRAY_ANY=_B;TZ_TO_WITH_TIME_ZONE=_B;TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.GEOMETRY:_G,exp.DataType.Type.DOUBLE:'DOUBLE PRECISION',exp.DataType.Type.TIMESTAMPTZ:'TIMESTAMP'};PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.OnCommitProperty:exp.Properties.Location.POST_INDEX,exp.PartitionedByProperty:exp.Properties.Location.POST_EXPRESSION,exp.StabilityProperty:exp.Properties.Location.POST_CREATE};TRANSFORMS={**generator.Generator.TRANSFORMS,exp.ArgMax:rename_func('MAX_BY'),exp.ArgMin:rename_func('MIN_BY'),exp.ArraySize:rename_func('CARDINALITY'),exp.Max:max_or_greatest,exp.Min:min_or_least,exp.Pow:lambda self,e:self.binary(e,'**'),exp.Rand:lambda self,e:self.func(_H,e.args.get('lower'),e.args.get('upper')),exp.Select:transforms.preprocess([transforms.eliminate_distinct_on,transforms.eliminate_semi_and_anti_joins]),exp.StrToDate:lambda self,e:f"CAST({self.sql(e,_A)} AS DATE FORMAT {self.format_time(e)})",exp.ToChar:lambda self,e:self.function_fallback_sql(e),exp.ToNumber:to_number_with_nls_param,exp.Use:lambda self,e:f"DATABASE {self.sql(e,_A)}",exp.DateAdd:_date_add_sql('+'),exp.DateSub:_date_add_sql('-'),exp.Quarter:lambda self,e:self.sql(exp.Extract(this=_E,expression=e.this))}
		def currenttimestamp_sql(B,expression):A=expression;C,D=('(',')')if A.this else('','');return B.func('CURRENT_TIMESTAMP',A.this,prefix=C,suffix=D)
		def cast_sql(B,expression,safe_prefix=None):
			A=expression
			if A.to.this==exp.DataType.Type.UNKNOWN and A.args.get('format'):A.to.pop()
			return super().cast_sql(A,safe_prefix=safe_prefix)
		def trycast_sql(A,expression):return A.cast_sql(expression,safe_prefix='TRY')
		def tablesample_sql(A,expression,tablesample_keyword=None):B=expression;return f"{A.sql(B,_A)} SAMPLE {A.expressions(B)}"
		def partitionedbyproperty_sql(A,expression):return f"PARTITION BY {A.sql(expression,_A)}"
		def update_sql(A,expression):B=expression;C=A.sql(B,_A);D=A.sql(B,'from');E=A.expressions(B,flat=_B);F=A.sql(B,'where');G=f"UPDATE {C}{D} SET {E}{F}";return A.prepend_ctes(B,G)
		def mod_sql(A,expression):return A.binary(expression,'MOD')
		def datatype_sql(D,expression):A=expression;B=super().datatype_sql(A);C=A.args.get('prefix');return f"SYSUDTLIB.{B}"if C else B
		def rangen_sql(B,expression):C=expression;D=B.sql(C,_A);E=B.expressions(C);A=B.sql(C,'each');A=f" EACH {A}"if A else'';return f"RANGE_N({D} BETWEEN {E}{A})"
		def createable_sql(A,expression,locations):
			C=locations;B=expression;D=A.sql(B,'kind').upper()
			if D=='TABLE'and C.get(exp.Properties.Location.POST_NAME):E=A.sql(B.this,_A);F=A.properties(exp.Properties(expressions=C[exp.Properties.Location.POST_NAME]),wrapped=_C,prefix=',');G=A.schema_columns_sql(B.this);return f"{E}{F}{A.sep()}{G}"
			return super().createable_sql(B,C)
		def extract_sql(B,expression):
			A=expression;C=B.sql(A,_A)
			if C.upper()!=_E:return super().extract_sql(A)
			D=exp.func('to_char',A.expression,exp.Literal.string('Q'));return B.sql(exp.cast(D,exp.DataType.Type.INT))
		def interval_sql(D,expression):
			B=expression;A=0;C=B.text('unit')
			if C.startswith('WEEK'):A=7
			elif C.startswith(_E):A=90
			if A:return f"({A} * {super().interval_sql(exp.Interval(this=B.this,unit=exp.var("DAY")))})"
			return super().interval_sql(B)