from __future__ import annotations
_C='comments'
_B='DataType.Type'
_A='class'
import typing as t
from sqlglot import expressions as exp
if t.TYPE_CHECKING:JSON=t.Union[dict,list,str,float,int,bool,None];Node=t.Union[t.List['Node'],exp.DataType.Type,exp.Expression,JSON]
def dump(node):
	'\n    Recursively dump an AST into a JSON-serializable dict.\n    ';A=node
	if isinstance(A,list):return[dump(A)for A in A]
	if isinstance(A,exp.DataType.Type):return{_A:_B,'value':A.value}
	if isinstance(A,exp.Expression):
		C=A.__class__.__qualname__
		if A.__class__.__module__!=exp.__name__:C=f"{A.__module__}.{C}"
		B={_A:C,'args':{B:dump(A)for(B,A)in A.args.items()if A is not None and A!=[]}}
		if A.type:B['type']=dump(A.type)
		if A.comments:B[_C]=A.comments
		if A._meta is not None:B['meta']=A._meta
		return B
	return A
def load(obj):
	'\n    Recursively load a dict (as returned by `dump`) into an AST.\n    ';A=obj
	if isinstance(A,list):return[load(A)for A in A]
	if isinstance(A,dict):
		B=A[_A]
		if B==_B:return exp.DataType.Type(A['value'])
		if'.'in B:E,B=B.rsplit('.',maxsplit=1);D=__import__(E,fromlist=[B])
		else:D=exp
		F=getattr(D,B);C=F(**{A:load(B)for(A,B)in A['args'].items()});C.type=t.cast(exp.DataType,load(A.get('type')));C.comments=A.get(_C);C._meta=A.get('meta');return C
	return A