'filter'
from sqlparse import lexer
from sqlparse.engine import grouping
from sqlparse.engine.statement_splitter import StatementSplitter
from sqlparse.filters import StripTrailingSemicolonFilter
class FilterStack:
	def __init__(A,strip_semicolon=False):
		A.preprocess=[];A.stmtprocess=[];A.postprocess=[];A._grouping=False
		if strip_semicolon:A.stmtprocess.append(StripTrailingSemicolonFilter())
	def enable_grouping(A):A._grouping=True
	def run(D,sql,encoding=None):
		B=lexer.tokenize(sql,encoding)
		for C in D.preprocess:B=C.process(B)
		B=StatementSplitter().process(B)
		for A in B:
			if D._grouping:A=grouping.group(A)
			for C in D.stmtprocess:C.process(A)
			for C in D.postprocess:A=C.process(A)
			yield A