_B=True
_A=False
from sqlparse import sql,tokens as T
class StatementSplitter:
	'Filter that split stream at individual statements'
	def __init__(A):A._reset()
	def _reset(A):'Set the filter attributes to its default values';A._in_declare=_A;A._in_case=_A;A._is_create=_A;A._begin_depth=0;A.consume_ws=_A;A.tokens=[];A.level=0
	def _change_splitlevel(A,ttype,value):
		'Get the new split level (increase, decrease or remain equal)';E='CASE';D=value;C=ttype
		if C is T.Punctuation and D=='(':return 1
		elif C is T.Punctuation and D==')':return-1
		elif C not in T.Keyword:return 0
		B=D.upper()
		if C is T.Keyword.DDL and B.startswith('CREATE'):A._is_create=_B;return 0
		if B=='DECLARE'and A._is_create and A._begin_depth==0:A._in_declare=_B;return 1
		if B=='BEGIN':
			A._begin_depth+=1
			if A._is_create:return 1
			return 0
		if B=='END':
			if not A._in_case:A._begin_depth=max(0,A._begin_depth-1)
			else:A._in_case=_A
			return-1
		if B in('IF','FOR','WHILE',E)and A._is_create and A._begin_depth>0:
			if B==E:A._in_case=_B
			return 1
		if B in('END IF','END FOR','END WHILE'):return-1
		return 0
	def process(A,stream):
		'Process the stream';D=T.Whitespace,T.Comment.Single
		for(B,C)in stream:
			if A.consume_ws and B not in D:yield sql.Statement(A.tokens);A._reset()
			A.level+=A._change_splitlevel(B,C);A.tokens.append(sql.Token(B,C))
			if A.level<=0 and B is T.Punctuation and C==';'or B is T.Keyword and C.split()[0]=='GO':A.consume_ws=_B
		if A.tokens and not all(A.is_whitespace for A in A.tokens):yield sql.Statement(A.tokens)