_B=' '
_A='\n'
from sqlparse import sql,tokens as T
class OutputFilter:
	varname_prefix=''
	def __init__(A,varname='sql'):A.varname=A.varname_prefix+varname;A.count=0
	def _process(A,stream,varname,has_nl):raise NotImplementedError
	def process(A,stmt):
		B=stmt;A.count+=1
		if A.count>1:C='{f.varname}{f.count}'.format(f=A)
		else:C=A.varname
		D=len(str(B).strip().splitlines())>1;B.tokens=A._process(B.tokens,C,D);return B
class OutputPythonFilter(OutputFilter):
	def _process(F,stream,varname,has_nl):
		D=has_nl;C=varname;B="'"
		if F.count>1:yield sql.Token(T.Whitespace,_A)
		yield sql.Token(T.Name,C);yield sql.Token(T.Whitespace,_B);yield sql.Token(T.Operator,'=');yield sql.Token(T.Whitespace,_B)
		if D:yield sql.Token(T.Operator,'(')
		yield sql.Token(T.Text,B)
		for A in stream:
			if A.is_whitespace and _A in A.value:
				yield sql.Token(T.Text," '");yield sql.Token(T.Whitespace,_A);yield sql.Token(T.Whitespace,_B*(len(C)+4));yield sql.Token(T.Text,B);E=A.value.split(_A,1)[1]
				if E:yield sql.Token(T.Whitespace,E)
				continue
			elif B in A.value:A.value=A.value.replace(B,"\\'")
			yield sql.Token(T.Text,A.value)
		yield sql.Token(T.Text,B)
		if D:yield sql.Token(T.Operator,')')
class OutputPHPFilter(OutputFilter):
	varname_prefix='$'
	def _process(E,stream,varname,has_nl):
		C=varname;B='"'
		if E.count>1:yield sql.Token(T.Whitespace,_A)
		yield sql.Token(T.Name,C);yield sql.Token(T.Whitespace,_B)
		if has_nl:yield sql.Token(T.Whitespace,_B)
		yield sql.Token(T.Operator,'=');yield sql.Token(T.Whitespace,_B);yield sql.Token(T.Text,B)
		for A in stream:
			if A.is_whitespace and _A in A.value:
				yield sql.Token(T.Text,' ";');yield sql.Token(T.Whitespace,_A);yield sql.Token(T.Name,C);yield sql.Token(T.Whitespace,_B);yield sql.Token(T.Operator,'.=');yield sql.Token(T.Whitespace,_B);yield sql.Token(T.Text,B);D=A.value.split(_A,1)[1]
				if D:yield sql.Token(T.Whitespace,D)
				continue
			elif B in A.value:A.value=A.value.replace(B,'\\"')
			yield sql.Token(T.Text,A.value)
		yield sql.Token(T.Text,B);yield sql.Token(T.Punctuation,';')